/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var serveur = get_pref_protocol() + "://" + get_pref_ipserveur() + ":" + get_pref_porttomcat();

function init() {
	try {
		var paramlist = "&Page=Compta/GetRDF/Dossier.tmpl&ContentType=xml";
    load_rdf_async('Exercice', getUrlOpeneas(paramlist), selExercice);
		
		document.getElementById('Exercice').focus();
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#init : ' + e);
  }
}

function selExercice() {
	document.getElementById('Exercice').selectedIndex = 0;
}

function envoiCompta() {
	try {
		document.getElementById('progression').collapsed = false;
		setTimeout('envoiCompta_bis()',100);
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#envoiCompta : ' + e);
  }
}

function envoiCompta_bis() {
	try {
		var type_envoi = document.getElementById('Type_Envoi').value;
		var email = document.getElementById('EMail').value;
		var message = document.getElementById('Corps').value;
		var sujet = document.getElementById('Sujet').value;
		
		if (type_envoi=='M' && !isEmail(email)) {
			alert('Adresse e-mail incorrecte !');
  		document.getElementById('progression').collapsed = true;
		}
		else {

  		var base = document.getElementById('Exercice').value;
			
			var corps = cookie() + "&Page=Export/ProcessExportOpensi.tmpl&ContentType=xml";
      corps += "&Base="+ base;
      corps += "&TypeEnvoi="+ type_envoi;
      corps += "&EMail="+ email;
      corps += "&Message="+ message;
      corps += "&Sujet="+ sujet;
      var httpRequest = new XMLHttpRequest();
      requeteHTTP(corps,httpRequest,envoiCompta_bis2,type_envoi);
    }
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#envoiCompta_bis : ' + e);
  }
}

function envoiCompta_bis2(httpRequest,type_envoi) {
	try {
  	if (httpRequest.status != "200") {
		  alert("Rception erreur " + httpRequest.status);
		}	else {
			var contenu = httpRequest.responseXML;
			var info_exp = contenu.documentElement;
			var action_error = info_exp.getAttribute('action_error');
			
			if (isEmpty(action_error)) {			
				if (type_envoi=='F') {
					window.location.href = serveur +"/OpenSI/export/"+ get_cookie('Dossier_Id') +".osi";
				} else {
					alert('Votre dossier comptable a t envoy !');
				}
			}	else {
					alert(action_error);
			}
		}
		document.getElementById('progression').collapsed = true;
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#envoiCompta_bis : ' + e);
  }
}

function displayDest(d) {
	try {
		document.getElementById('libDestinataire').collapsed = !d;
		document.getElementById('boxDestinataire').collapsed = !d;

		if (document.getElementById('Destinataire').value != '') {
			document.getElementById('libEMail').collapsed = !d;
			document.getElementById('boxEMail').collapsed = !d;
			document.getElementById('libSujet').collapsed = !d;
			document.getElementById('boxSujet').collapsed = !d;
			document.getElementById('libCorps').collapsed = !d;
			document.getElementById('boxCorps').collapsed = !d;
		}
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#displayDest : ' + e);
  }
}

function displayMail() {
	try {
		document.getElementById('libEMail').collapsed = false;
		document.getElementById('boxEMail').collapsed = false;
		document.getElementById('libSujet').collapsed = false;
		document.getElementById('boxSujet').collapsed = false;
		document.getElementById('libCorps').collapsed = false;
		document.getElementById('boxCorps').collapsed = false;

		if (document.getElementById('Destinataire').value == 'C') {
			var corps = cookie() + "&Page=Compta/GetAdresseMail.tmpl&ContentType=text";
			var p = requeteHTTP(corps);

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				document.getElementById('EMail').value = trim(p.responseText);
			}
		}
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#displayMail : ' + e);
  }
}

function retour_menu_autres() {
  try {
    var page = "chrome://opensi/content/compta/user/autres/menu_autres.xul?" + cookie() ;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#retour_menu_autres : ' + e);
  }
}

function retour_menu_principal() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie() ;
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#retour_menu_principal : ' + e);
  }
}

/*function retour_choixExercice() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_dossier.xul?" + cookie();
    page += "&Libelle=" + parent.document.getElementById("nom_dossier").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#retour_choixExercice : ' + e);
  }
}*/

/*function retour_choixDossier() {
  try {
    var page = "chrome://opensi/content/compta/user/menu.xul?" + cookie();
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/envoi_compta.js#retour_choixDossier : ' + e);
  }
}*/