/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*****************************************************
 *  @return l'id de l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree_id(){
  return 'journaux';
}

/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree(){
  try {
    return document.getElementById(get_tree_id());
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#get_tree : ' + e);
  }
}

function init() {
	try {
    var paramlist = "&Page=Compta/GetRDF/liste_journaux.tmpl&ContentType=xml&Type_Journal=TR";
    load_rdf_async('journaux', getUrlOpeneas(paramlist),init_journaux);
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#init : ' + e);
  }
}

function init_journaux(ds) {
  try {
    var tree = get_tree();
    var v = tree.view;
    if (v != null) {
      var journal = ParamValeur('Code_Journal');
      v.selection.select(0);
      if (isEmpty(journal)) {
        tree.treeBoxObject.ensureRowIsVisible(0);
      } else {
        setTimeout('selectjournal()',100); 
      }
    }
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#init_journaux : ' + e);
  }
}

function selectjournal() {
  try {
    var journal = ParamValeur('Code_Journal');
    var tree = get_tree();
    var v = tree.view;
    var index = 0;
    while (v.getCellText(v.selection.currentIndex,'code') != journal) {
      index++;
      v.selection.select(index);
    }
    tree.treeBoxObject.ensureRowIsVisible(index);
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#selectjournal : ' + e);
  }
}

function retour_menuAutres() {
  try {
    var page = "chrome://opensi/content/compta/user/autres/menu_autres.xul?" + cookie() ;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#retour_menuAutres : ' + e);
  }
}

function retour_menuPrincipal() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie() ;
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#retour_menuPrincipal : ' + e);
  }
}

function retour_choixExercice() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_dossier.xul?" + cookie();
    page += "&Libelle=" + parent.document.getElementById("nom_dossier").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#retour_choixExercice : ' + e);
  }
}

function retour_choixDossier() {
  try {
    var page = "chrome://opensi/content/compta/user/menu.xul?" + cookie();
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#retour_choixDossier : ' + e);
  }
}

function labelJournal(journal){

  try {

    var tab_journaux = document.getElementById('journaux').getElementsByTagName('menuitem');
    for (i=1;i<tab_journaux.length;i++) {
      var tab_journal = tab_journaux[i];
      if (journal.toUpperCase() == tab_journal.value.toUpperCase()) 
        return tab_journal.label;
      if (journal.toUpperCase() == tab_journal.label.toUpperCase()) 
        return tab_journal.label;
    }
    return '';

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#labelJournal : ' + e);
  }

}


function ok() {
  try {

    var v = get_tree().view;
    var journal = v.getCellText(v.selection.currentIndex,'code');

    process_import(journal);

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#ok : ' + e);
  }
}

function process_import(journal) {
  try {

    var url = "chrome://opensi/content/compta/util/upload.xul?" + cookie();
    url += "&file=" + document.getElementById('file').value;
    url += "&dir=import";
    window.openDialog(url,'upload','chrome,modal');

    var url2 = "chrome://opensi/content/compta/user/autres/importbank/traitementbank.xul?" + cookie();
    url2 += "&Fichier=" + getFileName(document.getElementById('file').value);
    url2 += "&Code_Journal=" + journal;
    
//    window.openDialog(url2,'traitement','chrome,modal');
    window.location = url2;
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/importbank.js#valider : ' + e);
  }
}