/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/user/consultation/consultation.xul>
 * @include chrome://libopensi/content/load_rdf.js
 * @include chrome://opensi/content/libs/util.js
 * @include chrome://opensi/content/libs/verif.js
 *
 */

var lettrage_en_cours = 0;
var lettre;
var debit = 0;
var credit = 0;
var solde = 0;
var dsource; // source de donnes RDF de l'arbre.
var rExp = / /gi;
var compteprec = '';
var comptesuiv = '';
var numop = '';

/*****************************************************
 *  @return l'id de l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree_id(){
  return 'lignes';
}

/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree(){
  try {
    return document.getElementById(get_tree_id());
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#get_tree : ' + e);
  }
}

/****************************************************
 *  Correspondance entre l'id d'un textbox et le target RDF associ
 *  @param id : l'identifiant du textbox
 *  @return le target associ
 ****************************************************/
function targetname(id) {
  try {
    switch(id) {
      case 'lettre':
        return "http://www.opensi.org/compta/lignes_ecriture/rdf#lettre";
        break;
      case 'input_prop':
        return "http://www.opensi.org/compta/lignes_ecriture/rdf#prop";
        break;
      default:
        return '';
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#targetName : ' + e);
  }
}

/****************************************************
 *  Chargement des critures dans l'arbre.
 *  @param dsUrl : l'URL de la source de donnes RDF.
 ****************************************************/
function load_tree(dsUrl) {

  try {

    // initialise la source de donnes de l'arbre.
    dsource = new RDFDataSource(); 
    
    // Gnre une source de donnes  partir de l'URL dfinie en paramtres,
    // et appelle la fonction init_tree() une fois la source charge.
    load_rdf_async(get_tree_id(), dsUrl, init_tree);   
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#load_tree' + e);
  }
  
}

/****************************************************
 *  Chargement de l'arbre depuis la source.
 *  @param dsource2 : la source du RDF
 ****************************************************/
function init_tree(dsource2){

  try {
    
    dsource.deleteRecursive("http://www.opensi.org/compta/lignes_ecriture");
    var datasource = dsource.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource);
    
    dsource2.copyAllToDataSource(dsource);

    var datasource2 = dsource2.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource2);
    var datasource = dsource.getRawDataSource();
    get_tree().database.AddDataSource(datasource);

    setTimeout('focus_tree()',100);
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#init_tree : ' + e);
  }

}

function delete_tree() {
  try {
    dsource.deleteRecursive("http://www.opensi.org/compta/lignes_ecriture");
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#delete_tree : ' + e);
  }
}

function reinit(){
  try {
    delete_tree();
    var nonlet = '0';
    if (document.getElementById('nonlet').checked) {
      nonlet = '1';
    }
    var let = '0';
    if (document.getElementById('let').checked) {
      let = '1';
    }
    var paramlist = "&Page=Compta/GetRDF/Consultation.tmpl&ContentType=xml";
    paramlist += "&NumCompte=" + ParamValeur('NumCompte');
    paramlist += "&let=" + let;
    paramlist += "&nonlet=" + nonlet;
    load_tree(getUrlOpeneas(paramlist));
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#reinit : ' + e);
  }
}

function init(){
  try {
    var paramlist = "&Page=Compta/GetRDF/Consultation.tmpl&ContentType=xml";
    paramlist += "&NumCompte=" + ParamValeur('NumCompte');
    paramlist += "&let=" + ParamValeur('let');
    paramlist += "&nonlet=1";
    load_tree(getUrlOpeneas(paramlist));
    numop = ParamValeur('numop');
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#init : ' + e);
  }
}

function focus_tree(){
  
  try {
  
    var v = get_tree();
    if (v.view == null) {
//      alert("Ce compte n'a aucune criture dans la priode donne.");
    } else {
      var lignefocus = 0;
      if (!isEmpty(numop)) {
        var vue = v.view;
        var found = false;
        while (! found) {
          if ((! vue.isSeparator(lignefocus)) && (vue.getCellText(lignefocus,'opid') == numop)) {
            found = true;
          } else {
            lignefocus++;
          }
        }
        numop = '';
      }
      v.view.selection.select(lignefocus);
      v.treeBoxObject.ensureRowIsVisible(lignefocus);
      lettre = get_cookie('Lettre');
      v.focus();
    }
    
    var compte = ParamValeur('NumCompte');
        
    var paramlist = cookie() + "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    paramlist += "&Numero_Compte=" + compte;

    var httpRequest = new XMLHttpRequest();
    requeteHTTP(paramlist,httpRequest,focusTree2);

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#focus_tree : ' + e);
  }    
    
}

function focusTree2(httpRequest){
  
  try {

    if (httpRequest.status == "0") return false;

    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
    } else {
      var contenu=httpRequest.responseXML;
      var session = contenu.documentElement;
      if (session.getElementsByTagName('numero').length  == 0 ) {
      } else {
        var num = session.getElementsByTagName('numero')[0];
        parent.document.getElementById('compte').value = num.firstChild.data;
        var l = session.getElementsByTagName('libelle')[0];
        document.getElementById('libelle_compte').value = l.firstChild.data;
        var l = session.getElementsByTagName('gen')[0];
        document.getElementById('type_compte').value = l.firstChild.data;
        var s = session.getElementsByTagName('solde')[0];
        var d = session.getElementsByTagName('debit')[0]; 
        var c = session.getElementsByTagName('credit')[0];
        document.getElementById('solde_compte').value = s.firstChild.data;
        document.getElementById('debit_compte').value = d.firstChild.data;
        document.getElementById('credit_compte').value = c.firstChild.data;
        var os = session.getElementsByTagName('old_solde')[0];
        var od = session.getElementsByTagName('old_debit')[0]; 
        var oc = session.getElementsByTagName('old_credit')[0];
        document.getElementById('old_solde_compte').value = os.firstChild.data;
        document.getElementById('old_debit_compte').value = od.firstChild.data;
        document.getElementById('old_credit_compte').value = oc.firstChild.data;
        var cp = session.getElementsByTagName('prec')[0];
        var cs = session.getElementsByTagName('suiv')[0];
        compteprec = cp.firstChild.data;
        comptesuiv = cs.firstChild.data;
        document.getElementById('compteprec').value = compteprec;
        document.getElementById('comptesuiv').value = comptesuiv;
        parent.document.getElementById('boutonPrec').disabled = (compteprec == '-');
        parent.document.getElementById('boutonSuiv').disabled = (comptesuiv == '-');
        parent.document.getElementById('boutonDebut').disabled = false;
        parent.document.getElementById('boutonFin').disabled = false;
      }

    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#focusTree2 : ' + e);
  }    
    
}

function keypress(e) {
  try {
    switch(e.keyCode){
      case 13: // 'Enter'
        ecritures();
        break;
      case 32: // Barre d'Espace
        lettrage();
        break;
      case 118 : // 'F7'
        validLettrage();
        break;
      case 119 : // 'F8'
        annulLettrage();
        break;
      case 123: // 'F12'
        rechecr(0);
        break;
/*
      default:
        alert(e.keyCode);
        break;
*/
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#keypress : ' + e);
  }
}
                   
function lettresuivante(l){
  
  try {
  
    if (l.length == 1) {
      if (l=='z' || l =='Z') {
        return 'A';
      } else {
        return String.fromCharCode(l.charCodeAt(0)+1);
      }
    } else {
      var c = l.substr(l.length-1,1);
      var aux = l.substr(0,l.length-1);
      if (c=='z' || c=='Z') {
        c = 'A';
        aux = lettresuivante(aux);
      } else {
        c = String.fromCharCode(c.charCodeAt(0)+1);
      }
      return aux + c;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#lettresuivante : ' + e);
  }

}

function incr_lettre() {
  try {
    if (isEmpty(lettre)) {
      lettre = 'AAA';
    } else {
      lettre = lettresuivante(lettre);
    }
    return lettre;
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#incr_lettre : ' + e);
  }
}

function lettrage() {

  try {

    var v = get_tree().view;
    
    var aux = v.getCellText(v.selection.currentIndex,'debit');
    var aux2 = '';
    for (i = 0;i<aux.length;i++) {
      var c = aux.charCodeAt(i);
      if ((c != 160) && (c != 32)) aux2 += aux.charAt(i);
    }
    var td = parseFloat(aux2.replace(',','.'));
    if (isNaN(td)) td = 0;

    aux = v.getCellText(v.selection.currentIndex,'credit');
    aux2 = '';
    for (i = 0;i<aux.length;i++) {
      var c = aux.charCodeAt(i);
      if ((c != 160) && (c != 32)) aux2 += aux.charAt(i);
    }
    var tc = parseFloat(aux2.replace(',','.'));
    if (isNaN(tc)) tc = 0;

    var tl = v.getCellText(v.selection.currentIndex,'lettre');

    var child = get_child(get_tree().currentIndex);

    if (premier_exo_ouvert()) {    
      if (isEmpty(tl)) {
        debit = debit + td;
        credit = credit + tc;
        solde =  parseFloat(format(credit - debit,2,'',0)); 
        maj_aff_solde();
        child.addTargetOnce(targetname('lettre'),'+');
        lettrage_en_cours++;
      } else if (tl == '+') {
        child.addTargetOnce(targetname('lettre'),'');
        debit = debit - td;
        credit = credit - tc;
        solde = parseFloat(format(credit - debit,2,'',0));
        lettrage_en_cours--;
        if (lettrage_en_cours == 0) {
          document.getElementById('lettrage').collapsed = true;
        } else {
          maj_aff_solde();
        } 
      }
    }    

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#lettrage : ' + e);
  }
  
}

function annulLettrage(){

  try {

    if (get_cookie('Writeable') > '0') {

      var v = get_tree().view;
      var tl = v.getCellText(v.selection.currentIndex,'lettre');
    
      if (isEmpty(tl)) return -1;
      if (tl == '+') return -1;

      if (confirm("Voulez vous annuler le lettrage des lignes d'critures lettres par " + tl + " ?")) {

        var corps = '&Page=Compta/UpdateDatabase/update.tmpl&ContentType=none&req=annullettrage&';
        corps += cookie();
        var list_op = '';
        var v = get_tree().view;
        for (i=0;i<v.rowCount;i++) {
          var tl2 = v.getCellText(i,'lettre');
          if (tl == tl2) {
            if (list_op != '') {
              list_op += ',';
            }
            var opid = v.getCellText(i,'opid');
            list_op += opid;
            var child = get_child(i);
            child.addTargetOnce(targetname('lettre'),'');
            child.addTargetOnce(targetname('input_prop'),'disabled');
          }
        }
        corps += '&Operations=' + list_op;
        var httpRequest = new XMLHttpRequest();
        requeteHTTP(corps,httpRequest,nope);
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#annulLettrage : ' + e);
  }

}

function get_child(id) {

  try {
  
    var child = null;
    var index = id + 1;
    var root = dsource.getNode("http://www.opensi.org/compta/lignes_ecriture");
    var children = root.getChildren();
    var found = false;

    while ((children.hasMoreElements()) && (! found) ) {
      var c = children.getNext();
      if (root.getChildIndex(c) == index) {
        child = c;
        found = true;
      }
    }
    
    return child;

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#lettrage : ' + e);
  }
  
}

function maj_aff_solde() {
  try {
    document.getElementById('lettrage').collapsed = false;
    document.getElementById('total_debit_lett').value = format(debit,2,' ',0);
    document.getElementById('total_credit_lett').value = format(credit,2,' ',0);
    document.getElementById('total_solde_lett').value = format(solde,2,' ',0);
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#maj_aff_solde : ' + e);
  }
}

function razLettrage() {
  try {
    debit = 0;
    credit = 0;
    solde = 0;
    lettrage_en_cours = 0;
    document.getElementById('lettrage').collapsed = true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#razLettrage : ' + e);
  }
}

function lettrer(ll) {

  try {
    if (lettrage_en_cours>0) {
      var corps = '&Page=Compta/UpdateDatabase/update.tmpl&ContentType=none&req=lettrage&';
      corps += cookie();
      corps += '&Num_Compte=' + ParamValeur('NumCompte');
      corps += '&Lettre=' + ll;
      var list_op = '';
      var v = get_tree().view;
      for (i=0;i<v.rowCount;i++) {
        var tl = v.getCellText(i,'lettre');
        if (tl == '+') {
          if (list_op != '') {
            list_op += ',';
          }
          var opid = v.getCellText(i,'opid');
          list_op += opid;
          var child = get_child(i);
          child.addTargetOnce(targetname('lettre'),ll);
          child.addTargetOnce(targetname('input_prop'),'enabled');
        }
      }
      corps += '&Operations=' + list_op;
      var httpRequest = new XMLHttpRequest();
      requeteHTTP(corps);
      razLettrage();

    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#lettrer : ' + e);
  }    
    
}

function validLettrage() {

  try {

    if (get_cookie('Writeable') > '0') {

      if (solde == 0) {
        lettrer(incr_lettre());
      } else if (confirm("Le lettrage n'est pas quilibr. Voulez vous saisir une criture de lettrage ?")) {
        var ll = incr_lettre();
        var nom = "ecr_lettrage" ;
        var page = "chrome://opensi/content/compta/user/consultation/lettrage.xul?" + cookie() ;
        page += "&NumCompte=" + ParamValeur('NumCompte');
        page += "&Lettre=" + ll;
        page += "&solde=" + (0 - solde);
        window.open(page,nom,'chrome,modal');      
        delete_tree();
        init();
        razLettrage();
      } 

    }    

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#validLettrage : ' + e);
  }    

}

function ecritures() {
  
  try {

    if (isEmpty(ParamValeur('popup'))) {
    
      var v = get_tree().view;
      var journal = v.getCellText(v.selection.currentIndex,'journal');
      var date = v.getCellText(v.selection.currentIndex,'date');

      var annee = date.substr(6,4);
      var mois = date.substr(3,2);
      var aux = parseIntBis(annee)*12;
      aux += parseIntBis(mois);
      var periode = mois + date.substr(8,2);
    
      if (aux < parseIntBis(get_cookie('Premier_Mois_Exercice'))) {
        var date_debut = get_cookie('Date_Debut_Exercice');
        periode = date_debut.substr(3,2) + date_debut.substr(8,2);
      }

      var nom = "saisie" ;
      var paramlist = cookie();
      paramlist += "&Code_Journal=" + journal;
      paramlist += "&Periode=" + periode;
      paramlist += "&numop=" + v.getCellText(v.selection.currentIndex,'opid');
      var page = "chrome://opensi/content/compta/user/saisie/menu_saisie.xul?" + paramlist ;
      window.parent.location = page;
//      var x = screen.width * 0.1 ;
//      var y = screen.height * 0.1 ;
//      var w = screen.width * 0.9;
//      var h = screen.height * 0.9;
//      var param = 'chrome,modal,screenX=' + x + ',screenY=' + y + ',width=' + w + ',height=' + h;
//      window.open(page,nom,param);
//      delete_tree();
//      init();
//      razLettrage();
      
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#ecritures : ' + e);
  }    

}