/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/consultation/menu_consultation.xul>
 * @include chrome://libopensi/content/load_rdf.js
 * @include chrome://opensi/content/libs/verif.js
 * @include chrome://opensi/content/util.js
 *
 */
var force = false;
var numop = '';

function init(){
  try {
    var compte = ParamValeur('compte'); 
    var prec = ParamValeur('prec'); 
    var nomprec = ParamValeur('nomprec'); 
    numop = ParamValeur('numop');

    var boutonDebut = document.getElementById('boutonDebut');
    var boutonFin = document.getElementById('boutonFin');
    var boutonPrec = document.getElementById('boutonPrec');
    var boutonSuiv = document.getElementById('boutonSuiv');
    boutonDebut.label="<<";
    boutonFin.label=">>";
    boutonPrec.label="<";
    boutonSuiv.label=">";

    if (isEmpty(compte)) {
      document.getElementById('compte').focus();
    } else {
      document.getElementById('compte').value = compte;
      ok();
    }
		
    if (!isEmpty(nomprec)) {
      document.getElementById('bRetour'+ nomprec).collapsed = false;
    }
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#init : ' + e);
  }
}

function retour_prec() {
  try {
    var page = ParamValeur('prec');
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#retour_prec : ' + e);
  }
}


function retour_consultation() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie() ;
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#retour_consultation : ');
  }
}

function retour_exercice() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_dossier.xul?" + cookie();
    page += "&Libelle=" + parent.document.getElementById("nom_dossier").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#retour_exercice : ' 
                  + e);
  }
}

function keypress(e){
  try {
    switch (e.keyCode) {
      case 13:
        ok();
        break;
      case 123: // 'F12'
        rechecr(1);
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#keypress : ' + e);
  }
}

function ok() {

  try {

    var inputcompte = document.getElementById('compte');
    if (isEmpty(inputcompte.value)) {
      inputcompte.focus();
      return false;
    }
    force = false;

    var compte = inputcompte.value;
    var paramlist = cookie() + "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    paramlist += "&Numero_Compte=" + compte;
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(paramlist,httpRequest,ok2,inputcompte);

  } catch(e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#ok : ' + e);
  }

}

function ok2(httpRequest,inputcompte) {
  try {
    if (httpRequest.status == "0") return false;
    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
    } else {
      var contenu=httpRequest.responseXML;
      var session = contenu.documentElement;
      var comptes = session.getElementsByTagName('numero');
      if (comptes.length  != 1 ) {
        recherche_compte(inputcompte);
        inputcompte.focus();
      } else {
        var compte = comptes.item(0).firstChild.nodeValue;
        inputcompte.value = compte;
      }
    }
    loadCompte(inputcompte.value);
  } catch(e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#ok2 : ' + e);
  }
}

function loadCompte(compte) {
  try {
    var let = ParamValeur('let');
    if (isEmpty(let)) {
      let = '0';
    }
    var page = "chrome://opensi/content/compta/user/consultation/consultation.xul?" + cookie() ;
    page += "&NumCompte=" + compte;
    page += "&let=" + let;
    page += "&numop=" + numop;
    page += "&nonlet=1";
    page += "&popup=";
    document.getElementById("consultation").setAttribute("src",page);
    numop = '';
    setTimeout('focus_consultation()',100);
  } catch(e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#loadCompte : ' + e);
  }
}

function compteSuiv() {
  try {
    var comptesuiv = document.getElementById('consultation').contentDocument.getElementById('comptesuiv').value;
    document.getElementById('compte').value = comptesuiv;
    ok();
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#compteSuiv : ' + e);
  }
}

function comptePrec() {
  try {
    var compteprec = document.getElementById('consultation').contentDocument.getElementById('compteprec').value;
    document.getElementById('compte').value = compteprec;
    ok();
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#compteSuiv : ' + e);
  }
}

function compteDebut() {
  try {
    loadCompte('premier');
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#compteDebut : ' + e);
  }
}

function compteFin() {
  try {
    loadCompte('dernier');
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#compteFin : ' + e);
  }
}


function focus_consultation() {
  document.getElementById("consultation").focus();
}

/****************************************************
 *  Effectue une recherche de compte
 *  @param t la zone de saisie  affecter.
 ****************************************************/
function recherche_compte(t){
  try {
    var compte = t.value;
    var id = t.id
    var url = "chrome://opensi/content/compta/util/rechcompte.xul?" + cookie();
    window.openDialog(url,'rechcompte','chrome,modal',compte,id,false);
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#recherche_compte : '
                 + e);
  }
}