/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

 
function init() {
  try {
    
		if (ParamValeur("Type")=="Fournisseurs") {
			document.getElementById('Type').selectedItem = document.getElementById('TypeF');
		}
		else {
			document.getElementById('Type').selectedItem = document.getElementById('TypeC');
		}
		document.getElementById('Periode').selectedItem = document.getElementById('PeriodeEC');
		document.getElementById('Tri').selectedItem = document.getElementById('TriN');
		document.getElementById('Sortie').selectedItem = document.getElementById('SortieP');
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_balanceagee.js#init : ' + e);
  }
}

function cacheChampsMail(b) {
	try {
		document.getElementById('ChampsMail').collapsed = b;
		
		if (b) {
			document.getElementById('BoutonEdition').label = "EDITER LA BALANCE AGEE";
		}
		else {
			document.getElementById('BoutonEdition').label = "ENVOYER LA BALANCE AGEE";
		}
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_balanceagee.js#cacheChampsMail : ' + e);
  }
}

function disableDates(b) {
	try {

		document.getElementById('Date_Fin').disabled = b;
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_balanceagee.js#disableDates : ' + e);
  }
}


function retour_menu_principal() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie();
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_balanceagee.js#retour_menu_principal : ' + e);
  }
}

function retour_menu_edition() {
  try {
    var page = "chrome://opensi/content/compta/user/edition/menu_edition.xul?" + cookie();
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_balanceagee.js#retour_menu_edition : ' + e);
  }
}

function updateTranche() {
	
	var tranche1 = document.getElementById('Tranche1').value;
	var tranche2 = document.getElementById('Tranche2').value;
	var tranche3 = document.getElementById('Tranche3').value;
	var tranche4 = document.getElementById('Tranche4').value;


	if (isEmpty(tranche1) || !isPositiveOrNull(tranche1)) {
		alert('Tranche 1 invalide !');
		document.getElementById('Tranche1').value = '';
		return false;
	}
	else if (isEmpty(tranche2) || !isPositiveOrNull(tranche2)) {
		alert('Tranche 2 invalide !');
		document.getElementById('Tranche2').value = '';
		return false;
	}
	else if (isEmpty(tranche3) || !isPositiveOrNull(tranche3)) {
		alert('Tranche 3 invalide !');
		document.getElementById('Tranche3').value = '';
		return false;
	}
	else if (isEmpty(tranche4) || !isPositiveOrNull(tranche4)) {
		alert('Tranche 4 invalide !');
		document.getElementById('Tranche4').value = '';
		return false;
	}
	else if (!(parseIntBis(tranche1) <= parseIntBis(tranche2) && parseIntBis(tranche2) <= parseIntBis(tranche3) && parseIntBis(tranche3) <= parseIntBis(tranche4))) {
		alert('Tranches incohrentes !');
		return false;
	}
	else {
		document.getElementById('Label2').value = "de "+ tranche1 +" ";
		document.getElementById('Label3').value = "de "+ tranche2 +" ";
		document.getElementById('Label4').value = "de "+ tranche3 +" ";
		document.getElementById('Label5').value = tranche4 +" jours";
		return true;
	}

}

function editerBalanceAgee() {
	try {
	
		var date_fin = document.getElementById('Date_Fin').value;
	
		if (document.getElementById('PeriodeDD').selected && !isDate(date_fin)) {
			showMessage("Date de fin invalide !");
		}
		else if(updateTranche()) {
			var liste_options = "&Date_Fin="+ date_fin;
			liste_options += "&Type="+ document.getElementById('Type').value;
			liste_options += "&Tri=" + document.getElementById('Tri').value;
			liste_options += "&Periode="+ document.getElementById('Periode').value;
			liste_options += "&Tranche1="+ document.getElementById('Tranche1').value;
			liste_options += "&Tranche2="+ document.getElementById('Tranche2').value;
			liste_options += "&Tranche3="+ document.getElementById('Tranche3').value;
			liste_options += "&Tranche4="+ document.getElementById('Tranche4').value;
		
			var sortie = document.getElementById('Sortie').value;
		
			if (sortie=="M") {
			
				var email = document.getElementById('Email').value;
				var sujet = document.getElementById('Sujet').value;
				var message = document.getElementById('Message').value;
			
				if (!isEmail(email)) {
					showMessage("Adresse e-mail incorrecte !");
				}
				else {
					var corps = cookie() + "&Page=Compta/Etats/balanceagee_pdf.tmpl&ContentType=Text&EnvoiMail=y";
          corps += liste_options+"&Email="+urlEncode(email)+"&Sujet="+urlEncode(sujet)+"&Message="+urlEncode(message);
          var httpRequest = new XMLHttpRequest();
          requeteHTTP(corps,httpRequest,suiteEditer);
				}
			}
			else {
				var page = "chrome://opensi/content/compta/user/edition/afficher_balanceagee.xul?" + cookie() + "&ListeOptions="+ urlEncode(liste_options);
				window.location = page;
			}
		}

	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_balanceagee.js#editerbalanceagee : ' + e);
  }
}

function suiteEditer(httpRequest) {
  try {
    if (httpRequest.status != "200") {
      alert("Rception erreur " + httpRequest.status);
    } else {
      alert("La balance age a t envoye !");
    }
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_balanceagee.js#suiteEditer : ' + e);
  }    
}

/*function retour_exercice() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_dossier.xul?" + cookie();
    page += "&Libelle=" + parent.document.getElementById("nom_dossier").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_balanceagee.js#retour_exercice : ' + e);
  }
}*/
