/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/user/saisie/saisie.xul>
 * @include chrome://libopensi/content/load_rdf.js
 * @include chrome://opensi/content/libs/verif.js
 * @include chrome://opensi/content/libs/util.js
 *
 */

//var CONST_NB_HTTPREQUEST = 100;u

//var httpRequest = new Array(CONST_NB_HTTPREQUEST);
//var httpRequest = new Array();
//var id_httpRequest = 0;

var force = false;
var rExp = / /gi;
var rExpVirg = /,/gi;
 
var focus_input = ''; // id du textbox ayant le focus.

var dsource; // source de donnes RDF de l'arbre.

var nb_ecritures = 0; // nombre d'critures
var ecritures; // la liste des critures du journal de saisie courant.

var debut_periode = 0;

var modif_solde = false;
var id_select = -1;

var writeable = true; // indique si l'exercice en cours est ditable ou non.
var isrech = false;

var page = 0;
var nb_pages = 0;
var numop = '';

var anc_value;

var page_chargee = true;

function pgload() {
  try {
    return document.getElementById("pgload");
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pgload : ' + e);
  }
}

/*****************************************************
 *  @return l'id de l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree_id(){
  return 'tree_ecritures';
}

/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree(){
  try {
    return document.getElementById(get_tree_id());
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_tree : ' + e);
  }
}

function get_root() {
  try {
    return dsource.getNode("http://www.opensi.org/compta/operations");
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_root : ' + e);
  }
}

/****************************************************
 *  Correspondance entre l'id d'un textbox et le target RDF associ
 *  @param id : l'identifiant du textbox
 *  @return le target associ
 ****************************************************/
function targetname(id) {
  
  try {
  
    switch(id) {
      case 'input_date':
        return "http://www.opensi.org/compta/operations/rdf#date";
        break;
      case 'input_compte':
        return "http://www.opensi.org/compta/operations/rdf#compte";
        break;
      case 'input_type':
        return "http://www.opensi.org/compta/operations/rdf#type";
        break;
      case 'input_raccourci':
        return "http://www.opensi.org/compta/operations/rdf#raccourci";
        break;
      case 'input_libelle':
        return "http://www.opensi.org/compta/operations/rdf#libelle";
        break;
      case 'input_contrepartie':
        return "http://www.opensi.org/compta/operations/rdf#contrepartie";
        break;
      case 'input_echeance':
        return "http://www.opensi.org/compta/operations/rdf#echeance";
        break;
      case 'input_piece':
        return "http://www.opensi.org/compta/operations/rdf#piece";
        break;
      case 'input_debit':
        return "http://www.opensi.org/compta/operations/rdf#debit";
        break;
      case 'input_credit':
        return "http://www.opensi.org/compta/operations/rdf#credit";
        break;   
      case 'tot_debit':
        return "http://www.opensi.org/compta/operations/rdf#tot_debit";
        break;
      case 'tot_credit':
        return "http://www.opensi.org/compta/operations/rdf#tot_credit";
        break;   
      case 'delta_debit':
        return "http://www.opensi.org/compta/operations/rdf#delta_debit";
        break;
      case 'delta_credit':
        return "http://www.opensi.org/compta/operations/rdf#delta_credit";
        break;   
      case 'num_ecriture':
        return "http://www.opensi.org/compta/operations/rdf#num_ecriture";
        break;   
      case 'ecrid':
        return "http://www.opensi.org/compta/operations/rdf#ecrid";
        break;   
      case 'opid':
        return "http://www.opensi.org/compta/operations/rdf#opid";
        break;   
      case 'nouv':
        return "http://www.opensi.org/compta/operations/rdf#nouv";
        break;  
      case 'type_desc':
        return "http://www.opensi.org/compta/operations/rdf#type_desc";
        break;
      default:
        return '';
    }
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#targetname : ' + e);
  }

}


/****************************************************
 *  @return le nombre de jours dans le mois correspondant  la saisie
 ****************************************************/
function nb_jours_periode() {
  try {
    var p = ParamValeur('Periode');
    var mois = parseIntBis(p.substr(0,2));
    var annee = parseIntBis(p.substr(2,2));
    return nb_jours(mois,annee);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#nb_jours_periode : ' + e);
  }
}
  
/****************************************************
 * Rcupre le nombre d'critures sur la base
 ****************************************************/
function get_nb_pages(){

  try {

    var corps = cookie() + "&Page=Compta/GetNbEcritures.tmpl&ContentType=xml";
    corps += "&Periode=" + ParamValeur('Periode');
    corps += "&Code_Journal=" +  ParamValeur('Code_Journal');
    
    var p = requeteHTTP(corps);

    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
      return '';
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      var nbecr =  session.getAttribute('nb');
      return parseInt(nbecr/10+1);
    }
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_nb_pages : ' + e);
  }

}
  
/****************************************************
 *  Initialisation des critures.
 ****************************************************/
function init() {

  try {

    isrech =  (ParamValeur('rech') == 'true');
    

    document.getElementById('nom_dossier').value = parent.parent.document.getElementById("nom_dossier").value;
    document.getElementById('date_exercice').value = parent.parent.document.getElementById("date_exercice").value;

    var boutonDebut = document.getElementById('boutonDebut');
    var boutonFin = document.getElementById('boutonFin');
    var boutonPrec = document.getElementById('boutonPrec');
    var boutonSuiv = document.getElementById('boutonSuiv');

    document.getElementById('input_box').collapsed = true;

    modif_solde = false;
    var paramlist = '';

    if (isrech) {

      page_chargee = true;
      document.getElementById('totaux').collapsed = true;
      document.getElementById('close').collapsed = false;
      
      boutonDebut.collapsed="true";
      boutonFin.collapsed="true";
      boutonPrec.collapsed="true";
      boutonSuiv.collapsed="true";

      writeable = false;
      document.getElementById('periodebox').collapsed = true;
      var x = screen.width * 0.1 ;
      var y = screen.height * 0.1 ;
      var w = screen.width * 0.8 ;
      var h = screen.height * 0.8 ;
      window.resizeTo(w,h);
      window.moveTo(x,y);
      paramlist = "&Page=Compta/GetRDF/Operations.tmpl&ContentType=xml";
      var compte = ParamValeur('compte');
      if (! isEmpty(compte)) paramlist += "&compte=" + compte;
      var debit = ParamValeur('debit');
      if (! isEmpty(debit)) paramlist += "&debit=" + debit;
      var debitinf = ParamValeur('debitinf');
      if (! isEmpty(debitinf)) paramlist += "&debitinf=" + debitinf;
      var debitsup = ParamValeur('debitsup');
      if (! isEmpty(debitsup)) paramlist += "&debitsup=" + debitsup;
      var credit = ParamValeur('credit');
      if (! isEmpty(credit)) paramlist += "&credit=" + credit;
      var creditinf = ParamValeur('creditinf');
      if (! isEmpty(creditinf)) paramlist += "&creditinf=" + creditinf;
      var creditsup = ParamValeur('creditsup');
      if (! isEmpty(creditsup)) paramlist += "&creditsup=" + creditsup;
      var date = ParamValeur('date');
      if (! isEmpty(date)) paramlist += "&date=" + date;
      var dateinf = ParamValeur('dateinf');
      if (! isEmpty(dateinf)) paramlist += "&dateinf=" + dateinf;
      var datesup = ParamValeur('datesup');
      if (! isEmpty(datesup)) paramlist += "&datesup=" + datesup;
      var libelle = ParamValeur('libelle');
      if (! isEmpty(libelle)) paramlist += "&libelle=" + libelle;
      var piece = ParamValeur('piece');
      if (! isEmpty(piece)) paramlist += "&piece=" + piece;
      var journal = ParamValeur('journal');
      if (! isEmpty(journal)) paramlist += "&journal=" + journal;
      document.getElementById('date').flex = 10;
      load_tree(getUrlOpeneas(paramlist)); 
      
    } else {

      nb_pages = get_nb_pages();
      var page_courante = ParamValeur('page');
      if (isEmpty(page_courante)) {
        page = nb_pages;
      } else {
        page = parseInt(page_courante);
      }
            
      if (ParamValeur('Type_Journal')=='TR') {
        document.getElementById('recupbq').collapsed = false;
      }
    
      boutonDebut.label="<<";
      boutonFin.label=">>";
      boutonPrec.label="<";
      boutonSuiv.label=">";

      boutonDebut.disabled = (page == 1);
      boutonPrec.disabled = (page == 1);
      boutonFin.disabled = (page == nb_pages);
      boutonSuiv.disabled = (page == nb_pages);
    
      writeable = ((get_cookie('Writeable') == '1') && (ParamValeur('Type_Journal')!='AN'));
      var periode = ParamValeur('Periode');
      var mois = get_mois(periode.substr(0,2));
      var annee = '20' + periode.substr(2,2);
      document.getElementById('periode').value = mois + ' ' + annee;

      numop = ParamValeur('numop');
      if (isEmpty(numop)) {
        pageFin();
      } else {
        pageNumOp(numop);
      }
    }
      
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#init : ' + e);
  }

}

function fininit(ds) {
  try {
    numop = ParamValeur('numop');    
    if (isEmpty(numop)) {
      pageFin();
    } else {
      pageNumOp(numop);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#fininit : ' + e);
  }
}

/****************************************************
 *  Supprime le contenu de l'arbre.
 ****************************************************/
function delete_tree() {
  try {
    if (dsource != null) {
      dsource.deleteRecursive(get_root());
      dsource.deleteRecursive(ecritures);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#delete_tree : ' + e);
  }
}

/****************************************************
 *  Chargement des critures dans l'arbre.
 *  @param dsUrl : l'URL de la source de donnes RDF.
 ****************************************************/
function load_tree(dsUrl) {

  try {

//    pgload().value = 10;
    pgload().collapsed = false;

    // initialise la source de donnes de l'arbre.
    dsource = new RDFDataSource(); 
    
    // Gnre une source de donnes  partir de l'URL dfinie en paramtres,
    // et appelle la fonction init_tree() une fois la source charge.
    load_rdf_async(get_tree_id(), dsUrl, init_tree);   
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#load_tree' + e);
  }
  
}

function get_child(id) {

  try {
  
    var child = null;

    var index = id + 1;
    var root = get_root();
    var children = root.getChildren();
    var found = false;

    while ((children.hasMoreElements()) && (! found) ) {
      var c = children.getNext();
      if (root.getChildIndex(c) == index) {
        child = c;
        found = true;
      }
    }

    return child;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_child : ' + e);
  }
  
}

/****************************************************
 *  Chargement de l'arbre depuis la source.
 *  @param dsource2 : la source du RDF
 ****************************************************/
function init_tree(dsource2){

  try {
    
//    pgload().value = 90;
    
    dsource.deleteRecursive("http://www.opensi.org/compta/operations");
    dsource.deleteRecursive("http://www.opensi.org/compta/ecritures");
    var datasource = dsource.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource);

    dsource2.copyAllToDataSource(dsource);

    var datasource2 = dsource2.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource2);
    var datasource = dsource.getRawDataSource();
    get_tree().database.AddDataSource(datasource);

    focus_input = "input_date";

    debut_periode = parseIntBis(get_cookie('Debut_Periode'));
    
    ecritures = dsource.getNode("http://www.opensi.org/compta/ecritures");
    ecritures.makeBag();
    setTimeout('init_ecritures()',100); 
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#init_tree' + e);
  }

}

/****************************************************
 *  Initialise le conteneur d'objets Ecritures
 *  @return le nombre d'critures du journal 
 *          (en comptant la nouvelle criture en fin de saisie)
 ****************************************************/
function init_ecritures(){
  
  try {
  
    var nb_ecr = 0;
  
    var root = get_root();
    var children = root.getChildren();
    while (children.hasMoreElements()) {
      var child = children.getNext();
      var id = root.getChildIndex(child) - 1;
      var aux = get_tree().view.getCellText(id,'ecrid');
      var num_ecr = parseIntBis(aux);
      if (isEmpty(aux) || isNaN(num_ecr)) num_ecr = -1;
      if (num_ecr > nb_ecr) nb_ecr = num_ecr;
      if (num_ecr > -1) {
        var uri = "http://www.opensi.org/compta/ecritures/" + num_ecr;
        var ecriture = dsource.getNode(uri);
        ecriture.makeBag();   
        ecriture.addChild(child);
        ecritures.addChild(ecriture);
      }
    }
    
    nb_ecritures = nb_ecr + 1;

    if (writeable && (page == nb_pages)) {

      var child = dsource.getAnonymousNode();
      root.addChild(child);
      child.addTargetOnce(targetname('ecrid'), '' + nb_ecritures);
      child.addTargetOnce(targetname('opid'),'0');
      child.addTargetOnce(targetname('nouv'),'true');

//      pgload().value = 95;

      var uri = "http://www.opensi.org/compta/ecritures/" + nb_ecritures;
      var ecriture = dsource.getNode(uri);
      ecriture.makeBag();   
      ecriture.addChild(child);
      ecritures.addChild(ecriture);

    } else {
//      nb_ecritures = nb_ecr;
//      pgload().value = 95;
    }

    setTimeout('focus_saisie()',100);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#init_ecritures : ' + e);
  }
  
}

/****************************************************
 *  Sletionne la dernire ligne de l'arbre et 
 *  met le focus sur la ligne de saisie.
 ****************************************************/
function focus_saisie(){

  try {
    
//    pgload().value = 100;

    if (writeable) {
      document.getElementById('input_box').collapsed = false;
      document.getElementById("input_compte").focus();
      document.getElementById("input_contrepartie").focus();
      document.getElementById("input_type").focus();
      document.getElementById("input_raccourci").focus();
      document.getElementById("input_libelle").focus();
      document.getElementById("input_debit").focus();
      document.getElementById("input_credit").focus();
      document.getElementById("input_echeance").focus();
      document.getElementById("input_piece").focus();
      focus_input = "input_date";
      document.getElementById(focus_input).focus();
    } else {
      document.getElementById('input_box').collapsed = true;
      get_tree().focus();
    } 
    
    if (isEmpty(numop)) {
    if (writeable && page == nb_pages) {
        select_end();
      } else if (get_tree().view != null) {
        select_begin();
      }
    } else {
      select_op(numop);
      numop = '';
    }

    page_chargee = true;
    pgload().collapsed = true;
  
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_saisie : ' + e);
  }
  
}

function select_op(numop) {
  
  try {

    var index = 0;
    var v = get_tree().view;
    var found = false;
    while (! found) {
      if ((! v.isSeparator(index)) && (v.getCellText(index,'numop') == numop)) {
        found = true;
      } else {
        index++;
      }
    }
    select_row(index);
  
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_op : ' + e);
  }

}

/****************************************************
 *  Affecte aux zones de saisie les valeurs correspondant
 *   la ligne slectionne de l'arbre.
 ****************************************************/
function reporter() {
  
  try {
        
    if (page_chargee) {
      if (id_select == -1) {
        do_reporter();
      } else {
        var v = get_tree().view;
        var id = v.selection.currentIndex ;
        if (id == -1) {
          select_row(id_select);
        } else if (v.isSeparator(id)) {
          select_row(id_select);
        } else if (modif_solde) {
          var v = get_tree().view;
          var ecr1 = v.getCellText(v.selection.currentIndex,'ecrid');
          var ecr2 = v.getCellText(id_select,'ecrid');
          if (ecr1 == ecr2) {
            do_reporter();
          } else {
            select_row(id_select);
          }
        } else {
          do_reporter();
        }
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#reporter : ' + e);
  }

}

function do_reporter() {
  
  try {
  
    if (writeable) {
    
      id_select = get_tree().currentIndex;
      var v = get_tree().view;

      if (id_select == -1) return false;
      
      var lettre = v.getCellText(v.selection.currentIndex,'lettre');
      if (isEmpty(lettre)) {
        set_editable();
      } else {
        set_readonly();
      }
      var date = v.getCellText(v.selection.currentIndex,'date');
      document.getElementById('input_date').value = date;

      var compte = v.getCellText(v.selection.currentIndex,'compte');
      document.getElementById('input_compte').value = compte;
      if (isEmpty(compte)) {
        document.getElementById('libelle_compte').value = '';
        document.getElementById('solde_compte').value = '';
      } else {
        maj_aff_compte(document.getElementById('input_compte'),false) ;
      }

      var type = v.getCellText(v.selection.currentIndex,'type');
      document.getElementById("input_type").value = type;
      var raccourci = v.getCellText(v.selection.currentIndex,'raccourci');
      document.getElementById("input_raccourci").value = raccourci;
      var libelle = v.getCellText(v.selection.currentIndex,'libelle');
      document.getElementById("input_libelle").value = libelle;
      var contrepartie = v.getCellText(v.selection.currentIndex,'contrepartie');
      document.getElementById("input_contrepartie").value = contrepartie;
      var debit = v.getCellText(v.selection.currentIndex,'debit').replace(',','.');
      document.getElementById("input_debit").value = debit;
      var credit = v.getCellText(v.selection.currentIndex,'credit').replace(',','.');
      document.getElementById("input_credit").value = credit;
      var echeance = v.getCellText(v.selection.currentIndex,'echeance');
      document.getElementById("input_echeance").value = echeance;
      var piece = v.getCellText(v.selection.currentIndex,'piece');
      document.getElementById("input_piece").value = piece;
      if (isEmpty(focus_input)) focus_input = "input_date";
      switch (focus_input) {
        case 'input_debit':
          if (isEmpty(debit) && (! isEmpty(credit))) focus_input = 'input_credit';
          break;
        case 'input_credit':
          if (isEmpty(credit) && (! isEmpty(debit))) focus_input = 'input_debit';
          break;
      }
      document.getElementById(focus_input).focus();
      anc_value = document.getElementById(focus_input).value;

      
      document.getElementById('controle_coherence').value = "";
      document.getElementById('controle_coherence').collapsed = true;
    
    }
     
    maj_aff_solde();

  } catch(e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#do_reporter : ' + e);
  }
    
}

function suite_reporter(ds) {
  
  try {

    if (page_chargee) {

      var v = get_tree().view;
      var compte = v.getCellText(v.selection.currentIndex,'compte');
      document.getElementById('input_compte').value = compte;
      if (isEmpty(compte)) {
        document.getElementById('libelle_compte').value = '';
        document.getElementById('solde_compte').value = '';
      } else {
        var comptes = document.getElementById('liste_comptes');
        comptes.value = compte;
        document.getElementById('libelle_compte').value = comptes.label;
        document.getElementById('solde_compte').value = comptes.acceltext;
      }

      var type = v.getCellText(v.selection.currentIndex,'type');
      document.getElementById("input_type").value = type;
      var raccourci = v.getCellText(v.selection.currentIndex,'raccourci');
      document.getElementById("input_raccourci").value = raccourci;
      var libelle = v.getCellText(v.selection.currentIndex,'libelle');
      document.getElementById("input_libelle").value = libelle;
      var contrepartie = v.getCellText(v.selection.currentIndex,'contrepartie');
      document.getElementById("input_contrepartie").value = contrepartie;
      var debit = v.getCellText(v.selection.currentIndex,'debit').replace(',','.');
      document.getElementById("input_debit").value = debit;
      var credit = v.getCellText(v.selection.currentIndex,'credit').replace(',','.');
      document.getElementById("input_credit").value = credit;
      var echeance = v.getCellText(v.selection.currentIndex,'echeance');
      document.getElementById("input_echeance").value = echeance;
      var piece = v.getCellText(v.selection.currentIndex,'piece');
      document.getElementById("input_piece").value = piece;
      if (isEmpty(focus_input)) focus_input = "input_date";
      switch (focus_input) {
        case 'input_debit':
          if (isEmpty(debit) && (! isEmpty(credit))) focus_input = 'input_credit';
          break;
        case 'input_credit':
          if (isEmpty(credit) && (! isEmpty(debit))) focus_input = 'input_debit';
          break;
      }
      document.getElementById(focus_input).focus();
      anc_value = document.getElementById(focus_input).value;
    
      maj_aff_solde();
      
    }
    
  } catch(e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#suite_reporter : ' + e);
  }
    
}

function set_editable() {
  try {
    document.getElementById("input_date").readonly = false;
    document.getElementById("input_compte").readonly = false;
    document.getElementById("input_type").readonly = false;
    document.getElementById("input_raccourci").readonly = false;
    document.getElementById("input_libelle").readonly = false;
    document.getElementById("input_contrepartie").readonly = false;
    document.getElementById("input_debit").readonly = false;
    document.getElementById("input_credit").readonly = false;
    document.getElementById("input_echeance").readonly = false;
    document.getElementById("input_piece").readonly = false;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#set_editable : ' + e);
  }
}

function set_readonly() {
  try {
    document.getElementById("input_date").readonly = true;
    document.getElementById("input_compte").readonly = true;
    document.getElementById("input_type").readonly = true;
    document.getElementById("input_raccourci").readonly = true;
    document.getElementById("input_libelle").readonly = true;
    document.getElementById("input_contrepartie").readonly = true;
    document.getElementById("input_debit").readonly = true;
    document.getElementById("input_credit").readonly = true;
    document.getElementById("input_echeance").readonly = true;
    document.getElementById("input_piece").readonly = true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#set_readonly : ' + e);
  }
}

function verif_coherence() {
  try {
    switch (ParamValeur('Type_Journal')) {
      case 'AC':
        switch (document.getElementById('type_compte').value) {
          case 'F':
            if (isEmpty(document.getElementById("input_debit").value)) {
              document.getElementById('controle_coherence').value = "";
              document.getElementById('controle_coherence').collapsed = true;
            } else {
              var msg = "Attention ! Vous dbitez un compte fournisseur. ";
              msg += "tes vous sr que vous comptabilisez un avoir ?";
              document.getElementById('controle_coherence').value = msg;
              document.getElementById('controle_coherence').collapsed = false;
            }
            break;
          case 'C':
            if (isEmpty(document.getElementById("input_credit").value)) {
              document.getElementById('controle_coherence').value = "";
              document.getElementById('controle_coherence').collapsed = true;
            } else {
              var msg = "Attention ! Vous crditez un compte client. ";
              msg += "tes vous sr que vous comptabilisez un avoir ?";
              document.getElementById('controle_coherence').value = msg;
              document.getElementById('controle_coherence').collapsed = false;
            }
            break;
          default:
            document.getElementById('controle_coherence').value = "";
            document.getElementById('controle_coherence').collapsed = true;
            break;
        }
        break;
      case 'TR':
        if (ParamValeur('Code_Journal') == 'CA') {
        }
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#verif_coherence : ' + e);
  }
}

/****************************************************
 *  Mise  jour des valeurs du solde et du libell
 * du compte affich dans la ligne de saisie.
 ****************************************************/
function maj_aff_compte(t,rech) {
  
  try {
  
    var compte = t.value;
    var paramlist = cookie() + "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    paramlist += "&Numero_Compte=" + compte;

    var p = requeteHTTP(paramlist);
  
    if (p.status == "0") return false;
    
    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      var comptes = session.getElementsByTagName('numero'); 
      if (comptes.length  != 1 ) {
        if (rech) {
          recherche_compte(t);
          return '';
        }
      } else {
        compte = comptes[0].firstChild.data;
        if (t.id == 'input_compte') {
          var l = session.getElementsByTagName('libelle')[0];
          document.getElementById('libelle_compte').value = l.firstChild.data;
          var l = session.getElementsByTagName('gen')[0];
          document.getElementById('type_compte').value = l.firstChild.data;
          var s = session.getElementsByTagName('solde')[0];
          var d = session.getElementsByTagName('debit')[0]; 
          var c = session.getElementsByTagName('credit')[0];
          document.getElementById('solde_compte').value = s.firstChild.data;
          document.getElementById('debit_compte').value = d.firstChild.data;
          document.getElementById('credit_compte').value = c.firstChild.data;
          var os = session.getElementsByTagName('old_solde')[0];
          var od = session.getElementsByTagName('old_debit')[0]; 
          var oc = session.getElementsByTagName('old_credit')[0];
          document.getElementById('old_solde_compte').value = os.firstChild.data;
          document.getElementById('old_debit_compte').value = od.firstChild.data;
          document.getElementById('old_credit_compte').value = oc.firstChild.data;
        }
      }

    }
    
    return compte;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#maj_aff_compte : ' + e);
  }

}


/****************************************************
 *  Mise  jour des valeurs du total crdit, du total dbit
 * et du solde de l'criture en cours de saisie.
 ****************************************************/
function maj_aff_solde() {
  
  try {
  
    var v = get_tree().view;
    var tot_debit = parseFloat(v.getCellText(v.selection.currentIndex,'tot_debit').replace(rExp,''));
    if (isNaN(tot_debit)) tot_debit = 0;
    document.getElementById("total_debit").value = format(tot_debit,2,' ',0);
    var tot_credit = parseFloat(v.getCellText(v.selection.currentIndex,'tot_credit').replace(rExp,''));
    if (isNaN(tot_credit)) tot_credit = 0;
    document.getElementById("total_credit").value = format(tot_credit,2,' ',0);
    var solde = parseFloat(format(tot_credit - tot_debit,2,'',0));
//    if ((solde < 0.01) && (solde > -0.01)) solde = 0;
    if (isNaN(solde)) solde = 0;
    var input_solde = document.getElementById("solde");
    input_solde.value = format(solde,2,' ',0); 
    if (solde == 0) {
      input_solde.className = 'nombre';
      modif_solde = false;
    } else {
      input_solde.className = 'debitcredit-totfocus';
      modif_solde = true;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#maj_aff_solde : ' + e);
  }

}

/****************************************************
 *  Excut lorsqu'une zone de saisie prend le focus.
 *  affecte le nom de classe 'focus'  la zone.
 *  @param t : la zone de saisie.
 *  @param id : l'identifieur de la zone de saisie.
 ****************************************************/
function focus_field(t,id){

  try {

    t.setSelectionRange(0,t.textLength);
    focus_input = id;
    get_tree().treeBoxObject.focused = true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_field : ' + e);
  }

}

///****************************************************
// *  Excut lorsqu'une zone de saisie perd le focus.
// *  affecte le nom de classe 'focus'  la zone.
// *  @param t : la zone de saisie.
// *  @param id : l'identifieur de la zone de saisie.
// ****************************************************/
//function blur_field(t,id){
//  try {
//    switch (id) {
//      case 'input_date':
//      case 'input_compte':
//      case 'input_type':
//      case 'input_raccourci':
//      case 'input_libelle':
//      case 'input_contrepartie':
//      case 'input_echeance':
//      case 'input_piece':
//        t.className = 'normal';
//        break;
//      case 'input_debit':
//      case 'input_credit':
//        t.className = 'debitcredit-normal';
//        break;
//    }
//  } catch (e) {
//    recup_erreur('erreur dans compta/user/saisie/saisie.js#blur_field : ' + e);
//  }
//}


/****************************************************
 * Suppression d'une ligne ou d'une criture
 ****************************************************/
function supprimer() {

  try {

    var v = get_tree().view;
    var index = v.selection.currentIndex;
    var num_ecr = v.getCellText(index,'num_ecriture');
    var ecrid = v.getCellText(index,'ecrid');

    if (ecrid == nb_ecritures) {
      if (confirm("Voulez vous annuler l'criture en cours de saisie ?")) {
        pageFin();
      }
    } else if (peutSupprimer(index,num_ecr)) {

      if (confirm("Voulez vous effacer l'criture en cours de saisie ?")) {

        while ((index > 0) && (v.getCellText(index-1,'ecrid') == ecrid)) index--;

        supprbase_ecriture(num_ecr);
        
        var root = get_root();
        var uri = "http://www.opensi.org/compta/ecritures/" + ecrid;
        var ecriture = dsource.getNode(uri);
        var children = ecriture.getChildren();
        while (children.hasMoreElements()) {
          var child = children.getNext();
          root.removeChild(child);
        }
        ecritures.removeChild(ecriture);
//        select_end();
        while ((index < v.rowCount) && v.isSeparator(index)) index++;
        if (index == v.rowCount) {
          select_end();
        } else {
          select_row(index);
        }

      }

    }


  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#supprimer : ' + e);
  }
  
}
 
function peutSupprimer(index,num_ecr) {

  try {

    if (! writeable) return false;
    
    if (num_ecr == nb_ecritures) return false;
    
    var v = get_tree().view;
    var i = index;
    while ((i >= 0) && (! v.isSeparator(i))) {
      if (! isEmpty(v.getCellText(i,'lettre'))) return false;
      i--;
    }

    i = index + 1;
    while ((i < v.rowCount) && (! v.isSeparator(i))) {
      if (! isEmpty(v.getCellText(i,'lettre'))) return false;
      i++;
    }

    return true;
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#peutSupprimer : ' + e);
  }

}
 
/****************************************************
 *  Excut lorsqu'une zone de saisie a t modifie
 *  
 *  @param id : l'identifiant de la zone de saisie.
 ****************************************************/
function change_field(id){

  try{

    var t = document.getElementById(id);
    
    var child =  get_child(get_tree().currentIndex);
    var value = t.value;

    child.addTargetOnce(targetname(id),value);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_field : ' + e);
  }

}

/****************************************************
 *  Excut lorsque la date a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_date() {

  try {

    var t = document.getElementById('input_date');
    if (t.value == ' ' || t.value == '  ') {
      t.value = '';
    }
    if (isEmpty(t.value)) {
      return false;
    }
    if (isNaN(t.value)) {
      alert('Date incorrecte');
      t.value = anc_value;
      return false;
    }
    var v = parseIntBis(t.value);
    if ((v < 1) || (v > nb_jours_periode())) {
      alert('Date incorrecte');
      t.value = anc_value;
      return false;
    }
    t.value = format(v, '', '', 2);
    change_field('input_date');
  
    var view = get_tree().view;
    var nouv = view.getCellText(view.selection.currentIndex,'nouv');
    if (nouv == 'false') {
      majbase_field('input_date',view.selection.currentIndex);
    }

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_date : ' + e);
  }

}

/****************************************************
 *  Effectue une recherche de compte
 *  @param t la zone de saisie  affecter.
 ****************************************************/
function recherche_compte(t){
  
  try {
  
    var compte = t.value;
    var id = t.id
    var url = "chrome://opensi/content/compta/util/rechcompte.xul?" + cookie();
    window.openDialog(url,'rechcompte','chrome,modal',compte,id,true);

    switch(t.id) {
      case 'input_compte' :
        change_compte();
        break;
      case 'input_contrepartie' :
        change_contrepartie();
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#recherche_compte : ' + e);
  }

}

/****************************************************
 *  Excut lorsque le numero de compte a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_compte() {
  
  try {

    var t = document.getElementById('input_compte');
//    var comptes = document.getElementById('liste_comptes');
    if (isEmpty(t.value)) {
      return false;
    }
    if (force) {
      maj_aff_compte(t,false);
      force = false;
    } else {
      if (t.value == '*') t.value = ' ';
      var compte = maj_aff_compte(t,true);
      if (isEmpty(compte)) return false;
      t.value = compte;
    }

    change_field('input_compte');

    var view = get_tree().view;
    var nouv = view.getCellText(view.selection.currentIndex,'nouv');
    if (nouv == 'false') {
      majbase_field('input_compte',view.selection.currentIndex);
    }
    
    verif_coherence();
    
    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_compte : ' + e);
  }

}

/****************************************************
 *  Excut lorsque le libell a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_libelle() {
  
  try {
  
    var t = document.getElementById('input_libelle');
    if (isEmpty(t.value)) {
      return false;
    }
    change_field('input_libelle');

    var view = get_tree().view;
    var nouv = view.getCellText(view.selection.currentIndex,'nouv');
    if (nouv == 'false') {
      majbase_field('input_libelle',view.selection.currentIndex);
    }

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_libelle : ' + e);
  }

}

/****************************************************
 *  Excut lorsque le compte de contrepartie a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_contrepartie() {
  
  try {
  
    var t = document.getElementById('input_contrepartie');
    if (isEmpty(t.value)) {
      change_field('input_contrepartie');
      return true;
    }
    if (force) {
      force = false;
    } else {
      if (t.value == '*') t.value = ' ';
      var compte = maj_aff_compte(t,true);
      if (isEmpty(compte)) return false;
      t.value = compte;
    }
    change_field('input_contrepartie');

    var view = get_tree().view;
    var nouv = view.getCellText(view.selection.currentIndex,'nouv');
    if (nouv == 'false') {
      majbase_field('input_contrepartie',view.selection.currentIndex);
    }

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_contrepartie : ' + e);
  }

}

/****************************************************
 *  Excut lorsque la valeur du dbit ou du crdit a t modifie
 *  @name 'debit' ou 'credit'
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_debitcredit(name) {

  if ((name != 'debit') && (name != 'credit')) {
    recup_erreur("erreur dans compta/user/saisie/saisie.js#change_debitcredit :"
                 + " paramtre <name> invalide : '" + name + "'");
    return false;
  }

  try {
  
    var id = 'input_' + name;
    var t = document.getElementById(id);
    var v = t.value;
    var value = 0;
    if (! isEmpty(v)) {
      if (v == '*') {
        var solde = eval(document.getElementById("solde").value.replace(rExp,''));
        var aux1 = anc_value.replace(rExp,'');
        var aux = 0;
        if (! isEmpty(aux1) && ! isNaN(aux1)) {
          aux = eval(aux1);
        }
        switch (name) {
          case 'debit':
            newval = solde + aux;
            break;
          case 'credit':
            newval = aux - solde;
            break;
        }
        if (newval > 0) value = newval;
      } else {
        try {
          value = eval(v.replace(rExp,''));
        } catch (e) {
          t.value = anc_value;
          alert('Valeur incorrecte');
          return false;
        }
      }
    }
    if (value != 0) {
      t.value = format(value,2,' ',0);
    } else {
      t.value = '';
    }
    var aux = parseFloat(anc_value.replace(rExp,''));
    if (isNaN(aux)) aux = 0;
    var delta = value - aux;
    modif_field(name,delta);
    change_field(id);
    verif_coherence();
    return true;
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_debitcredit : ' + e);
  }
    
}
  
/****************************************************
 *  Excut lorsque la valeur du dbit a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_debit() {
  return change_debitcredit('debit');
}

/****************************************************
 *  Excut lorsque la valeur du crdit a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_credit() {
  return change_debitcredit('credit');
}

/****************************************************
 *  Excut lorsque la valeur du dbit ou du crdit a t modifie
 *  @param fieldname 'debit' ou 'credit'
 *  @param delta la diffrence de dbit  appliquer
 ****************************************************/
function modif_field(fieldname,delta) {
  
  if ((fieldname != 'debit') && (fieldname != 'credit')) {
    recup_erreur("erreur dans compta/user/saisie/saisie.js#modif_field :"
                 + " paramtre <fieldname> invalide : '" + fieldname + "'");
    return -1;
  }

  try {

    var tot_name = 'tot_' + fieldname;
    var delta_name = 'delta_' + fieldname;
    var v = get_tree().view;
    var index = v.selection.currentIndex;
    var num_ecr = v.getCellText(index,'ecrid');
    var tot_value = parseFloat(v.getCellText(index,tot_name).replace(rExp,''));
    if (isNaN(tot_value)) tot_value = 0;
    var delta_value = parseFloat(v.getCellText(index,delta_name));
    if (isNaN(delta_value)) delta_value = 0;
    tot_value += delta;
    delta_value += delta;
    var uri = "http://www.opensi.org/compta/ecritures/" + num_ecr;
    var ecriture = dsource.getNode(uri);
    var children = ecriture.getChildren();
    while (children.hasMoreElements()) {
      var child = children.getNext();
      child.addTargetOnce(targetname(tot_name),format(tot_value,2,'',0));
    }


    var nouv = v.getCellText(index,'nouv');
    if (nouv == 'false') {

      index ++;
      var root = get_root();
      children = root.getChildren();
      var child = null;
      var found = false;

      while ((children.hasMoreElements()) && (! found) ) {
        var c = children.getNext();
        if (root.getChildIndex(c) == index) {
          child = c;
          found = true;
        }
      }
      if (found) child.addTargetOnce(targetname(delta_name),'' + delta_value);
      
    }

    maj_aff_solde();
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#modif_field : ' + e);
  }

}

/****************************************************
 *  Excut lorsque la date d'chance a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_echeance() {
  try {
    change_field('input_echeance');
    var view = get_tree().view;
    var nouv = view.getCellText(view.selection.currentIndex,'nouv');
    if (nouv == 'false') {
      majbase_field('input_echeance',view.selection.currentIndex);
    }
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_echeance : ' + e);
  }
}
  
/****************************************************
 *  Excut lorsque le type a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_type() {
  try {
    change_field('input_type');
    var view = get_tree().view;
    var nouv = view.getCellText(view.selection.currentIndex,'nouv');
    if (nouv == 'false') {
      majbase_field('input_type',view.selection.currentIndex);
    }
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_type : ' + e);
  }
}

/****************************************************
 *  Excut lorsque le raccourci a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_raccourci() {
  try {
    change_field('input_raccourci');
    var view = get_tree().view;
    var nouv = view.getCellText(view.selection.currentIndex,'nouv');
    if (nouv == 'false') {
      majbase_field('input_raccourci',view.selection.currentIndex);
    }
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_raccourci : ' + e);
  }
}

/****************************************************
 *  Excut lorsque a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_piece() {
  change_field('input_piece');
  return true;
}

function keypresstree(e) {
  try {
    switch (e.keyCode) {
      case 13: // Enter
        close_search();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#keypresstree : ' + e);
  }    
}

function close_search() {
  try {
    if (isrech) {
      if (page_chargee) {
        id_select = get_tree().currentIndex;
        var v = get_tree().view;

        if (id_select == -1) return false;
      
        var numop = v.getCellText(v.selection.currentIndex,'numop');

        var paramlist = cookie();
        paramlist += "&Code_Journal=" + v.getCellText(v.selection.currentIndex,'journal');
        paramlist += "&Periode=" + v.getCellText(v.selection.currentIndex,'periode');
        paramlist += "&numop=" + v.getCellText(v.selection.currentIndex,'numop');
        var page = "chrome://opensi/content/compta/user/saisie/menu_saisie.xul?" + paramlist ;
        if (!isEmpty(ParamValeur('global'))) {
          window.opener.parent.location = page;
        } else {
          window.opener.location = page;
        }

        window.close();
      }
      
    } else {
      revision();
    }
      
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#close_search : ' + e);
  }    
}

/****************************************************
 *  Excut lorsque l'utilisateur appuie sur une touche du clavier.
 *  @param e : la touche du clavier
 ****************************************************/
function keypresssaisie(e) {
  try {
    var soldeecr = parseFloat(document.getElementById("solde").value);
    switch (e.keyCode) {
      case 13: // Enter
        enter_pressed(e.ctrlKey);
        break;
      case 33: // 'PageUp'
        if (soldeecr == 0) select_up();
        break;
      case 34: // 'PageDown'
        if (soldeecr == 0) select_down();
        break;
      case 35: // 'Fin'
        if (soldeecr == 0) select_end();
        break;
      case 36: // 'Debut'
        if (soldeecr == 0) select_begin();
        break;
//      case 37: // '<-'
      case 27: // 'Echap'
        focus_prev();
        break;
      case 38: // '^'
        select_prev();
        break;
//      case 39: // '->'
//        focus_next();
//        break;
      case 9: // TAB
        var f;
        switch (focus_input) {
          case 'input_date':
            f = get_tree();
            break;
          case 'input_compte':
            f = document.getElementById('input_date');
            break;
          case 'input_type':
            f = document.getElementById('input_compte');
            break;
          case 'input_raccourci':
            f = document.getElementById('input_type');
            break;
          case 'input_libelle':
            f = document.getElementById('input_compte');
            break;
          case 'input_contrepartie':
            f = document.getElementById('input_libelle');
            break;
          case 'input_debit':
            f = document.getElementById('input_contrepartie');
            break;
          case 'input_credit':
            f = document.getElementById('input_debit');
            break;
          case 'input_echeance':
            f = document.getElementById('input_credit');
            break;
          case 'input_piece':
            f = document.getElementById('input_echeance');
            break;
        }
        if (writeable) f.focus();
        break;
      case 40: // 'v'
        select_next();
        break;
      case 46: // 'Suppr'
        if (e.ctrlKey) {
          supprimer();
        }
        break;
      case 113: // 'F2'
        revision();
        break;
      case 114: // 'F3'
        reprise_lib_compte();
        break;
      case 123: // 'F12'
        rechecr(0);
        break;
/*
      default: 
        alert(e.keyCode);
        break;
*/
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#keypresssaisie : ' + e);
  }

}

/****************************************************
 ****************************************************/
function revision() {

  try {

    var v = get_tree().view;
    var compte = v.getCellText(v.selection.currentIndex,'compte');
    var numop = v.getCellText(v.selection.currentIndex,'numop');
    var lettre = v.getCellText(v.selection.currentIndex,'lettre');

    if (isEmpty(compte)) {
      return false;
    } else {
      
      var prec = "chrome://opensi/content/compta/user/saisie/menu_saisie.xul?" + cookie();
      prec += "&Code_Journal=" + ParamValeur('Code_Journal');
      prec += "&Type_Journal=" + ParamValeur('Type_Journal');
      prec += "&Periode=" + ParamValeur('Periode');
      prec += "&numop=" + numop;

      var let = '1';
      if (isEmpty(lettre)) {
        let = '0';
      }
      
      var page = "chrome://opensi/content/compta/user/consultation/menu_consultation.xul?" + cookie() ;
      page += "&compte=" + compte;
      page += "&let=" + let;
      page += "&numop=" + numop;
      page += "&prec=" + escape(prec);
      page += "&nomprec=Saisie";
      window.parent.location = page;
      return true;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#revision : ' + e);
  }

}

/****************************************************
 ****************************************************/
function reprise_lib_compte() {
  try {
    if (focus_input == 'input_libelle') {
      var libelle_compte = document.getElementById('libelle_compte').value;
      document.getElementById('input_libelle').value = libelle_compte;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#reprise_num_compte : ' + e);
  }
}

/****************************************************
 *  selectionne un ligne dans l'arbre.
 *  @param index : l'index de la ligne de l'arbre  slectionner
 ****************************************************/
function select_row(index) {
  try {
    var tree = get_tree();
    if (tree.view != null) {
      tree.view.selection.select(index);
      tree.treeBoxObject.ensureRowIsVisible(index);
    }
    do_reporter();
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_row : ' + e);
  }
}

/****************************************************
 *  slection de la premire ligne de l'arbre
 ****************************************************/
function select_begin(){
  select_row(0);
}

/****************************************************
 *  slection de la dernire ligne de l'arbre
 ****************************************************/
function select_end(){
  try {
    var v = get_tree().view;
    var index = v.rowCount - 1 ;
    while (v.isSeparator(index)) index--;
    select_row(index);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_end : ' + e);
  }
}

/****************************************************
 *  slection d'une ligne 10 lignes au dessus de la ligne slectionne
 ****************************************************/
function select_up(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 10;
    if (index < 0) {
      select_begin();
    } else {
      while (v.isSeparator(index)) index--;
      if (index >= 0) {
        select_row(index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_up : ' + e);
  }
}

/****************************************************
 *  slection d'une ligne 10 lignes en dessous de la ligne slectionne
 ****************************************************/
function select_down(){
  try {
    var v = get_tree().view;
    var rc = v.rowCount;
    var index = v.selection.currentIndex + 10 ;
    if (index >= rc) {
      select_end();
    } else {
      while (v.isSeparator(index)) index++;
      if (index < rc) {
        select_row(index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_down : ' + e);
  }
}

/****************************************************
 *  slection de la ligne prcdente  la ligne slectionne
 ****************************************************/
function select_prev(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 1;
    if (index < 0) return false;
    var soldeecr = parseFloat(document.getElementById("solde").value);
    if ((v.isSeparator(index)) && (soldeecr != 0)) return false;
    while (v.isSeparator(index)) index--;
    if (index >= 0) {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_prev : ' + e);
  }
}

/****************************************************
 *  slection de la ligne suivante  la ligne slectionne
 ****************************************************/
function select_next(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex + 1;
    if (index >= v.rowCount) return false;
    var soldeecr = parseFloat(document.getElementById("solde").value);
    if ((v.isSeparator(index)) && (soldeecr != 0)) return false;
    while ((index < v.rowCount) && (v.isSeparator(index))) index++;
    if (index < v.rowCount ) {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_next : ' + e);
  }
}

/****************************************************
 *  focus sur la zone de saisie prcdant la zone
 *  ayant couramment le focus.
 ****************************************************/
function focus_prev(){
  
  try {
  
    var f = focus_input;
    var t = document.getElementById(f);
    switch (f) {
      case 'input_compte':
        if (t.value != anc_value) {
          if(change_compte()) {
            f = 'input_date';
          } else {
            f = 'input_compte';
          }
        } else {
          f = 'input_date';
        }
        break;
      case 'input_raccourci':
        if (t.value != anc_value) {
          if(change_raccourci()) {
            f = 'input_compte';
          } else {
            f = 'input_raccourci';
          }
        } else {
          f = 'input_compte';
        }
        break;
      case 'input_type':
        if (t.value != anc_value) {
          if(change_type()) {
            f = 'input_raccourci';
          } else {
            f = 'input_type';
          }
        } else {
          f = 'input_raccourci';
        }
        break;
      case 'input_libelle':
        if (t.value != anc_value) {
          if(change_libelle()) {
            f = 'input_type';
          } else {
            f = 'input_libelle';
          }
        } else {
          f = 'input_type';
        }
        break;
      case 'input_contrepartie':
        if (t.value != anc_value) {
          if(change_contrepartie()) {
            f = 'input_libelle';
          } else {
            f = 'input_contrepartie';
          }
        } else {
          f = 'input_libelle';
        }
        break;
      case 'input_echeance':
        if (t.value != anc_value) {
          if(change_echeance()) {
            f = 'input_contrepartie';
          } else {
            f = 'input_echeance';
          }
        } else {
          f = 'input_contrepartie';
        }
        break;
      case 'input_debit':
        if (t.value != anc_value) {
          if(change_debit()) {
            f = 'input_echeance';
          } else {
            f = 'input_debit';
          }
        } else {
          f = 'input_echeance';
        }
        break;
      case 'input_credit':
        if (t.value != anc_value) {
          if(change_credit()) {
            if (isEmpty(t.value)) {
              f = 'input_debit';
            } else {
              f = 'input_contrepartie';
            } 
          } else {
            f = 'input_credit';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_debit';
        } else {
          f = 'input_contrepartie';
        }
        break;
      case 'input_piece':
        var debit = document.getElementById('input_debit').value;
        var credit = document.getElementById('input_credit').value;
        if (t.value != anc_value) {
          if(change_piece()) {
            if ((isEmpty(credit)) && (! isEmpty(debit))) {
              f = 'input_debit';
            } else {
              f = 'input_credit';
            }
          } else {
            f = 'input_piece';
          }
        } else if ((isEmpty(credit)) && (! isEmpty(debit))) {
          f = 'input_debit';
        } else {
          f = 'input_credit';
        } 
        break;
    }
    if (writeable) {
      document.getElementById(f).focus();
      anc_value = document.getElementById(f).value;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_prev : ' + e);
  }

}

/****************************************************
 *  focus sur la zone de saisie suivant la zone
 *  ayant couramment le focus.
 ****************************************************/
function focus_next(){
  
  try {

    var f = focus_input;
    var t = document.getElementById(f);
    switch (f) {
      case 'input_date':
        if (t.value != anc_value) {
          if (change_date()) {
            f = 'input_compte';
          } else {
            f = 'input_date';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_date';
        } else {
          f = 'input_compte';
        }
        break;
      case 'input_compte':
        if (t.value != anc_value) {
          if (change_compte()) {
            f = 'input_raccourci';
          } else {
            f = 'input_compte';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_compte';
        } else {
          f = 'input_raccourci';
        }
        break;
      case 'input_raccourci':
        if (t.value != anc_value) {
          if (change_raccourci()) {
            f = 'input_type';
          } else {
            f = 'input_raccourci';
          }
        } else {
          f = 'input_type';
        }
        break;
      case 'input_type':
        if (t.value != anc_value) {
          if (change_type()) {
            f = 'input_libelle';
          } else {
            f = 'input_type';
          }
        } else {
          f = 'input_libelle';
        } 
        break;
      case 'input_libelle':
        if (t.value != anc_value) {
          if (change_libelle()) {
            f = 'input_contrepartie';
          } else {
            f = 'input_libelle';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_libelle';
        } else {
          f = 'input_contrepartie';
        }
        break;
      case 'input_contrepartie':
        if (t.value != anc_value) {
          if (change_contrepartie()) {
            f = 'input_echeance';
          } else {
            f = 'input_contrepartie';
          }
        } else {
          f = 'input_echeance';
        }
        break;
      case 'input_echeance':
        var debit = document.getElementById('input_debit').value;
        var credit = document.getElementById('input_credit').value;
        if (t.value != anc_value) {
          if (change_echeance()) {
            if ((isEmpty(debit)) && (! isEmpty(credit))) {
              f = 'input_credit';
            } else {
              f = 'input_debit';
            }
          } else {
            f = 'input_echeance';
          }
        } else if ((isEmpty(debit)) && (! isEmpty(credit))) {
          f = 'input_credit';
        } else {
          f = 'input_debit';
        }
        break;
      case 'input_debit':
        var view = get_tree().view;
        var solde = parseFloat(document.getElementById('solde').value.replace(rExp,''));
        var nouv = view.getCellText(view.selection.currentIndex,'nouv');
        if ((nouv == 'true') || (solde == 0)) {
          if (t.value != anc_value) {
            if (change_debit()) {
              if (isEmpty(t.value)) {
                f = 'input_credit';
              } else if (nouv == 'true') { 
                f = 'input_piece';
              } else {
                f = focus_debitcredit_modif();
              }
            } else {
              f = 'input_debit';
            }
          } else if (isEmpty(t.value)) {
            f = 'input_credit';
          } else {
            f = 'input_piece';
          }
        } else if (change_debit()) {
          if (isEmpty(t.value)) {
            f = 'input_credit';
          } else {
            f = focus_debitcredit_modif();
          }
        } else {
          f = focus_debitcredit_modif();
        }
        break;
      case 'input_credit':
        var view = get_tree().view;
        var solde = parseFloat(document.getElementById('solde').value.replace(rExp,''));
        var nouv = view.getCellText(view.selection.currentIndex,'nouv');
        if ((nouv == 'true') || (solde == 0)) { 
          if (t.value != anc_value) {
            if (change_credit()) {
              if (isEmpty(t.value)) {
                f = 'input_debit';
              } else if (nouv == 'true') { 
                f = 'input_piece';
              } else {
                f = focus_debitcredit_modif();
              }            
            } else {
              f = 'input_credit';
            }
          } else if (isEmpty(t.value)) {
            f = 'input_debit';
          } else {
            f = 'input_piece';
          }
        } else if (change_credit()) {
          if (isEmpty(t.value)) {
            f = 'input_debit';
          } else {
            f = focus_debitcredit_modif();
          }
        } else {
          f = focus_debitcredit_modif();
        }
        break;
    }
    if (writeable) {
      document.getElementById(f).focus();
      anc_value = document.getElementById(f).value;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_next : ' + e);
  }

}

/****************************************************
 *  gestion du focus sur les saisies de dbit/crdit
 * lors d'une criture modifie.
 * @return l'id de la zone de saisie ayant le focus
 ****************************************************/
function focus_debitcredit_modif() {
  
  try {
  
    var view = get_tree().view;
    var index = view.selection.currentIndex;
    var solde = parseFloat(document.getElementById('solde').value.replace(rExp,''));
    if (solde == 0) {
      maj_ecriture();
      select_row(index);
      return 'input_piece';
    } else {
      var num_ecr = view.getCellText(index,'ecrid');
      var uri = "http://www.opensi.org/compta/ecritures/" + num_ecr;
      var ecriture = dsource.getNode(uri);
      var nb_lignes = ecriture.getChildCount();
      var opid = parseIntBis(view.getCellText(index,'opid'));
      if (opid == nb_lignes - 1) {
        ajout_ligne();
      } else {
        select_next();
      }
      return focus_input;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_debitcredit_modif : ' + e);
  }

}

/****************************************************
 *  appele lorsque l'utilisateur appuie sur 'Enter'
 ****************************************************/
function enter_pressed(ctrlKey) {
  
  try {
  
    switch (focus_input) {
      case 'input_piece':
        var view = get_tree().view;
        var index = view.selection.currentIndex;
        var num_ecr = view.getCellText(index,'ecrid');
        var nouv = view.getCellText(index,'nouv');
        var solde = parseFloat(document.getElementById('solde').value.replace(rExp,''));
        var v = document.getElementById(focus_input).value;
        if (v != anc_value) {
          change_piece();
        }
        var date = view.getCellText(index,'date');
        if (isEmpty(date)) {
          if (writeable) document.getElementById('input_date').focus();
          anc_value = '';
          return -1;
        }
        var compte = view.getCellText(index,'compte');
        if (isEmpty(compte)) {
          if (writeable) document.getElementById('input_compte').focus();
          anc_value = '';
          return -1;
        }
        var libelle = view.getCellText(index,'libelle');
        if (isEmpty(libelle)) {
          if (writeable) document.getElementById('input_libelle').focus();
          anc_value = '';
          return -1;
        }
        var debit = view.getCellText(index,'debit').replace(rExp,'');
        var credit = view.getCellText(index,'credit').replace(rExp,'');
        if (isEmpty(debit) && isEmpty(credit)) {
          if (writeable) document.getElementById('input_debit').focus();
          anc_value = '';
          return -1;
        }
        if (num_ecr == nb_ecritures) {
          if (solde == 0) {
            valid_ecriture();
          } else {
            if (view.rowCount == index + 1) {
              ajout_ligne();
            } else {
              select_next();
              if (writeable) document.getElementById('input_date').focus();
              anc_value = document.getElementById('input_date').value;
            }
          }
        } else if (nouv == 'true') {
          if (solde == 0) {
            maj_ecriture();
          } else {
            var uri = "http://www.opensi.org/compta/ecritures/" + num_ecr;
            var ecriture = dsource.getNode(uri);
            var nb_lignes =  ecriture.getChildCount();
            var opid = parseIntBis(view.getCellText(index,'opid'));
            if (opid == nb_lignes - 1) {
              ajout_ligne();
            } else {
              select_next();
              focus_prev();
            }
          }
        } else {
          if (v != anc_value) {
            majbase_field('input_piece',index);
          }
          if (solde == 0) {
            select_next();
            if (writeable) document.getElementById('input_date').focus();
            anc_value = document.getElementById('input_date').value;            
          } else {
            var uri = "http://www.opensi.org/compta/ecritures/" + num_ecr;
            var ecriture = dsource.getNode(uri);
            var nb_lignes = ecriture.getChildCount();
            var opid = parseIntBis(view.getCellText(index,'opid'));
            if (opid == nb_lignes - 1) {
              ajout_ligne();
            } else {
              select_next();
              focus_prev();
            }
          }
        }
        break;
      default:
        focus_next();
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#enter_pressed : ' + e);
  }

}


/****************************************************
 *  insre une ligne de saisie vierge dans une criture
 ****************************************************/
function ajout_ligne() {

  try {
    
    var v = get_tree().view;
    var index = v.selection.currentIndex;
    var num_ecr = v.getCellText(index,'num_ecriture');
    var ecrid = v.getCellText(index,'ecrid');

    var child = new_ligne(ecrid, num_ecr, index + 2);

    var date = v.getCellText(index,'date');
    var type = v.getCellText(index,'type');
    var raccourci = v.getCellText(index,'raccourci');
    var libelle = v.getCellText(index,'libelle');
    var echeance = v.getCellText(index,'echeance');
    var piece = v.getCellText(index,'piece');
    var tot_debit = v.getCellText(index,'tot_debit');
    var tot_credit = v.getCellText(index,'tot_credit');
    child.addTargetOnce(targetname('input_date'), date);
    child.addTargetOnce(targetname('input_type'), type);
    child.addTargetOnce(targetname('input_raccourci'), raccourci);
    child.addTargetOnce(targetname('input_libelle'), libelle);
    child.addTargetOnce(targetname('input_echeance'), echeance);
    child.addTargetOnce(targetname('input_piece'), piece);
    child.addTargetOnce(targetname('tot_debit'), tot_debit);
    child.addTargetOnce(targetname('tot_credit'), tot_credit);
      
    select_row(index + 1);
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajout_ligne : ' + e);
  }
}

/****************************************************
 * validation de la mise  jour d'une criture
 ****************************************************/
function maj_ecriture() {
  
  try {

    var v = get_tree().view;
    var index = v.selection.currentIndex;
    var num_ecr = v.getCellText(index,'num_ecriture');
    var ecrid = v.getCellText(index,'ecrid');

    majbase_ecriture(ecrid,num_ecr);

    setNouvToFalse(ecrid);
        
    select_next();
    if (writeable) {
      document.getElementById('input_date').focus();
      anc_value = document.getElementById('input_date').value;            
    }
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#maj_ecriture : ' + e);
  }
 
}

/****************************************************
 * met  <false> l'attribut 'nouv' de toutes les lments
 * de l'criture d'id <ecrid>
 ****************************************************/
function setNouvToFalse(ecrid) {

  try {
  
    var v = get_tree().view;

    var uri = "http://www.opensi.org/compta/ecritures/" + ecrid;
    var ecriture = dsource.getNode(uri);
    var children = ecriture.getChildren();

    while (children.hasMoreElements()) {
      var child = children.getNext();
      child.addTargetOnce(targetname('nouv'),'false');
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#setNouvToFalse : ' + e);
  }

}

/****************************************************
 * validation de l'criture en cours de saisie
 ****************************************************/
function valid_ecriture() {
  try {
    ajoutbase_ecriture(nb_ecritures);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#valid_ecriture : ' + e);
  }
}

function suite_valid_ecriture(num_ecr) {
  
  try {

    var uri = "http://www.opensi.org/compta/ecritures/" + nb_ecritures;
    var ecriture = dsource.getNode(uri);
    var children = ecriture.getChildren();
    while (children.hasMoreElements()) {
      var child = children.getNext();
      child.addTargetOnce(targetname('num_ecriture'),'' + num_ecr);
    }

    
    setNouvToFalse(nb_ecritures);        

    ajout_separateur();
    
    nb_ecritures++;

    uri = "http://www.opensi.org/compta/ecritures/" + nb_ecritures;
    var ecriture = dsource.getNode(uri);
    ecriture.makeBag();   

    var index = get_tree().view.rowCount;
    
    new_ligne(nb_ecritures,'',index+1);
    select_row(index);

    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#suite_valid_ecriture : ' + e);
  }
 
}

/****************************************************
 * insre une ligne de sparation dans l'arbre de saisie
 ****************************************************/
function ajout_separateur() {
  
  try {

     var child = dsource.getAnonymousNode();
     child.addTargetOnce(targetname('type_desc'), 'separator');

     var root = get_root();
     root.addChildAt(child,get_tree().view.rowCount+1);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajout_separateur : ' + e);
  }
}

/****************************************************
 *  insre une ligne de saisie vierge 
 *  @param num_ecr le numro de l'criture  laquelle
 *                 il faut rajouter la ligne
 *  @param index l'index o il faut insrer le noeud dans l'arbre
 *  @return le noeud de l'arbre correspondant  la nouvelle ligne
 ****************************************************/
function new_ligne(ecrid, num_ecr, index) {
  
  try {
  
    var child = dsource.getAnonymousNode();
    
    var root = get_root();
    root.addChildAt(child,index);
    child.addTargetOnce(targetname('ecrid'), '' + ecrid);
    child.addTargetOnce(targetname('num_ecriture'), '' + num_ecr);
    var uri = "http://www.opensi.org/compta/ecritures/" + ecrid;
    var ecriture = dsource.getNode(uri);
    child.addTargetOnce(targetname('opid'),'' + ecriture.getChildCount());
    child.addTargetOnce(targetname('nouv'),'true');
    ecriture.addChild(child);
    ecritures.addChild(ecriture);
    
    if (writeable) {
      document.getElementById('input_date').focus();
      anc_value = document.getElementById('input_date').value;            
    }
    
    return child;
  
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#new_ligne : ' + e);
  }
  
}

/*==================================================================*/
/*========= Fonctions de mise  jour de la base de donnes =========*/
/*==================================================================*/

 /****************************************************
 Mise  jour de la base de donnes de la compta
 @param req ==
          'new'        => ajout ecriture
          'majchps'    => mise  jour champs
          'majcpt'     => mise  jour d'un compte
          'majcomplex' => mise  jour complexe (dbits, crdits, insertion lignes...)
          'majdate'    => mise  jour du champ 'Date' d'une criture
 @param paramlist la liste des paramtres  soumettre au formulaire de mise  jour
 ****************************************************/
function updateDatabase(req,paramlist) {

  try {

//    var corps = '&Page=Compta/UpdateDatabase/update.tmpl&ContentType=none&' + cookie();
    var corps = '&Page=Compta/UpdateDatabase/update.tmpl&ContentType=xml&' + cookie();
//    var corps = '&Page=Compta/UpdateDatabase/update.tmpl&' + cookie();
    corps += '&code_journal=' + ParamValeur('Code_Journal');
    corps += '&Periode=' + ParamValeur('Periode');  

    if (req != "") {
      corps += '&req=' + req;
    }
    corps += paramlist ;
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,suiteUpdateDatabase);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#updateDatabase : ' + e);
  }

}

function suiteUpdateDatabase(httpRequest) {

  try {

    if (httpRequest.status == "0") return false;
    
    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
      return false;
    } else {
      var contenu = httpRequest.responseXML;
      var session = contenu.documentElement;
      switch(session.getAttribute('req')) {
        case 'new' :
          suite_valid_ecriture(session.getAttribute('retour'));
          break;
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#suiteUpdateDatabase : ' + e);
  }

}


/****************************************************
 * mise  jour du champs 'piece'.
 ****************************************************/
function majbase_field(chps, index) {
  
  try {
  
    var v = get_tree().view;
    var num_ecr = v.getCellText(index,'num_ecriture');
    var num_op = v.getCellText(index,'opid');
    switch (chps) {
      case 'input_date':
        var valeur = parseIntBis(v.getCellText(index,'date'));
        changeDate(valeur,num_ecr,num_op,debut_periode);
        break;
      case 'input_compte':
        var valeur = v.getCellText(index,'compte');
        var debit = parseFloat(document.getElementById('input_debit').value.replace(rExp,''));
        var credit = parseFloat(document.getElementById('input_credit').value.replace(rExp,''));
        if (isNaN(debit)) debit = 0;
        if (isNaN(credit)) credit = 0;
        majCompte(valeur,debit,credit,num_ecr,num_op);
//        majCompte(valeur,anc_value,debit,credit,num_ecr,num_op);
        break;
      case 'input_raccourci':
        var valeur = v.getCellText(index,'raccourci');
        changeValue('Raccourci',valeur,num_ecr,num_op);
        break;
      case 'input_type':
        var valeur = v.getCellText(index,'type');
        changeValue('Type',valeur,num_ecr,num_op);
        break;
      case 'input_libelle':
        var valeur = v.getCellText(index,'libelle');
        changeValue('Libelle',valeur,num_ecr,num_op);
        break;
      case 'input_echeance':
        var valeur = v.getCellText(index,'echeance');
        changeValue('Date_Echeance',valeur,num_ecr,num_op);
        break;
      case 'input_contrepartie':
        var valeur = v.getCellText(index,'contrepartie');
        changeValue('Contrepartie',valeur,num_ecr,num_op);
        break;
      case 'input_piece':
        var valeur = v.getCellText(index,'piece');
        changeValue('Num_Piece',valeur,num_ecr,num_op);
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#majbase_field : ' + e);
  }

}

function changeValue(champs,valeur,num_ecr,num_op) {

  try {

    var req = 'majchps';
    var paramlist = "&NumEcr=" + num_ecr + "&NumOp=" + num_op ;
    paramlist += "&champs=" + champs + "&valeur=" + valeur ;
    updateDatabase(req,paramlist);
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#changeValue : ' + e);
  }
    
}

//function majCompte(valeur,anc_value,debit,credit,num_ecr,num_op) {
function majCompte(valeur,debit,credit,num_ecr,num_op) {
// valide la modification de la valeur du compte dans la base de donnes

  try {

    var req='majcpt';
    var paramlist = "&NumEcr=" + num_ecr + "&NumOp=" + num_op ;
//    paramlist += "&anc_compte=" + anc_value;
    paramlist += "&compte=" + valeur;
    var c = credit;
    var d = debit;
    if (isNaN(c)) c = 0;
    if (isNaN(d)) d = 0;
    paramlist += "&debit=" + d + "&credit=" + c ;
    updateDatabase(req,paramlist);
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#majCompte : ' + e);
  }
    
}

function changeDate(valeur,num_ecr,num_op,debut_periode) {
// associ  l'vnement onchange des entres 'Jour' sur les anciennes critures
// valide la modification de la valeur du champs dans la base de donnes

  try {

    var req = 'majdate';
    var paramlist = "&NumEcr=" + num_ecr + "&NumOp=" + num_op ;
    var date = debut_periode + ((parseIntBis(valeur) - 1) * 24 * 60 * 60 * 1000 );
    paramlist += "&date=" + date;
    updateDatabase(req,paramlist);
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#changeDate : ' + e);
  }
    
}


function get_operation(index){

  try {
  
    var v = get_tree().view;
    var opid = v.getCellText(index,'opid');
    var date = v.getCellText(index,'date');
    var dateop = debut_periode + ((parseIntBis(date) - 1) * 24 * 60 * 60 * 1000 );
    var compte = v.getCellText(index,'compte');
    var type = v.getCellText(index,'type');
    var raccourci = v.getCellText(index,'raccourci');
    var libelle = v.getCellText(index,'libelle').replace(rExpVirg,'(|)');
    var contrepartie = v.getCellText(index,'contrepartie');
    var debit = v.getCellText(index,'debit').replace(rExp,'');
    var credit = v.getCellText(index,'credit').replace(rExp,'');
    var echeance = v.getCellText(index,'echeance');
    var piece = v.getCellText(index,'piece');

    var operation = '';

    
    if (isEmpty(debit) && isEmpty(credit)) {
      var num_ecr = v.getCellText(index,'ecrid');
      var child =  get_child(index);
      var uri = "http://www.opensi.org/compta/ecritures/" + num_ecr;
      var ecriture = dsource.getNode(uri);
      var root = get_root();
      root.removeChild(child);
      ecriture.removeChild(child);
    } else {
      operation = "Num_Ligne:" + opid + ",";
      operation += "Date_Op:" + dateop + ",";
      operation += "Numero_Compte:" + compte + ",";
      operation += "Type:" + type + ",";
      operation += "Raccourci:" + raccourci + ",";
      operation += "Libelle:" + libelle + ",";
      operation += "Contrepartie:" + contrepartie + ",";
      operation += "Date_Echeance:" + echeance + ",";
      if (isEmpty(debit)) debit = 0;
      operation += "Montant_D:" + debit + ",";
      if (isEmpty(credit)) credit = 0;
      operation += "Montant_C:" + credit + ",";
      operation += "Num_Piece:" + piece;
    }

    return operation;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_operation : ' + e);
  }

}

function get_operations(ecrid) {

  try {
  
    var operations = '';
    var uri = "http://www.opensi.org/compta/ecritures/" + ecrid;
    var ecriture = dsource.getNode(uri);
    var root = get_root();
    var children = ecriture.getChildren();
    var v = get_tree().view;

    while (children.hasMoreElements()) {
      var child = children.getNext();
      var index = root.getChildIndex(child) - 1;
      var nouv = v.getCellText(index,'nouv');
      if (nouv == 'true') {
        if (! isEmpty(operations)) operations += ';';
        operations += get_operation(index);
      }
    }

    return escape(operations);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_operations : ' + e);
  }

}


/****************************************************
 * mise  jour d'une criture aprs modifications du solde
 * et ventuellement insertion de lignes
 ****************************************************/
function majbase_ecriture(ecrid,num_ecriture) {

  try {
    
    // valide la mise  jour d'une criture dans la base de donnes
    var req = 'majcomplex';

    var maj = '';
    var operations = '';

    var uri = "http://www.opensi.org/compta/ecritures/" + ecrid;
    var ecriture = dsource.getNode(uri);
    var root = get_root();
    var children = ecriture.getChildren();
    var v = get_tree().view;

    while (children.hasMoreElements()) {
      var child = children.getNext();
      var index = root.getChildIndex(child) - 1;
      var nouv = v.getCellText(index,'nouv');
      if (nouv == 'true') {
        if (! isEmpty(operations)) operations += ';';
        operations += get_operation(index);
      } else {
        var delta_debit = v.getCellText(index,'delta_debit');
        var delta_credit = v.getCellText(index,'delta_credit');
        var delta_d = 0;
        var delta_c = 0;
        if (! isEmpty(delta_debit)) delta_d = parseFloat(delta_debit);
        if (! isEmpty(delta_credit)) delta_c = parseFloat(delta_credit);
        child.addTargetOnce(targetname('delta_debit'),'0');
        child.addTargetOnce(targetname('delta_credit'),'0');
        if((delta_d != 0) || (delta_c != 0) ) {
          var opid = v.getCellText(index,'opid');
          var compte = v.getCellText(index,'compte');
          if (! isEmpty(maj)) maj += ';';
          maj += "Num_Ligne:" + opid;
          maj += ",Numero_Compte:" + compte;
          maj += ",debit:" + delta_d + ",credit:" + delta_c ;
        }
      }
    }

    var paramlist = "&NumEcr=" + num_ecriture + "&operations=" + escape(operations) + "&maj=" + maj;

    updateDatabase(req,paramlist);

    
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#majbase_ecriture : ' + e);
  }

}

/****************************************************
 * Ajout de l'criture courante dans la base
 ****************************************************/
function ajoutbase_ecriture(ecrid) {
  
  try {

    var req = 'new';
    operations = get_operations(ecrid);
    var paramlist = "&operations=" + operations;
    updateDatabase(req,paramlist);
  
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajoutbase_ecriture : ' + e);
  }
  
}

/****************************************************
 * Suppression de l'criture courante de la base
 ****************************************************/
function supprbase_ecriture(num_ecriture) {

  try {

    var req = 'supprecr';
    var paramlist = "&NumEcr=" + num_ecriture ;
    updateDatabase(req,paramlist);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#supprbase_ecriture : ' + e);
  }
  
}

/****************************************************
 * Chargement d'une page d'criture
 ****************************************************/
function loadPage(p) {
  try {
    if (page_chargee) {
      page_chargee = false;
      delete_tree();
      page = p;
      document.getElementById('page').value="Page N " + page + " / " + nb_pages;    
      var periode = ParamValeur('Periode');
      paramlist = "&Page=Compta/GetRDF/Ecritures.tmpl&ContentType=xml";
      paramlist += "&Code_Journal=" + ParamValeur('Code_Journal');
      paramlist += "&Periode=" + periode;
      paramlist += "&Pagination=" + page;
      load_tree(getUrlOpeneas(paramlist)); 
      document.getElementById('boutonDebut').disabled = (page == 1);
      document.getElementById('boutonPrec').disabled = (page == 1);
      document.getElementById('boutonFin').disabled = (page == nb_pages);
      document.getElementById('boutonSuiv').disabled = (page == nb_pages);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#loadPage : ' + e);
  }
}

/****************************************************
 * Chargement de la premire page d'criture
 ****************************************************/
function pageDebut() {
  try {
    loadPage(1);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageDebut : ' + e);
  }
}

/****************************************************
 * Chargement de la dernire page d'criture
 ****************************************************/
function pageFin() {
  try {
    loadPage(nb_pages);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageFin : ' + e);
  }
}

/****************************************************
 * Chargement de la page prcdente.
 ****************************************************/
function pagePrec() {
  try {
    loadPage(page-1);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pagePrec : ' + e);
  }
}

/****************************************************
 * Chargement de la page suivante.
 ****************************************************/
function pageSuiv() {
  try {
    loadPage(page+1);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageSuiv : ' + e);
  }
}

/****************************************************
 * Chargement de la page contenant l'opration d'Id numop.
 ****************************************************/
function pageNumOp(no) {
  try {
    
    if (isrech) {
      var journal = document.getElementById('journal');
      journal.collapsed = false;
      journal.value = "Journal : " + ParamValeur('Code_Journal');
    }

    delete_tree();
    var corps = cookie() + "&Page=Compta/GetNumPage.tmpl&ContentType=xml";
    corps += "&Periode=" + ParamValeur('Periode');
    corps += "&Code_Journal=" +  ParamValeur('Code_Journal');
    corps += "&NumOp=" + no;
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,suitePageNumOp);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageNumOp : ' + e);
  }
}

function suitePageNumOp(httpRequest) {
  try {
    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + p.status);
    } else {
      var contenu=httpRequest.responseXML;
      var session = contenu.documentElement;
      page =  session.getAttribute('page');
      var periode = ParamValeur('Periode');
      paramlist = "&Page=Compta/GetRDF/Ecritures.tmpl&ContentType=xml";
      paramlist += "&Code_Journal=" + ParamValeur('Code_Journal');
      paramlist += "&Periode=" + periode;
      paramlist += "&Pagination=" + page;
      load_tree(getUrlOpeneas(paramlist)); 
      document.getElementById('page').value="Page N " + page + " / " + nb_pages;    
      document.getElementById('boutonDebut').disabled = (page == 1);
      document.getElementById('boutonPrec').disabled = (page == 1);
      document.getElementById('boutonFin').disabled = (page == nb_pages);
      document.getElementById('boutonSuiv').disabled = (page == nb_pages);
    }  
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#suitePageNumOp : ' + e);
  }
}

function recupBank() {
  try {
    var page = "chrome://opensi/content/compta/user/autres/importbank/importbank.xul?" + cookie() ;
    page += "&Code_Journal=" + ParamValeur('Code_Journal');
    window.parent.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#recupBank : ' + e);
  }
}