/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/util/nouveau_compte.xul>
 * @include chrome://opensi/content/libs/verif.js
 * @include chrome://opensi/content/libs/util.js
 * @include chrome://libopensi/content/load_rdf.js
 *
 */

function init() {
  
  try {
  
    var x = (screen.width / 2) - 400;
    var y = (screen.height / 2) - 200;
    window.resizeTo(700,300);
    window.moveTo(x,y);
    initRDF();
    var compte = document.getElementById("compte");
    var num_compte = window.arguments[0].replace(' ','');
    compte.value = num_compte;
    if (isEmpty(num_compte)) {
      compte.focus();
    } else if (isCompteCorrect(num_compte)){
      document.getElementById("libelle").focus();
    } else {
      compte.focus();
    }
    infos_compte();

  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#init : ' + e);
  }

}

function initRDF() {

  try {
    
    var paramlist = "&Page=Compta/GetRDF/tva.tmpl&ContentType=xml";
    load_rdf_async('tva', getUrlOpeneas(paramlist),initTVA);
    var paramlist = "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    load_rdf('liste_comptes', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#initRDF : ' + e);
  }

}

function initTVA() {
  try {
  document.getElementById('tva').selectedIndex = 0;
  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#initTVA : ' + e);
  }
}


function keyup(e) {
  try {
    switch (e.keyCode) {
      case 38: // '^'
        break;
      case 40: // 'v'
        break;
      case 13: // <Enter>
        break;
      default:
        infos_compte();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#keyup : ' + e);
  }
}

function infos_compte(){

  try {

    var numcompte = document.getElementById('compte').value;
    var initiale = numcompte[0];
    switch (initiale) {
      case '0':
        document.getElementById('tva').collapsed = false;
        document.getElementById('lab_tva').collapsed = false;
        document.getElementById('comptegen').collapsed = false;
        document.getElementById('lab_comptegen').collapsed = false;
        if (numcompte.length > 1) {
          switch(numcompte[1]) {
            case '1':
              document.getElementById('comptegen').value = 'C';
              break;
            case '8':
              document.getElementById('comptegen').value = 'F';
              break;
          }
        }
        break;
      case '6': case '7':
        document.getElementById('tva').collapsed = false;
        document.getElementById('lab_tva').collapsed = false;
        document.getElementById('comptegen').collapsed = true;
        document.getElementById('lab_comptegen').collapsed = true;
        break;
      default:
        document.getElementById('tva').collapsed = true;
        document.getElementById('lab_tva').collapsed = true;
        document.getElementById('comptegen').collapsed = true;
        document.getElementById('lab_comptegen').collapsed = true;
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#infos_compte : ' + e);
  }

}


function doOK() {
  
  try {
  
    var compte = document.getElementById("compte");
    var url = "chrome://opensi/content/compta/util/nouveau_compte.xul?" + cookie();
  	var numc = compte.value;
    if (isEmpty(numc)) {
      compte.focus();
      return false;
    }
  	if (! isCompteCorrect(numc)) {
	  	alert('Numro de compte incorrect !');
      return false;
    }
    if (existeCompte(numc)) {
		  alert('Le compte numro ' + numc + ' existe dj.');
      return false;
    }
    var libelle = document.getElementById('libelle');
    if (isEmpty(libelle.value)) {
      libelle.focus();
      return false;
    }
    var tva = '';
    var comptegen = 'G';
    switch (numc[0]) {
      case '0':
        tva = '';
        comptegen = document.getElementById("comptegen").value;
        break;
      case '6': case '7':
        tva = document.getElementById("tva").value;
        comptegen = 'G';
        break;
      default:
        tva = '';
        comptegen = 'G';
        break;
    }
    var lettrauto = 'n';
    if (document.getElementById("lettrauto_y").selected) lettrauto = 'y';
    var centraliser = 'n';
    if (document.getElementById("centraliser_y").selected) centraliser = 'y';
    var cumuljournal = 'n';
    if (document.getElementById("cumuljournal_y").selected) cumuljournal = 'y';
    var detailcloture = 'n';
    if (document.getElementById("detailcloture_y").selected) detailcloture = 'y';
  
    ajoutcompte_base(numc, libelle.value, tva, comptegen, 
                     lettrauto, centraliser, cumuljournal, detailcloture);
    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js# : ' + e);
  }

}

function valider() {
  try {
    if (doOK()){
      var num_compte = document.getElementById("compte").value;
      window.opener.document.getElementById('num_compte').value = num_compte;
      window.opener.document.getElementById('lib_compte').value = '';
      window.opener.reinit_tree();
      window.close();
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#valider : ' + e);
  }
}

function keypress(e){
  try {
    switch (e.keyCode) {
      case 13:
        valider();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#keypress : ' + e);
  }
}

function existeCompte(numcompte) {
  try {
    var comptes = document.getElementById('liste_comptes');
    comptes.selectedIndex = -1;
    comptes.value = numcompte;
    return (comptes.selectedIndex  > -1 )
  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#existeCompte : ' + e);
  }
}

function ajoutcompte_base(numcompte, libelle, tva, comptegen, 
                          lettrauto, centraliser, cumuljournal, detailcloture) {

  try {
   
    var paramlist = '&Page=Compta/UpdateDatabase/update.tmpl&ContentType=none&' + cookie();

    paramlist += "&req=newcompte";
    paramlist += "&Numero_Compte=" + numcompte;
    paramlist += "&Libelle=" + urlEncode(libelle);
    paramlist += "&Compte_Gen=" + comptegen;
    if (! isEmpty(tva)) paramlist += "&Taux_Tva=" + tva;
    paramlist += "&Lettrage=" + lettrauto;
    paramlist += "&Centraliser=" + centraliser;
    paramlist += "&Cumul_Journal=" + cumuljournal;
    paramlist += "&Detail_Cloture=" + detailcloture;

    var httpRequest = new XMLHttpRequest();
    requeteHTTP(paramlist,httpRequest,nope);
  
  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#ajoutcompte_base : ' + e);
  }

}

function verifFormCompte() {
  try {
	  var numc = compte.value;
	  if (!isDigitList(numc) 
        || numc.charAt(0)=='8' 
        || numc.charAt(0)=='9' 
        || numc.length != 8
        || numc == '40100000'
        || numc == '41100000') {
  		alert('Numro de compte incorrect !');
	  	return false;
  	}
	  else
		  return true;
  } catch (e) {
    recup_erreur('erreur dans compta/util/nouveau_compte.js#verifFormCompte : ' + e);
  }
}