/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/util/rechcompte.xul>
 * @include chrome://opensi/content/libs/verif.js
 * @include chrome://opensi/content/libs/util.js
 * @include chrome://libopensi/content/load_rdf.js
 *
 */
 
var page_chargee = false;
var noresult = false;

function pgload() {
  try {
    return document.getElementById("pgload");
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pgload : ' + e);
  }
}

 
 /*****************************************************
 *  @return l'id de l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree_id(){
  return 'comptes_tree';
}

/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree(){
  try {
    return document.getElementById(get_tree_id());
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#get_tree : ' + e);
  }
}


function init() {

  try {
    
    var x = (screen.width / 2) - 400;
    var y = (screen.height / 2) - 200;
    window.resizeTo(800,300);
    window.moveTo(x,y);
    var num_compte = window.arguments[0].replace(' ','');
    document.getElementById('num_compte').value = num_compte;
    init_tree();
    document.getElementById('num_compte').focus();

  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#init : ' + e);
  }

}

function init_tree() {
  try {
    var paramlist = "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    var numc = document.getElementById('num_compte').value;
    var libc = document.getElementById('lib_compte').value;
    if (! isEmpty(numc)) {
      paramlist += "&Numero_Compte=" + numc;
    }
    if (! isEmpty(libc)) {
      paramlist += "&Libelle=" + libc;
    }
    load_rdf_async(get_tree_id(), getUrlOpeneas(paramlist), fin_chargement); 
    get_tree().builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#init_tree : ' + e);
  }
}

function fin_chargement(ds) {
  try {
    if (get_tree().view == null) {
      var libc = document.getElementById('num_compte').value;
      if (noresult || isEmpty(libc)) {
        document.getElementById('num_compte').value = document.getElementById('lib_compte').value;
        document.getElementById('lib_compte').value = '';
        pgload().collapsed = true;
        page_chargee = true;
      } else {
        document.getElementById('lib_compte').value = libc;
        document.getElementById('num_compte').value = '';
        noresult = true;
        init_tree();
        return false;
      }
    } else {
      pgload().collapsed = true;
      page_chargee = true;
    }
    noresult = false;
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#fin_chargement : ' + e);
  }
}


function delete_tree() {
  try {
    var database = get_tree().database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#delete_tree : ' + e);
  }
}

function reinit_tree(){
  try {
    get_tree().currentIndex = -1;
  } catch (e) {}
  pgload().collapsed = false;
  page_chargee = false;
  delete_tree();
  init_tree();
}

function reporter(tree) {
  try {
    var selection = tree.contentView.getItemAtIndex(tree.currentIndex);
    var text = selection.firstChild.firstChild.getAttribute("label");
    document.getElementById("num_compte").value = text;
  } catch (e) {
    if (e.name == 'NS_ERROR_ILLEGAL_VALUE') {
      tree.view.selectedIndex = -1;
    } else {
      recup_erreur('erreur dans compta/util/rechcompte.js#reporter : ' + e);
    }
  }
}

function ok() {

  try {
  
    if (doOK()){
      var num_compte = document.getElementById('num_compte').value;
      var id = window.arguments[1];
      window.opener.document.getElementById(id).value = num_compte;
      window.opener.force = true;
      window.close();
    } else {
      document.getElementById('num_compte').focus();
    }

  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#ok : ' + e);
  }

}

function doOK() {
  
  try {
  
    var input_compte = document.getElementById('num_compte');
//    while (input_compte.value.length < 8) input_compte.value += '0';
    var num_compte = input_compte.value;
    if (isEmpty(num_compte)) return false;
    if (num_compte.length < 8) {
      reinit_tree();
      return false;
    } else {
      if (belongs(num_compte)) {
        return true;
      } else {
        var msg = "Le compte numro " + num_compte + " n'existe pas. ";
        if (window.arguments[2]) {
          msg += "Voulez-vous crer un nouveau compte ?";
          if (confirm(msg)) {
            creer_compte();
            return false;
          } else {
            return false;
          }
        } else {
          alert(msg);
          return false;
        }
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#doOK : ' + e);
  } 

}

function creer_compte(){
  try {
    var num_compte = document.getElementById('num_compte').value;
    var url = "chrome://opensi/content/compta/util/nouveau_compte.xul?" + cookie();
    window.openDialog(url,'nouvcompte','chrome,modal',num_compte);
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#creer_compte : ' + e);
  }
}

function keypress(e) {
  try {
    switch (e.keyCode) {
      case 33: // 'PageUp'
        select_up();
        break;
      case 34: // 'PageDown'
        select_down();
        break;
      case 38: // '^'
        select_prev();
        break;
      case 40: // 'v'
        select_next();
        break;
      case 13: // <Enter>
        ok();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#keypress : ' + e);
  }
}


/****************************************************
 *  slection de la ligne prcdente  la ligne slectionne
 ****************************************************/
function select_prev(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 1;
    if (index >= 0) {
      select_row(index);
    } else {
      select_begin();
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#select_prev : ' + e);
  }
}

/****************************************************
 *  slection de la ligne suivante  la ligne slectionne
 ****************************************************/
function select_next(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex + 1;
    if (index < v.rowCount ) {
      select_row(index);
    } else {
      select_end();
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#select_next : ' + e);
  }
}

/****************************************************
 *  slection de la premire ligne de l'arbre
 ****************************************************/
function select_begin(){
  select_row(0);
}

/****************************************************
 *  slection de la dernire ligne de l'arbre
 ****************************************************/
function select_end(){
  try {
    var v = get_tree().view;
    select_row(v.rowCount - 1);
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#select_end : ' + e);
  }
}

/****************************************************
 *  slection d'une ligne 10 lignes au dessus de la ligne slectionne
 ****************************************************/
function select_up(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 10;
    if (index < 0) {
      select_begin();
    } else {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#select_up : ' + e);
  }
}

/****************************************************
 *  slection d'une ligne 10 lignes en dessous de la ligne slectionne
 ****************************************************/
function select_down(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex + 10 ;
    if (index >= v.rowCount) {
      select_end();
    } else {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#select_down : ' + e);
  }
}

/****************************************************
 *  selectionne un ligne dans l'arbre.
 *  @param index : l'index de la ligne de l'arbre  slectionner
 ****************************************************/
function select_row(index) {
  try {
    var tree = get_tree();
    tree.treeBoxObject.focused = true;
    tree.view.selection.select(index);
    tree.treeBoxObject.ensureRowIsVisible(index);
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#select_row : ' + e);
  }
}

function belongs(num_compte) {

  try {
    
    var v = get_tree().view;
    if (v == null) return false;
    for (i=0;i<v.rowCount;i++) {
      if (num_compte.toUpperCase() == v.getCellText(i,'num').toUpperCase())  {
        return true;
      }
    }
    return false;
    
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#belongs : ' + e);
    return false;
  }

}

function cancel() {

  try {
  
    var id = window.arguments[1];
    window.opener.document.getElementById(id).value = '';
    window.opener.force = true;
    window.close();

  } catch (e) {
    recup_erreur('erreur dans compta/util/rechcompte.js#cancel : ' + e);
  }

}