/******************************************************************************/
/* OpenSI Comptabilit? : Outils libre de comptabilit? d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var base_calcul;
var taux_tva;


function init() {
  try {
		
		var corps = cookie() + "&Page=Facturation/Stocks/getInfosTarifArticle.tmpl&ContentType=xml&Article_Id="+ ParamValeur("Article_Id");

    var p = requeteHTTP(corps);

		if (p.status != "200") {
      alert("Rception erreur " + p.status);
    } 
  	else {			
    	var contenu = p.responseXML.documentElement;
			
			document.getElementById('Prix_Revient').value = contenu.getAttribute('Prix_Revient');
			taux_tva = contenu.getAttribute('Taux_TVA');
			base_calcul = contenu.getAttribute('Base_Calcul')==1;
		}
		
		initModeTarifQte();
		switchMode();
		annulerLigne();
		init_tree_tarifs();
		
		window.sizeToContent();
		window.outerHeight = 400;
		
		var x = (screen.width / 2) - (window.outerWidth / 2);
    var y = (screen.height / 2) - (window.outerHeight / 2);
    window.moveTo(x,y);

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#init : ' + e);
  }
}


function init_tree_tarifs() {
  try {
    
    var article_id = ParamValeur("Article_Id");
		
    var paramlist = "&Page=Facturation/GetRDF/tarifs_qte.tmpl&ContentType=xml&Article_Id="+ article_id +"&Taux_TVA="+ taux_tva;
		
		if (base_calcul) {
			paramlist += "&Prix_Achat="+ document.getElementById('Prix_Revient').value;
		}
		
    load_rdf('tarifs_qte', getUrlOpeneas(paramlist));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#init_tree_tarifs : ' + e);
  }
}


function delete_tree_tarifs() {
  try {
	
    var database = document.getElementById("tarifs_qte").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('tarifs_qte').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#delete_tree_tarifs : ' + e);
  }
}

function reporterTarif() {
  try {
		
		tree = document.getElementById('tarifs_qte');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
			window.opener.document.getElementById('Tarif_Id').value = tree.view.getCellText(tree.currentIndex,'ColTarif_Id');
			window.close();
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#reporterTarif : ' + e);
  }
}

function validerLigne() {
  try {

		var article_id = ParamValeur("Article_Id");

		var quantite = document.getElementById('Quantite_Ligne').value;
		var prix = document.getElementById('Prix_Ligne').value;
		var lib_ext = document.getElementById('Lib_Ext').value;
		var lib_int = document.getElementById('Lib_Int').value;
		var coeff = document.getElementById('Coeff_Ligne').value;
		var tarif_id = document.getElementById('Tarif_Id').value;

		if (isEmpty(prix) || !isPositiveOrNull(prix)) {
			showWarning("Prix HT incorrect !");
		}
		else if (isEmpty(quantite) || !isPositiveInteger(quantite)) {
			showWarning("Quantit incorrecte !");
		}
		else if (base_calcul && (isEmpty(coeff) || !isPositive(coeff))) {
			showWarning("Coefficient incorrect !");
		}
		else {
		
			var corps;
		
			if (isEmpty(tarif_id)) {
				corps = cookie() + "&Page=Facturation/Stocks/ajouterTarifQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id);
			}
			else {
				corps = cookie() + "&Page=Facturation/Stocks/modifierTarifQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id) +"&Tarif_Id="+ tarif_id;
			}
			
			corps += "&Quantite="+ quantite +"&Prix="+ prix +"&Lib_Ext="+ urlEncode(lib_ext) +"&Lib_Int="+ urlEncode(lib_int) +"&Coeff="+ coeff; 
			var p = requeteHTTP(corps);

			if (p.status != "200") {
  			alert("Rception erreur " + p.status);
			}
			else {
  			delete_tree_tarifs();
				init_tree_tarifs();

				annulerLigne();
			}
		}
  
  } catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#validerLigne : ' + e);
	} 
}


function switchMode() {
  try {
	
		var b = !document.getElementById('SwitchMode').checked;
	
		document.getElementById('boxBoutons').collapsed = b;
		document.getElementById('boxLigne').collapsed = b;
		document.getElementById('boxRevient').collapsed = b;
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#switchMode : ' + e);
	}
}


function initModeTarifQte() {
  try {
	
		if (base_calcul) {
			document.getElementById('ColMarge').collapsed = false;
			document.getElementById('ColCoeff').collapsed = false;
			document.getElementById('Marge_Ligne').collapsed = false;
			document.getElementById('Coeff_Ligne').collapsed = false;
			document.getElementById('Prix_Revient').collapsed = false;
			document.getElementById('lblPrix_Revient').collapsed = false;
		}
		else {
			document.getElementById('ColMarge').collapsed = true;
			document.getElementById('ColCoeff').collapsed = true;
			document.getElementById('Marge_Ligne').collapsed = true;
			document.getElementById('Coeff_Ligne').collapsed = true;
			document.getElementById('Prix_Revient').collapsed = true;
			document.getElementById('lblPrix_Revient').collapsed = true;
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#initModeTarifQte : ' + e);
	}
}


function annulerLigne() {
  try {
	
		document.getElementById('Lib_Int').value = "";
		document.getElementById('Lib_Ext').value = "";
		document.getElementById('Quantite_Ligne').value = "";
		document.getElementById('Prix_Ligne').value = "";
		document.getElementById('Marge_Ligne').value = "";
		document.getElementById('Coeff_Ligne').value = "";
		document.getElementById('Prix_Ligne_TTC').value = "";
		document.getElementById('Tarif_Id').value = "";
		document.getElementById('bSupprimer').disabled = true;
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#annulerLigne : ' + e);
	}
}


function calculerLigne(t) {
  try {
	
		var tva = parseFloat(taux_tva)/100 + 1;		
		
		var pr = document.getElementById('Prix_Revient').value;

		if (t=="h") {
			var pvht = parseFloat(document.getElementById('Prix_Ligne').value);
			document.getElementById('Coeff_Ligne').value = formatNombre(pvht / pr, "0.#####");
			document.getElementById('Prix_Ligne_TTC').value = formatNombre(pvht * tva, "0.00");
			document.getElementById('Marge_Ligne').value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else if (t=="c") {
			var pvht = parseFloat(document.getElementById('Coeff_Ligne').value) * pr;
			document.getElementById('Prix_Ligne').value = formatNombre(pvht, "0.00");
			document.getElementById('Prix_Ligne_TTC').value = formatNombre(pvht * tva, "0.00");
			document.getElementById('Marge_Ligne').value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else if (t=="t") {
			var pvht = parseFloat(document.getElementById('Prix_Ligne_TTC').value) / tva;
			document.getElementById('Prix_Ligne').value = formatNombre(pvht, "0.00");
			document.getElementById('Coeff_Ligne').value = formatNombre(pvht / pr, "0.#####");
			document.getElementById('Marge_Ligne').value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else if (t=="m") {

			if (parseFloat(document.getElementById('Marge_Ligne').value)>=100) {
				showWarning("Le pourcentage de marge doit tre infrieur  100 % !");
			}
			else {				
				var pvht = pr / (1 - parseFloat(document.getElementById('Marge_Ligne').value)/100);
				document.getElementById('Prix_Ligne').value = formatNombre(pvht, "0.00");
				document.getElementById('Coeff_Ligne').value = formatNombre(pvht / pr, "0.#####");
				document.getElementById('Prix_Ligne_TTC').value = formatNombre(pvht * tva, "0.00");
			}
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#calculerLigne : ' + e);
	}
}


function reporterLigne() {
  try {
		
		var tree = document.getElementById('tarifs_qte');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById('Lib_Int').value = tree.view.getCellText(tree.currentIndex,'ColLibInt');
			document.getElementById('Lib_Ext').value = tree.view.getCellText(tree.currentIndex,'ColLibExt');
			document.getElementById('Quantite_Ligne').value = tree.view.getCellText(tree.currentIndex,'ColQuantite');
			document.getElementById('Prix_Ligne').value = tree.view.getCellText(tree.currentIndex,'ColHT');
			document.getElementById('Marge_Ligne').value = tree.view.getCellText(tree.currentIndex,'ColMarge');
			document.getElementById('Coeff_Ligne').value = tree.view.getCellText(tree.currentIndex,'ColCoeff');
			document.getElementById('Prix_Ligne_TTC').value = tree.view.getCellText(tree.currentIndex,'ColTTC');
			document.getElementById('Tarif_Id').value = tree.view.getCellText(tree.currentIndex,'ColTarif_Id');
			document.getElementById('bSupprimer').disabled = false;
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#reporterLigne : ' + e);
	}
}

function supprimerLigne() {
  try {
	
		var tarif_id = document.getElementById("Tarif_Id").value;

		if (window.confirm("Supprimer la ligne de tarif ?")) {

    	var corps = cookie() + "&Page=Facturation/Stocks/supprimerTarifQte.tmpl&ContentType=xml&Tarif_Id="+ tarif_id;
    	var p = requeteHTTP(corps);

			if (p.status != "200") {
      	alert("Rception erreur " + p.status);
    	} 
  		else {			
    		delete_tree_tarifs();
    		init_tree_tarifs();
				annulerLigne();
			}
		}
			
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/choix_tarif.js#supprimerLigne : ' + e);
	}
}

