/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var mode; // mode cration ou modification
var com_valide;
var mode_fact;
var bon_id = 0;


function init() {    
  try {  
	
		paramlist = "&Page=Facturation/GetRDF/liste_commerciaux.tmpl&ContentType=xml";
  	load_rdf_async('Login_Resp', getUrlOpeneas(paramlist), initResp);
	 
  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#init : ' + e);
  }
}


function initResp() {
  try {
	
		mode = ParamValeur("Mode");
		
		if (mode=="C") {
			nouvelle_affaire();
		}
		else {
			charger_affaire(ParamValeur("Affaire_Id"));
		}
	 
	 	window.parent.addEventListener("close",demandeEnregistrement,false);
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#initResp : ' + e);
  }
}


function desinit() {
	try {
	
		window.parent.removeEventListener("close",demandeEnregistrement,false);
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#desinit : ' + e);
  }	
}


function init_tree_commandes(affaire_id) {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/commandes_affaire.tmpl&ContentType=xml&Affaire_Id="+ affaire_id;
    load_rdf('commandes', getUrlOpeneas(paramlist));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#init_tree_commandes : ' + e);
  }
}

function delete_tree_commandes() {
  try {
    
    var database = document.getElementById("commandes").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('commandes').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#delete_tree_commandes : ' + e);
  }
}


function init_tree_bons(affaire_id) {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/bons_affaire.tmpl&ContentType=xml&Affaire_Id="+ affaire_id;
    load_rdf('bons', getUrlOpeneas(paramlist));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#init_tree_bons : ' + e);
  }
}

function delete_tree_bons() {
  try {
    
    var database = document.getElementById("bons").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('bons').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#delete_tree_bons : ' + e);
  }
}


function init_tree_factures(affaire_id) {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/factures_affaire.tmpl&ContentType=xml&Affaire_Id="+ affaire_id;
    load_rdf('factures', getUrlOpeneas(paramlist));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#init_tree_factures : ' + e);
  }
}


function delete_tree_factures() {
  try {
    
    var database = document.getElementById("factures").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('factures').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#delete_tree_factures : ' + e);
  }
}


function nouvelle_affaire() {
  try {
	
		mode = "C";
		document.getElementById('chercher_client').collapsed = false;
		document.getElementById('chercher_adresse').collapsed = true;
		document.getElementById('chercher_adresse').disabled = false;
		document.getElementById('bSupprimer').collapsed = true;
		document.getElementById('bInter').disabled = true;
		document.getElementById('bEnregistrer').disabled = false;
		
		document.getElementById('bNouvelleCommande').disabled = true;
		document.getElementById('bNouveauBon').disabled = true;
		document.getElementById('bNouveauFacture').disabled = true;
		document.getElementById('Type_Fact').disabled = false;
		document.getElementById('Login_Resp').disabled = false;
		document.getElementById('Interlocuteur').disabled = false;
		document.getElementById('Nom_Affaire').disabled = false;
		document.getElementById('Commentaires').disabled = false;
		document.getElementById('Imp_Com').disabled = false;
		document.getElementById('Receptionnaire').disabled = false;
		
		document.getElementById('labelClient').setAttribute("label", "Client");
		
		document.getElementById('Affaire_Id').value = "";
		document.getElementById('Numero').value = "";
		document.getElementById('Client_Id').value = "";
		document.getElementById('Nom_Affaire').value = "";
		document.getElementById('Raison_Sociale').value = "";
		document.getElementById('Adresse_Fact').value = "";
		document.getElementById('CP_Fact').value = "";
		document.getElementById('Comp_Adresse_Fact').value = "";
		document.getElementById('Ville_Fact').value = "";
		document.getElementById('Pays_Fact').value = "";
		document.getElementById('Commentaires').value = "";
		document.getElementById('Type_Fact').value = "C";
		document.getElementById('Login_Resp').selectedIndex = 0;
		document.getElementById('Etat').value = "";
		document.getElementById('Status').value = "";
		
		document.getElementById('Nom_Liv').value = "";
		document.getElementById('Adresse_Liv').value = "";
		document.getElementById('Comp_Adresse_Liv').value = "";
		document.getElementById('CP_Liv').value = "";
		document.getElementById('Ville_Liv').value = "";
		document.getElementById('Pays_Liv').value = "";
		document.getElementById('Receptionnaire').value = "";
		document.getElementById('Imp_Com').checked = false;
	
		document.getElementById('Creation').label = "";
		document.getElementById('Modification').label = "";
		document.getElementById('Creation').collapsed = true;
		document.getElementById('Modification').collapsed = true;
		document.getElementById('Fiche').label = "";
		
		delete_tree_commandes();
		delete_tree_bons();
		delete_tree_factures();
		delete_contacts();	
		
		setModifie(false);
		
		rechercherClient();
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#nouvelle_affaire : ' + e);
  }
}


function charger_affaire(affaire_id) {
  try {
		
		delete_tree_commandes();
		delete_tree_bons();
		delete_tree_factures();
		init_tree_commandes(affaire_id);
		init_tree_bons(affaire_id);
		init_tree_factures(affaire_id);
		
		mode = "M";
		document.getElementById('chercher_client').collapsed = true;
		document.getElementById('chercher_adresse').disabled = false;
		document.getElementById('bNouvelleCommande').disabled = false;
		document.getElementById('bEnregistrer').disabled = false;
		document.getElementById('bSupprimer').collapsed = false;
		document.getElementById('bInter').disabled = false;
		document.getElementById('Type_Fact').disabled = false;
		document.getElementById('Login_Resp').disabled = false;
		document.getElementById('Interlocuteur').disabled = false;
		document.getElementById('Nom_Affaire').disabled = false;
		document.getElementById('Commentaires').disabled = false;
		document.getElementById('Imp_Com').disabled = false;
		document.getElementById('Receptionnaire').disabled = false;
		
		document.getElementById('Affaire_Id').value = affaire_id;
		
		var corps = cookie() + "&Page=Facturation/Affaires/getAffaire.tmpl&ContentType=xml&Affaire_Id="+ urlEncode(affaire_id);
		
		var p = requeteHTTP(corps);              

  	if (p.status != "200") {
    	alert("Rception erreur " + p.status);
  	} 
		else {
			var contenu = p.responseXML.documentElement;
			
			document.getElementById('Client_Id').value = contenu.getAttribute("Client_Id");
			document.getElementById('labelClient').setAttribute("label", "Client N "+ contenu.getAttribute("Client_Id"));
			document.getElementById('Numero').value = contenu.getAttribute("Numero");
			document.getElementById('Nom_Affaire').value = contenu.getAttribute("Nom_Affaire");
			document.getElementById('Raison_Sociale').value = contenu.getAttribute("Raison_Sociale");
			document.getElementById('Adresse_Fact').value = contenu.getAttribute("Adresse_Fact");
			document.getElementById('Comp_Adresse_Fact').value = contenu.getAttribute("Comp_Adresse_Fact");
			document.getElementById('CP_Fact').value = contenu.getAttribute("CP_Fact");
			document.getElementById('Ville_Fact').value = contenu.getAttribute("Ville_Fact");
			document.getElementById('Pays_Fact').value = contenu.getAttribute("Pays_Fact");
			document.getElementById('Commentaires').value = contenu.getAttribute("Commentaires");
			document.getElementById('Etat').value = getEtat(contenu.getAttribute("Etat"));
			document.getElementById('Login_Resp').value = contenu.getAttribute("Login_Resp");
			document.getElementById('Type_Fact').value = contenu.getAttribute("Type_Fact");
			mode_fact = contenu.getAttribute("Type_Fact");
			document.getElementById('Status').value = contenu.getAttribute("Etat");
			com_valide = contenu.getAttribute("Com_Valide");
			
			document.getElementById('Nom_Liv').value = contenu.getAttribute("Nom_Liv");
			document.getElementById('Adresse_Liv').value = contenu.getAttribute("Adresse_Liv");
			document.getElementById('Comp_Adresse_Liv').value = contenu.getAttribute("Comp_Adresse_Liv");
			document.getElementById('CP_Liv').value = contenu.getAttribute("CP_Liv");
			document.getElementById('Ville_Liv').value = contenu.getAttribute("Ville_Liv");
			document.getElementById('Pays_Liv').value = contenu.getAttribute("Pays_Liv");
			document.getElementById('Receptionnaire').value = contenu.getAttribute("Receptionnaire");
			document.getElementById('Imp_Com').checked = (contenu.getAttribute("Imp_Com")==1);
			
			
			if (isEmpty(com_valide)) {
				document.getElementById('bNouveauBon').disabled = true;
				document.getElementById('bNouveauFacture').disabled = true;
				document.getElementById('bNouvelleCommande').disabled = false;
			} 
			else {
				document.getElementById('bNouveauBon').disabled = false;
				document.getElementById('bNouveauFacture').disabled = false;
				document.getElementById('bNouvelleCommande').disabled = true;
				
				var nb_facture_total = contenu.getAttribute("Nb_Facture_Non_Gen") + contenu.getAttribute("Nb_Facture_Gen");
				
				if (mode_fact=='G' || contenu.getAttribute("Etat")=='C'
							|| (contenu.getAttribute("Nb_Facture_Non_Gen")>0 && mode_fact=="B")
							|| ((nb_facture_total>0 || contenu.getAttribute("Soldee")==0) && mode_fact=="C")) {
					document.getElementById('bNouveauFacture').disabled = true;
				}
			
				
				if (contenu.getAttribute("Soldee")==1 || contenu.getAttribute("Nb_Bons_Non_Gen")>0) {
					document.getElementById('bNouveauBon').disabled = true;
				}
				
				if (nb_facture_total>0) {
					document.getElementById('Type_Fact').disabled = true;
					document.getElementById('Interlocuteur').disabled = true;
					document.getElementById('bInter').disabled = true;
					document.getElementById('Login_Resp').disabled = true;
					document.getElementById('Nom_Affaire').disabled = true;
					document.getElementById('Commentaires').disabled = true;
					document.getElementById('Imp_Com').disabled = true;
					document.getElementById('Receptionnaire').disabled = true;
					document.getElementById('bEnregistrer').disabled = true;
					document.getElementById('chercher_adresse').disabled = true;
				}
				
				if (contenu.getAttribute("Nb_Facture_Gen")>0 || contenu.getAttribute("Nb_Bons_Gen")>0) {
					document.getElementById('bSupprimer').disabled = true;
				}
			}			
			
			if (contenu.getAttribute("Nb_Com")>0) {
				document.getElementById('bNouvelleCommande').disabled = true;
			}
			
			charger_contacts(contenu.getAttribute("Num_Inter"));
		
			document.getElementById('Creation').label = "Affaire cre le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
			document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
			document.getElementById('Fiche').label = "Affaire N "+ contenu.getAttribute('Numero') +" - "+ contenu.getAttribute('Nom_Affaire');
			document.getElementById('Creation').collapsed = false;
			document.getElementById('Modification').collapsed = false;
		}
		
		setModifie(false);
			
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#charger_affaire : ' + e);
  }
}


function supprimer_affaire() {
	try {

		if (window.confirm("Voulez-vous vraiment supprimer cette affaire ?")) {
			var corps = cookie() + "&Page=Facturation/Affaires/supprimerAffaire.tmpl&ContentType=xml&Affaire_Id="+ document.getElementById('Affaire_Id').value;

			var p = requeteHTTP(corps);              
 			if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				showMessage("L'affaire a t supprime");
				var page = "chrome://opensi/content/facturation/user/affaires/menu_affaires.xul?"+ cookie();
    		window.location = page;
			}
		}
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#supprimer_affaire : ' + e);
  }
}


function ouvrir_affaire_win(affaire_id) {
  try {
	
		charger_affaire(affaire_id);
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#ouvrir_affaire_win : ' + e);
  }
}


function setBonId_win(id) {
  try {
	
		bon_id = id;
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#setBonId_win : ' + e);
  }
}


function enregistrer_affaire() {
  try {
	
		var corps;
	
		if (mode=="C") {
			corps = cookie() + "&Page=Facturation/Affaires/creerAffaire.tmpl&ContentType=xml";
		}
		else {
			corps = cookie() + "&Page=Facturation/Affaires/modifierAffaire.tmpl&ContentType=xml&Affaire_Id="+ document.getElementById('Affaire_Id').value;
		}
		
		
		var client_id = document.getElementById('Client_Id').value;
		var nom_affaire = document.getElementById('Nom_Affaire').value;
		var num_inter = document.getElementById('Interlocuteur').value;
		var raison_sociale = document.getElementById('Raison_Sociale').value;
		var adresse_fact = document.getElementById('Adresse_Fact').value;
		var cp_fact = document.getElementById('CP_Fact').value;
		var comp_adresse_fact = document.getElementById('Comp_Adresse_Fact').value;
		var ville_fact = document.getElementById('Ville_Fact').value;
		var pays_fact = document.getElementById('Pays_Fact').value;
		var commentaires = document.getElementById('Commentaires').value;
		var login_resp = document.getElementById('Login_Resp').value;
		var type_fact = document.getElementById('Type_Fact').value;
		
		var nom_liv = document.getElementById('Nom_Liv').value;
		var adresse_liv = document.getElementById('Adresse_Liv').value;
		var comp_adresse_liv = document.getElementById('Comp_Adresse_Liv').value;
		var cp_liv = document.getElementById('CP_Liv').value;
		var ville_liv = document.getElementById('Ville_Liv').value;
		var pays_liv = document.getElementById('Pays_Liv').value;
		var receptionnaire = document.getElementById('Receptionnaire').value;
		var imp_com = (document.getElementById('Imp_Com').checked?"1":"0");
		
		corps += "&Client_Id="+ urlEncode(client_id) +"&Nom_Affaire="+ urlEncode(nom_affaire) +"&Num_Inter="+ num_inter +"&Raison_Sociale="+ urlEncode(raison_sociale);
		corps += "&Adresse_Fact="+ urlEncode(adresse_fact) +"&CP_Fact="+ urlEncode(cp_fact) +"&Comp_Adresse_Fact="+ urlEncode(comp_adresse_fact);
		corps += "&Ville_Fact="+ urlEncode(ville_fact) +"&Pays_Fact="+ urlEncode(pays_fact) +"&Commentaires="+ urlEncode(commentaires) +"&Login_Resp="+ urlEncode(login_resp);
		corps += "&Type_Fact="+ type_fact +"&Imp_Com="+ imp_com +"&Nom_Liv="+ urlEncode(nom_liv) +"&Adresse_Liv="+ urlEncode(adresse_liv);
		corps += "&Comp_Adresse_Liv="+ urlEncode(comp_adresse_liv) +"&CP_Liv="+ urlEncode(cp_liv) +"&Ville_Liv="+ urlEncode(ville_liv);
		corps += "&Pays_Liv="+ urlEncode(pays_liv) +"&Receptionnaire="+ urlEncode(receptionnaire);
		
		
		if (isEmpty(client_id)) {
			showWarning("Vous devez choisir un client avant d'enregistrer l'affaire !");
		}
		else {		
			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				var contenu = p.responseXML.documentElement;

				if (mode=="C") {
					var affaire_id = contenu.getAttribute("Affaire_Id");
					charger_affaire(affaire_id);
				}
				else {
					var affaire_id = document.getElementById('Affaire_Id').value
					mode_fact = type_fact;
					charger_affaire(affaire_id);
				}
				
				setModifie(false);
			}
		}
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#enregistrer_affaire : ' + e);
  }
}


function charger_coordfact() {
  try {

		var client_id = document.getElementById("Client_Id").value;

		var corps = cookie() + "&Page=Facturation/Affaires/getCoordFact.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id);
		
		var p = requeteHTTP(corps);              

  	if (p.status != "200") {
    	alert("Rception erreur " + p.status);
  	} 
		else {
			var contenu = p.responseXML.documentElement;
			
			document.getElementById("Raison_Sociale").value = contenu.getAttribute("Raison_Sociale");
			document.getElementById("Adresse_Fact").value = contenu.getAttribute("Adresse_Fact");
			document.getElementById("CP_Fact").value = contenu.getAttribute("CP_Fact");
			document.getElementById("Comp_Adresse_Fact").value = contenu.getAttribute("Comp_Adresse_Fact");
			document.getElementById("Ville_Fact").value = contenu.getAttribute("Ville_Fact");
			document.getElementById("Pays_Fact").value = contenu.getAttribute("Pays_Fact");
			document.getElementById("Type_Fact").value = contenu.getAttribute("Type_Fact");
			document.getElementById("Login_Resp").value = contenu.getAttribute("Login_Resp");
			
			document.getElementById("Nom_Liv").value = contenu.getAttribute("Nom_Liv");
			document.getElementById("Adresse_Liv").value = contenu.getAttribute("Adresse_Liv");
			document.getElementById("Comp_Adresse_Liv").value = contenu.getAttribute("Comp_Adresse_Liv");
			document.getElementById("CP_Liv").value = contenu.getAttribute("CP_Liv");
			document.getElementById("Ville_Liv").value = contenu.getAttribute("Ville_Liv");
			document.getElementById("Pays_Liv").value = contenu.getAttribute("Pays_Liv");
			document.getElementById("Receptionnaire").value = contenu.getAttribute("Receptionnaire");
			
			document.getElementById('bInter').disabled = false;
			document.getElementById('chercher_adresse').collapsed = false;
			document.getElementById('labelClient').setAttribute("label", "Client N "+ client_id);
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#charger_coordfact : ' + e);
  }
}


function rechercherClient() {
  try {
	
		var url = "chrome://opensi/content/facturation/user/clients/rech_client.xul?"+ cookie() +"&Nouv=false&Modif_Action=false&Field_Client=Client_Id&Bloque=true";
    window.openDialog(url,'','chrome,modal');
		
		if (document.getElementById("Client_Id").value != "") {
			setModifie(true);
			charger_coordfact();
			charger_contacts(0);
		}
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#rechercherClient : ' + e);
  }
}


function rechercherAdresse() {
  try {
	
		var url = "chrome://opensi/content/facturation/user/affaires/choix_adresse.xul?"+ cookie() +"&Client_Id="+ urlEncode(document.getElementById('Client_Id').value);
    window.openDialog(url,'','chrome,modal');
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#rechercherAdresse : ' + e);
  }
}


var valContact;

function charger_contacts(val) {
  try {
		
		delete_contacts();
		
		valContact = val;
		
		var client_id = document.getElementById("Client_Id").value;
		
		var paramlist = "&Page=Facturation/GetRDF/contacts_client.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id);
    load_rdf_async('Interlocuteur', getUrlOpeneas(paramlist), initContacts);
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#charger_contacts : ' + e);
  }
}


function delete_contacts() {
  try {
	
    var database = document.getElementById("Interlocuteur").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('Interlocuteur').builder.rebuild();
		document.getElementById('Interlocuteur').selectedIndex = 0;
		
  } catch (e) {
    recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#delete_contacts: ' + e);
  }
}


function initContacts() {
  try {

		var modifie = document.getElementById("Modifie").value;

		if (mode=="C") {
			document.getElementById('Interlocuteur').selectedIndex = 0;
		}
		else {
			document.getElementById('Interlocuteur').value = valContact;
		}
		
		if (modifie!="y") { setModifie(false); }

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#initContacts : ' + e);
  }
}


function getEtat(etat) {
  try {
	
		switch(etat) {
			case "N": return "NOUVELLE";
			case "D": return "EN COURS";
			case "V": return "VALID\u00C9E";
			case "A": return "ANNUL\u00C9E";
			case "C": return "CLOTUR\u00C9E";
			default:  return "";
		}
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#getEtat : ' + e);
  }
}


function editerCommande(mode_edit) {
  try {

		demandeEnregistrement();

		var affaire_id = document.getElementById("Affaire_Id").value;

		var liste_param = "&Raison_Sociale="+ urlEncode(document.getElementById("Raison_Sociale").value);
		liste_param += "&Adresse_Fact="+ urlEncode(document.getElementById("Adresse_Fact").value);
		liste_param += "&CP_Fact="+ urlEncode(document.getElementById("CP_Fact").value);
		liste_param += "&Ville_Fact="+ urlEncode(document.getElementById("Ville_Fact").value);
		liste_param += "&Client_Id="+ urlEncode(document.getElementById("Client_Id").value);
		liste_param += "&Nom_Affaire="+ urlEncode(document.getElementById("Nom_Affaire").value);
		liste_param += "&Responsable="+ urlEncode(document.getElementById("Login_Resp").getAttribute("label"));
		liste_param += "&EtatAffaire="+ urlEncode(document.getElementById("Status").value);
		liste_param += "&Num_Affaire="+ urlEncode(document.getElementById("Numero").value);

		if (mode_edit=="C") {
			var page = "chrome://opensi/content/facturation/user/affaires/edition_commande.xul?"+ cookie() +"&Mode=C&Affaire_Id="+ affaire_id + liste_param;
    	window.location = page;
		}
		else {
			var tree = document.getElementById('commandes');
			
			if (tree.view!=null && tree.currentIndex!=-1) {
			
				var com_id = tree.view.getCellText(tree.currentIndex,'ColCom_Id');
				var page = "chrome://opensi/content/facturation/user/affaires/edition_commande.xul?"+ cookie() +"&Com_Id="+ com_id +"&Mode=M&Affaire_Id="+ affaire_id + liste_param;
    		window.location = page;
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#editerCommande : ' + e);
  }
}


function pressOnTree(elem,ev) {
  try {
	
		switch(ev.keyCode) {
      case 13: // 'Enter'
        switch(elem) {
					case "C": editerCommande("M");
					case "B": editerBon("M");
					case "F": editerFacture("M");
				}
        break;
    }
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#pressOnTree : ' + e);
  }
}


function editerBon(mode_edit) {
  try {

		demandeEnregistrement();

		var affaire_id = document.getElementById("Affaire_Id").value;

		var liste_param = "&Raison_Sociale="+ urlEncode(document.getElementById("Raison_Sociale").value);
		liste_param += "&Adresse_Fact="+ urlEncode(document.getElementById("Adresse_Fact").value);
		liste_param += "&CP_Fact="+ urlEncode(document.getElementById("CP_Fact").value);
		liste_param += "&Ville_Fact="+ urlEncode(document.getElementById("Ville_Fact").value);
		liste_param += "&Client_Id="+ urlEncode(document.getElementById("Client_Id").value);
		liste_param += "&Nom_Affaire="+ urlEncode(document.getElementById("Nom_Affaire").value);
		liste_param += "&Responsable="+ urlEncode(document.getElementById("Login_Resp").getAttribute("label"));
		liste_param += "&ComValide="+ com_valide;
		liste_param += "&Num_Affaire="+ urlEncode(document.getElementById("Numero").value);
		
		if (mode_edit=="C") {
			var page = "chrome://opensi/content/facturation/user/affaires/edition_livraison.xul?"+ cookie() +"&Mode=C&Affaire_Id="+ affaire_id + liste_param;
    	window.location = page;
		}
		else {
			var tree = document.getElementById('bons');
			
			if (tree.view!=null && tree.currentIndex!=-1) {
			
				var bon_id = tree.view.getCellText(tree.currentIndex,'ColBon_Id');			
				var page = "chrome://opensi/content/facturation/user/affaires/edition_livraison.xul?"+ cookie() +"&Mode=M&Bon_Id="+ bon_id +"&Affaire_Id="+ affaire_id + liste_param;
    		window.location = page;
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#editerBon : ' + e);
  }
}


function editerFacture(mode_edit) {
  try {

		demandeEnregistrement();

		var affaire_id = document.getElementById("Affaire_Id").value;

		var liste_param = "&Raison_Sociale="+ urlEncode(document.getElementById("Raison_Sociale").value);
		liste_param += "&Adresse_Fact="+ urlEncode(document.getElementById("Adresse_Fact").value);
		liste_param += "&CP_Fact="+ urlEncode(document.getElementById("CP_Fact").value);
		liste_param += "&Ville_Fact="+ urlEncode(document.getElementById("Ville_Fact").value);
		liste_param += "&Client_Id="+ urlEncode(document.getElementById("Client_Id").value);
		liste_param += "&Nom_Affaire="+ urlEncode(document.getElementById("Nom_Affaire").value);
		liste_param += "&Responsable="+ urlEncode(document.getElementById("Login_Resp").getAttribute("label"));
		liste_param += "&ComValide="+ com_valide;
		liste_param += "&Type_Fact="+ mode_fact;
		liste_param += "&Num_Affaire="+ urlEncode(document.getElementById("Numero").value);

		if (mode_edit=="C") {
		
			if (mode_fact=="B") {
				var url = "chrome://opensi/content/facturation/user/affaires/choix_bon.xul?"+ cookie() +"&Affaire_Id="+ affaire_id;
    		window.openDialog(url,'','chrome,modal');
				
				if (bon_id!=0) {
					liste_param += "&Bon_Id="+ bon_id;
				
					var page = "chrome://opensi/content/facturation/user/affaires/edition_facture.xul?"+ cookie() +"&Mode=C&Affaire_Id="+ affaire_id + liste_param;
    			window.location = page;
				}
			}
			else {
				var page = "chrome://opensi/content/facturation/user/affaires/edition_facture.xul?"+ cookie() +"&Mode=C&Affaire_Id="+ affaire_id + liste_param;
    		window.location = page;
			}
		}
		else {
			var tree = document.getElementById('factures');
			
			if (tree.view!=null && tree.currentIndex!=-1) {
			
				var facture_id = tree.view.getCellText(tree.currentIndex,'ColFacture_Id');			
				var page = "chrome://opensi/content/facturation/user/affaires/edition_facture.xul?"+ cookie() +"&Mode=M&Facture_Id="+ facture_id +"&Affaire_Id="+ affaire_id + liste_param;
    		window.location = page;
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#editerFacture : ' + e);
  }
}


function editerOF() {
	try {

		demandeEnregistrement();

		var liste_param = "&Raison_Sociale="+ urlEncode(document.getElementById("Raison_Sociale").value);
		liste_param += "&Adresse_Fact="+ urlEncode(document.getElementById("Adresse_Fact").value);
		liste_param += "&CP_Fact="+ urlEncode(document.getElementById("CP_Fact").value);
		liste_param += "&Ville_Fact="+ urlEncode(document.getElementById("Ville_Fact").value);
		liste_param += "&Client_Id="+ urlEncode(document.getElementById("Client_Id").value);
		liste_param += "&Nom_Affaire="+ urlEncode(document.getElementById("Nom_Affaire").value);
		liste_param += "&Responsable="+ urlEncode(document.getElementById("Login_Resp").getAttribute("label"));
		liste_param += "&ComValide="+ com_valide;
		liste_param += "&Type_Fact="+ mode_fact;
		liste_param += "&Affaire_Id="+ document.getElementById("Affaire_Id").value;
		liste_param += "&Num_Affaire="+ urlEncode(document.getElementById("Numero").value);

		var page = "chrome://opensi/content/facturation/user/affaires/edition_of.xul?"+ cookie() + liste_param +"&Liste_Param="+ urlEncode(liste_param);
    window.location = page;

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#editerOF : ' + e);
	}
}


function demandeEnregistrement() {
  try {
	
		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes  l'affaire ?")) {
				enregistrer_affaire();
			}
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#demandeEnregistrement : ' + e);
	}
}


function setModifie(m) {
  try {
	
		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelAffaire').setAttribute("label","Affaire (modifie)");
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelAffaire').setAttribute("label","Affaire");
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#setModifie : ' + e);
	}
}


function rechercher_affaire() {
  try {
		
		var url = "chrome://opensi/content/facturation/user/affaires/rech_affaire.xul?" + cookie();
		window.openDialog(url,'','chrome,modal');
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#rechercher_affaire : ' + e);
  }
}


function newInterlocuteur() {
	try {

		var url = "chrome://opensi/content/facturation/user/affaires/ajouter_interlocuteur.xul?" + cookie() +"&Client_Id="+ urlEncode(document.getElementById("Client_Id").value);
		window.openDialog(url,'','chrome,modal');

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#newInterlocuteur : ' + e);
  }
}


function retour_affaires() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/affaires/menu_affaires.xul?" + cookie();
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#retour_affaires : ' + e);
  }
}


function retour_menu_principal() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?" + cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#retour_menu_principal : ' + e);
  }
}




