/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {    
  try {
   
  	init_tree_affaires();
		init_tree_historique();
		init_tree_livraisons();
	 
  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#init : ' + e);
  }
}


function basculer(b) {
  try {

		document.getElementById('boxAff').collapsed = (b=='L');
		document.getElementById('boxLiv').collapsed = (b=='A');

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#basculer : ' + e);
  }
}


function nouvelle_affaire() {    
  try {
   
		var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?" + cookie() +"&Mode=C";
    window.location = page;
   
  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#nouvelle_affaire : ' + e);
  }
}


function rechercher_affaire() {
  try {
		
		var url = "chrome://opensi/content/facturation/user/affaires/rech_affaire.xul?" + cookie();
		window.openDialog(url,'','chrome,modal');
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#rechercher_affaire : ' + e);
  }
}


function pressOnAffaires(ev) {
  try {
	
		switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrir_affaire();
        break;      
    }
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#pressOnAffaires : ' + e);
  }
}


function pressOnLivraisons(ev) {
  try {
	
		switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrir_affaire_livraisons();
        break;      
    }
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#pressOnLivraisons : ' + e);
  }
}


function pressOnHistorique(ev) {
  try {
	
		switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrir_affaire_historique();
        break;      
    }
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#pressOnHistorique : ' + e);
  }
}


function ouvrir_affaire_win(affaire_id) {
  try {
	
		var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?" + cookie() +"&Mode=M&Affaire_Id="+ affaire_id;
    window.location = page;
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#ouvrir_affaire_win : ' + e);
  }
}


function ouvrir_affaire() {
  try {
	
		var tree = document.getElementById('affaires');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
		
			var affaire_id = tree.view.getCellText(tree.currentIndex,'ColAffaire_Id');
			
			var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?" + cookie() +"&Mode=M&Affaire_Id="+ affaire_id;
    	window.location = page;
		}
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#ouvrir_affaire : ' + e);
  }
}


function ouvrir_affaire_livraisons() {
  try {
	
		var tree = document.getElementById('livraisons');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
		
			var affaire_id = tree.view.getCellText(tree.currentIndex,'ColAffaire_IdLiv');
			
			var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?" + cookie() +"&Mode=M&Affaire_Id="+ affaire_id;
    	window.location = page;
		}
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#ouvrir_affaire_livraisons : ' + e);
  }
}


function ouvrir_affaire_historique() {
  try {
		
		var tree = document.getElementById('historique');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
		
			var affaire_id = tree.view.getCellText(tree.currentIndex,'ColAffaire_IdH');
			
			var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?" + cookie() +"&Mode=M&Affaire_Id="+ affaire_id;
    	window.location = page;
		}
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/menu_affaires.js#ouvrir_affaire_historique : ' + e);
  }
}


function init_tree_affaires() {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/liste_affaires.tmpl&ContentType=xml&Terminees=n";
    load_rdf('affaires', getUrlOpeneas(paramlist));
    document.getElementById('affaires').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/menu_affaires.js#init_tree_affaires : ' + e);
  }
}

function delete_tree_affaires() {
  try {
    
    var database = document.getElementById("affaires").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/menu_affaires.js#delete_tree_affaires : ' + e);
  }
}

function init_tree_livraisons() {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/liste_livraisons.tmpl&ContentType=xml";
    load_rdf('livraisons', getUrlOpeneas(paramlist));
    document.getElementById('livraisons').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/menu_affaires.js#init_tree_livraisons : ' + e);
  }
}

function delete_tree_livraisons() {
  try {
    
    var database = document.getElementById("livraisons").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/menu_affaires.js#delete_tree_livraisons : ' + e);
  }
}

function init_tree_historique() {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/liste_affaires.tmpl&ContentType=xml&Terminees=y";
    load_rdf('historique', getUrlOpeneas(paramlist));
    document.getElementById('historique').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/menu_affaires.js#init_tree_historique : ' + e);
  }
}


function delete_tree_historique() {
  try {
    
    var database = document.getElementById("historique").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/menu_affaires.js#delete_tree_historique : ' + e);
  }
}


function retour_menu_principal() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?" + cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;
  
	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/menu_affaires.js#retour_menu_principal : ' + e);
  }
}
