/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


/*

Paramtres d'entre non obligatoires :
	- Nouv - true->affichage du bouton nouveau - defaut=true
	- Modif_Action - true->modification du champs Action (fentre appelante) - defaut=true
	- Field_Client - id du champs o est report le code client choisi (fentre appelante) - defaut=Client
	- Bloque - true->impossible de choisir un client bloqu - default=false

*/


function init() {
  try {
	
		var nouv = ParamValeur('Nouv');
    if (! isEmpty(nouv)) {
      if (nouv == 'false') {
        document.getElementById('bouton_nouveau').collapsed = true;
      }
    }
	
		var paramlist = "&Page=Facturation/GetRDF/familles_client.tmpl&ContentType=xml"+ nocache();
  	load_rdf_async('Famille', getUrlOpeneas(paramlist), initFamille);
	
    var x = (screen.width / 2) - 400;
    var y = (screen.height / 2) - 200;
    window.resizeTo(800,400);
    window.moveTo(x,y);
    document.getElementById('Client_Id').focus();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_client.js#init : ' + e);
  }
}


function initFamille() {
	try {
	
		document.getElementById('Famille').selectedIndex = 0;
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_client.js#initFamille : ' + e);
  }
}


function pressOnNom(ev) {
  try {
    switch(ev.keyCode) {
      case 13: // 'Enter'
			
				document.getElementById('Code_Couleur').value = -1;
				document.getElementById('Famille').value = "";
				document.getElementById('Client_Id').value = "";
			
        delete_tree();
        init_tree("&Nom="+ urlEncode(document.getElementById('Nom').value));
        break;
      
    }
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#pressOnNom : ' + e);
  }
}


function pressOnFamille() {
  try {
    
		document.getElementById('Code_Couleur').value = -1;
		document.getElementById('Nom').value = "";
		document.getElementById('Client_Id').value = "";
		
    delete_tree();
    init_tree("&Famille="+ urlEncode(document.getElementById('Famille').value));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_client.js#pressOnFamille : ' + e);
  }
}


function pressOnCouleur() {
  try {
    
		document.getElementById('Famille').value = "";
		document.getElementById('Nom').value = "";
		document.getElementById('Client_Id').value = "";
		
  	delete_tree();
    init_tree("&Code_Couleur="+ urlEncode(document.getElementById('Code_Couleur').value));  
   
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#pressOnCouleur : ' + e);
  }
}


function existeClient(code_client) {
  try {
		
		var corps = cookie() + "&Page=Facturation/Clients/existeClient.tmpl&ContentType=xml&Client_Id="+ urlEncode(code_client);
		var p = requeteHTTP(corps);

		if (p.status != "200") {
  		alert("Rception erreur " + p.status);
			return false;
		} 
		else {
			var contenu = p.responseXML.documentElement;                
  		return (contenu.getAttribute('existe')=="true" && contenu.getAttribute('supprime')=="false");
		}
    
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#existeClient : ' + e);
  }
}

function clientBloque(code_client) {
  try {
		
		var corps = cookie() + "&Page=Facturation/Clients/clientBloque.tmpl&ContentType=xml&Client_Id="+ urlEncode(code_client);
		var p = requeteHTTP(corps);

		if (p.status != "200") {
  		alert("Rception erreur " + p.status);
			return true;
		} 
		else {
			var contenu = p.responseXML.documentElement;                
  		return (contenu.getAttribute('bloque')=="true");
		}
    
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#clientBloque : ' + e);
  }
}


function pressOnId(ev) {
  try {

		switch(ev.keyCode) {
      case 13: // 'Enter'
			
				var code_client = document.getElementById('Client_Id').value;

				if (existeClient(code_client)) {
        	ouvrirClient(code_client);
				}
				else {
					document.getElementById('Famille').value = "";
					document.getElementById('Nom').value = "";
					document.getElementById('Code_Couleur').value = "";
		
  				delete_tree();
    			init_tree("&Client_Id="+ urlEncode(code_client));
				}
				
        break;      
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#pressOnId : ' + e);
  }
}


function pressOnTree(ev) {
  try {
   
    switch(ev.keyCode) {
      case 13: // 'Enter'
				choixClient();        
       	break;      
  	}
	
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#pressOnTree : ' + e);
  }
}


function nouveauClient() {
  try {
	   
		var modif_action = !(ParamValeur('Modif_Action')=="false");
			
		if (modif_action) {
    	window.opener.document.getElementById("Action").value="C";
		}
		
    window.close();
    
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#nouveauClient : ' + e);
  }
}


function ouvrirClient(code_client) {
  try {
			
		if (ParamValeur('Bloque')=="true" && clientBloque(code_client)) {
			showWarning("Ce client est bloqu !");
		}
		else {			
			var modif_action = !(ParamValeur('Modif_Action')=="false");

			if (modif_action) {
				window.opener.document.getElementById('Action').value = "M";
			}

			var field_client = ParamValeur('Field_Client');

			if (isEmpty(field_client)) {
				window.opener.document.getElementById('Client').value = code_client;
			}
			else {
				window.opener.document.getElementById(field_client).value = code_client;
			}

      window.close();
		}			         
  
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#ouvrirClient : ' + e);
  }  
}


function choixClient() {
	try {
	
		var tree = document.getElementById('clients');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
		
			var code_client = tree.view.getCellText(tree.currentIndex, 'ColClient_Id');
		
			ouvrirClient(code_client);		
		}
		
	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_client.js#choixClient : ' + e);
  }
}


function init_tree(param) {
  try {
	
    var paramlist = "&Page=Facturation/GetRDF/liste_clients.tmpl&ContentType=xml"+ param;
    load_rdf('clients', getUrlOpeneas(paramlist));
    document.getElementById('clients').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {
	
    var database = document.getElementById("clients").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/rech_clients.js#delete_tree : ' + e);
  }
}
