/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
  try {
	
    var x = (screen.width / 2) - 425;
    var y = (screen.height / 2) - 200;
    window.resizeTo(850,400);
    window.moveTo(x,y);
    document.getElementById('Commande_Id').focus();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#init : ' + e);
  }
}


function pressOnId(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrirCommande();
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#pressOnId : ' + e);
  }
}

function pressOnFournisseurId(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'        
        document.getElementById('Commande_Id').value = "";
        document.getElementById('Raison_Sociale').value = "";
				delete_tree();
				init_tree("&Fournisseur_Id="+ urlEncode(document.getElementById('Fournisseur_Id').value));
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#pressOnFournisseurId : ' + e);
  }
}

function pressOnRaisonSociale(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'        
				document.getElementById('Commande_Id').value = "";
        document.getElementById('Fournisseur_Id').value = "";
				delete_tree();
				init_tree("&Raison_Sociale="+ urlEncode(document.getElementById('Raison_Sociale').value));
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#pressOnRaisonSociale : ' + e);
  }
}


function pressOnTree(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrirCommande();
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#pressOnTree : ' + e);
  }
}


function etatCommande(num_commande) {
  try {
 
		var corps = cookie() + "&Page=Facturation/Commandes/etatCommande.tmpl&ContentType=xml&Num_Commande="+ num_commande;
		var p = requeteHTTP(corps);

		if (p.status != "200") {
    	alert("Rception erreur " + p.status);
			return false;
		} 
		else {
  		var contenu = p.responseXML.documentElement;
      document.getElementById('Fournisseur_Id').value = contenu.getAttribute('fournisseur_id');
  		return contenu.getAttribute('etat');
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#etatCommande : ' + e);
  }
}


function ouvrirCommande() {
  try {
			
		var num_commande = document.getElementById('Commande_Id').value;

		if (num_commande!="") {
      var etat = etatCommande(num_commande);
			if (isEmpty(etat)) {
				document.getElementById('Raison_Sociale').value = "";
        document.getElementById('Fournisseur_Id').value = "";
				delete_tree();
				init_tree("&Num_Commande="+ urlEncode(num_commande));
			}
			else {
				window.opener.ouvrir_commande_win(num_commande,etat,urlEncode(document.getElementById('Fournisseur_Id').value));
        window.close();
			}                 
    }
  
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#ouvrirCommande : ' + e);
  }  
}


function reporterId() {
	try {
	
		var tree = document.getElementById('commandes');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
			
			var val = tree.view.getCellText(tree.currentIndex,'ColNum');
		
			document.getElementById('Commande_Id').value = val;		
		}
		
	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#reporterId : ' + e);
  }
}


function init_tree(param) {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/commandes.tmpl&ContentType=xml"+ param;

    load_rdf('commandes', getUrlOpeneas(paramlist));
    document.getElementById('commandes').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {
    
		var database = document.getElementById("commandes").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#delete_tree : ' + e);
  }
}