/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Commercial: contact@opensi.org                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {    
  try {  
     
		 nouveauCommercial();
     delete_tree();
     init_tree();
   
  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/gestion_entreprise/menu_gestion_entreprise.js#init : ' + e);
  }
}


function nouveauCommercial() {
	try {
		
		// initialisation valeurs par dfaut
	  document.getElementById('Civilite').selectedItem = document.getElementById('CiviliteM');
		document.getElementById('Nom').value = "";
		document.getElementById('Prenom').value = "";
		document.getElementById('Fonction').value = "";
		document.getElementById('Age').value = "";
		document.getElementById('Tel').value = "";
		document.getElementById('Portable').value = "";
		document.getElementById('Fax').value = "";
		document.getElementById('Email').value = "";
	
		document.getElementById('bNouveau').collapsed = true;
		document.getElementById('bSupprimer').collapsed = true;
		document.getElementById('bModifier').collapsed = true;
		document.getElementById('bCreer').collapsed = false;
		
	} catch (e) {
    recup_erreur('erreur dans facturation/user/gestion_entreprise/menu_gestion_entreprise.js#nouveauCommercial : ' + e);
  }
}


function supprimerCommercial() {
	try {
	
		var commercial_id = document.getElementById('Commercial_Id').value;		
		var prenom = document.getElementById('Prenom').value;
		var nom = document.getElementById('Nom').value;		
		
		if (window.confirm("Confirmez-vous la suppression du commercial '"+ prenom +" "+ nom +"' ?")) {		
			var corps = cookie() + "&Page=Facturation/Gestion_Entreprise/supprimerCommercial.tmpl&ContentType=text&Commercial_Id="+ commercial_id;

			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		} 
			else {
				delete_tree();
				init_tree();
				nouveauCommercial();
  		}
		}
		
	} catch (e) {
    recup_erreur('erreur dans facturation/user/gestion_entreprise/menu_gestion_entreprise.js#supprimerCommercial : ' + e);
  }
}


function enregistrerCommercial(mode) {
	try {

    var civilite = document.getElementById('Civilite').value;
		var nom = document.getElementById('Nom').value;
		var prenom = document.getElementById('Prenom').value;
		var fonction = document.getElementById('Fonction').value;
		var tel = document.getElementById('Tel').value;
		var portable = document.getElementById('Portable').value;
		var fax = document.getElementById('Fax').value;
		var email = document.getElementById('Email').value;
		var age = document.getElementById('Age').value;

		var corps;

		if (mode=="C") {
			corps = cookie() + "&Page=Facturation/Gestion_Entreprise/creerCommercial.tmpl&ContentType=xml";
		}
		else {		
			var commercial_id = document.getElementById('Commercial_Id').value;
			corps = cookie() + "&Page=Facturation/Gestion_Entreprise/modifierCommercial.tmpl&ContentType=text&Commercial_Id="+ commercial_id;
		}
		
		corps += "&Nom="+ urlEncode(nom) +"&Prenom="+ urlEncode(prenom) +"&Fonction="+ urlEncode(fonction);
		corps += "&Age="+ age +"&Tel="+ urlEncode(tel);
		corps += "&Portable="+ urlEncode(portable) +"&Fax="+ urlEncode(fax) +"&Email="+ urlEncode(email) +"&Civilite="+ civilite;
    
		if (isEmpty(nom)) {
			showWarning("Veuillez spcifier le nom du commercial !");
		}
		else if (!isEmpty(tel) && !isPhone(tel)) { showWarning("Numro de tlphone incorrect !"); }
		else if (!isEmpty(portable) && !isPhone(portable)) { showWarning("Numro de portable incorrect !"); }
		else if (!isEmpty(fax) && !isPhone(fax)) { showWarning("Numro de fax incorrect !"); }
		else if (!isEmpty(email) && !isEmail(email)) { showWarning("Adresse e-mail incorrecte !"); }
		else {		
			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		} 
			else {    	
				if (mode=="C") {
					contenu = p.responseXML.documentElement;

					document.getElementById('Commercial_Id').value = contenu.getAttribute('Commercial_Id');

					document.getElementById('bCreer').collapsed = true;
					document.getElementById('bModifier').collapsed = false;
					document.getElementById('bNouveau').collapsed = false;
					document.getElementById('bSupprimer').collapsed = false;
				}
				else {
					//alert(trim(p.responseText));
				}
				delete_tree();
				init_tree();
  		}
		}
		
	} catch (e) {
    recup_erreur('erreur dans facturation/user/gestion_entreprise/menu_gestion_entreprise.js#enregistrerCommercial : ' + e);
  }
}


function pressOnTree(e) {
	try {
		switch(e.keyCode){
      case 13: // 'Enter'
        chargerCommercial();
        break;      
    }
 	} catch (e) {
    recup_erreur('erreur dans facturation/user/gestion_entreprise/menu_gestion_entreprise.js#pressOnTree : ' + e);
  }
}

function chargerCommercial() {
	try {
	
		var tree = document.getElementById('liste_commerciaux');
		
		if (tree.contentView!=null && tree.currentIndex!=-1) {
		
			var selection = tree.contentView.getItemAtIndex(tree.currentIndex);
			var commercial_id = selection.firstChild.firstChild.getAttribute('value');

			var corps = cookie() + "&Page=Facturation/Gestion_Entreprise/getCommercial.tmpl&ContentType=xml&Commercial_Id="+ commercial_id;

			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		} 
			else {
    		contenu = p.responseXML.documentElement;

				document.getElementById('Commercial_Id').value = contenu.getAttribute('Commercial_Id');
				document.getElementById('Nom').value = contenu.getAttribute('Nom');
				document.getElementById('Prenom').value = contenu.getAttribute('Prenom');
				document.getElementById('Fonction').value = contenu.getAttribute('Fonction');
				document.getElementById('Age').value = contenu.getAttribute('Age');
				document.getElementById('Tel').value = contenu.getAttribute('Tel');
				document.getElementById('Portable').value = contenu.getAttribute('Portable');
				document.getElementById('Fax').value = contenu.getAttribute('Fax');
				document.getElementById('Email').value = contenu.getAttribute('Email');

				document.getElementById('bSupprimer').collapsed = false;
				document.getElementById('bModifier').collapsed = false;
				document.getElementById('bNouveau').collapsed = false;
				document.getElementById('bCreer').collapsed = true;
				
      	if (contenu.getAttribute("Civilite") == "1") {
      		document.getElementById("Civilite").selectedItem = document.getElementById("CiviliteM");
      	}
      	else {
        	if (contenu.getAttribute("Civilite") == "2"){
          	document.getElementById("Civilite").selectedItem = document.getElementById("CiviliteMme");
        	}
        	else{
          	document.getElementById("Civilite").selectedItem = document.getElementById("CiviliteMlle");
        	}
      	}
  		}
		}
	
 	} catch (e) {
    recup_erreur('erreur dans facturation/user/gestion_entreprise/menu_gestion_entreprise.js#chargerCommercial : ' + e);
  }
}


function init_tree() {
  try {
	
    var paramlist = "&Page=Facturation/GetRDF/liste_commerciaux.tmpl&ContentType=xml";
    load_rdf('liste_commerciaux', getUrlOpeneas(paramlist));
    document.getElementById('liste_commerciaux').builder.rebuild();
    
  } catch (e) {
    recup_erreur('erreur dans facturation/user/gestion_entreprise/menu_gestion_entreprise.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {
	
    var database = document.getElementById("liste_commerciaux").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/gestion_entreprise/menu_gestion_entreprise.js#delete_tree : ' + e);
  }
}


function retour_menu_fact2() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?" + cookie();
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/menu_gestion_entreprise.js#retour_menu_fact2 : ' + e);
  }
}
