/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
  try {
   
		var paramlist = "&Page=Facturation/GetRDF/familles_article.tmpl&ContentType=xml";
  	load_rdf_async('Famille', getUrlOpeneas(paramlist), initSousFamille);

		paramlist = "&Page=Facturation/GetRDF/marques_article.tmpl&ContentType=xml";
  	load_rdf('Marque', getUrlOpeneas(paramlist));
		
		window.parent.document.getElementById('Loaded').setAttribute('label', nocache());
	
	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#init : ' + e);
	}	
}


function initSousFamille() {
  try {

		var paramlist = "&Page=Facturation/GetRDF/sousfamilles_article.tmpl&ContentType=xml&Famille="+ document.getElementById('Famille').value;
  	load_rdf('Sous_Famille', getUrlOpeneas(paramlist));

	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#initSousFamille : ' + e);
	}
}


function chargerSousFamilles() {
	try {

		delete_sousfamilles();

		var paramlist = "&Page=Facturation/GetRDF/sousfamilles_article.tmpl&ContentType=xml&Famille="+ document.getElementById('Famille').value;
  	load_rdf('Sous_Famille', getUrlOpeneas(paramlist));
		document.getElementById('Sous_Famille').builder.rebuild();
		
		document.getElementById('Sous_Famille').value = "";

	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#chargerSousFamilles : ' + e);
	}
}


function delete_sousfamilles() {
  try {
	
    var database = document.getElementById("Sous_Famille").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
		document.getElementById('Sous_Famille').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#delete_sousfamilles : ' + e);
  }
}


function loadPhoto() {
  try {
		
		var dossier = get_cookie("Dossier_Id");
		var article_id = window.parent.document.getElementById('Article').value;
		document.getElementById('Vignette').setAttribute("src", "");
		document.getElementById('Vignette').setAttribute("src", getDirServeur() +"photos_articles/"+ dossier +"/"+ article_id +"_small.jpg");
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#loadPhoto : ' + e);
  }
}


function voirPhoto() {
  try {
	
		var article_id = window.parent.document.getElementById('Article').value;
		
		var url = "chrome://opensi/content/facturation/user/stocks/voir_photo.xul?" + cookie() +"&Article_Id="+ article_id;
		window.openDialog(url,'','chrome,modal');

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#voirPhoto : ' + e);
  }
}


function changerPhoto() {
  try {

		var article_id = window.parent.document.getElementById('Article').value;

		var url = "chrome://opensi/content/facturation/user/stocks/change_photo.xul?" + cookie() +"&Article_Id="+ article_id;
		window.openDialog(url,'','chrome,modal');
		
		loadPhoto();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#changerPhoto : ' + e);
  }
}


function choixArticleSubstitution() {
  try {

		var url = "chrome://opensi/content/facturation/user/stocks/rech_stocks.xul?" + cookie() +"&Field_Article=Article_Substitution&Modif_Action=false&Nouv=false";
		window.openDialog(url,'','chrome,modal');
		
		setModifie();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#choixArticleSubstitution : ' + e);
  }
}


function setModifie() {
	try {
	
		window.parent.document.getElementById('Modifie').value = "y";
		
	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/contenuPres.js#setModifie : ' + e);
	} 
}
