/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {    
  try {

    var page = "chrome://opensi/content/facturation/user/stocks/contenuPres.xul?" + cookie();
    document.getElementById("contenu_pres").setAttribute("src",page);      
    page = "chrome://opensi/content/facturation/user/stocks/contenuStock.xul?" + cookie();
    document.getElementById("contenu_stock").setAttribute("src",page); 
    page = "chrome://opensi/content/facturation/user/stocks/contenuFournisseurs.xul?" + cookie();
    document.getElementById("contenu_fournisseurs").setAttribute("src",page);
    page = "chrome://opensi/content/facturation/user/stocks/contenuNomenclature.xul?" + cookie();
    document.getElementById("contenu_nomenclature").setAttribute("src",page);
    page = "chrome://opensi/content/facturation/user/stocks/contenuPrix.xul?" + cookie();
    document.getElementById("contenu_prix").setAttribute("src",page);		
    page = "chrome://opensi/content/facturation/user/stocks/resumeStocks.xul?" + cookie();
    document.getElementById("resume_stocks").setAttribute("src",page);
      
  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/stocks/menu_stocks.js#init : ' + e);
  }
}

var NB_ONGLET = 6;
var countLoaded = 0;

function processLoading() {
  try {

		countLoaded++;
		
		if (countLoaded == NB_ONGLET) {
			document.getElementById('Modifie').value = 'n';
			rechercherArticle();
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/stocks/menu_stocks.js#updateLoading : ' + e);
  }
}


function hideButtons(b) {
	try {
	
		document.getElementById('bEnregistrer').collapsed = b;
		
		if (document.getElementById('Action').value == "M") {
    	document.getElementById('bSupprimer').collapsed = b;
		}
		else {
			document.getElementById('bSupprimer').collapsed = true;
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/menu_stocks.js#hideButtons : ' + e);
  }
}


function setDefaultValues() {
	try {
		
		document.getElementById('Panneau').selectedIndex = 0;
		hideButtons(false);
		
		var doc = document.getElementById("resume_stocks").contentDocument;
		
		doc.getElementById('Article_Id').value = "";
		doc.getElementById('Designation').value = "";
		doc.getElementById('Marque').value = "";
		doc.getElementById('Famille').value = "";
		doc.getElementById('Stock_Init').value = "";
    doc.getElementById('Entrees').value = "";
    doc.getElementById('Sorties').value = "";
    doc.getElementById('Stock_Auj').value = "";
    doc.getElementById('Stock_Calcule').value = "";
    doc.getElementById('PMP').value = "";
		
		// onglet prsentation
		
		var doc = document.getElementById('contenu_pres').contentDocument;

		doc.getElementById('Article_Id').value = "";
    doc.getElementById('Designation').value = "";
    doc.getElementById('Famille').value = "";
		doc.getElementById('Sous_Famille').value = "";
		document.getElementById('contenu_pres').contentWindow.delete_sousfamilles();
		doc.getElementById('Marque').value = "";
    doc.getElementById('Localisation').value = "";
    doc.getElementById('Code_Barre').value = "";
    doc.getElementById('Conditionnement').value = "";
    doc.getElementById('Article_Substitution').value = "";

    doc.getElementById('Facturable').selectedItem = doc.getElementById("FacturableOui");
    doc.getElementById('Mise_En_Ligne').checked = false;
    doc.getElementById('Nature').selectedItem = doc.getElementById("NaturePdt");
		
		doc.getElementById('Descrip_1').value = "";
		doc.getElementById('Descrip_2').value = "";
		
		
		var corps = cookie() + "&Page=Manager/ParamDossier/getParamDossier.tmpl&ContentType=xml&Dossier_Id="+ get_cookie("Dossier_Id");
    var p = requeteHTTP(corps);

		if (p.status != "200") {
      alert("Rception erreur " + p.status);
    } 
  	else {			
    	var contenu = p.responseXML.documentElement;
			
			doc.getElementById('Imp_Nom_Fiche').checked = (contenu.getAttribute('Imp_Nom_Fiche')==1);
			doc.getElementById('Imp_Nom_OF').checked = (contenu.getAttribute('Imp_Nom_OF')==1);
			doc.getElementById('Imp_Nom_Facture').checked = (contenu.getAttribute('Imp_Nom_Facture')==1);
			doc.getElementById('Imp_Nom_Bon').checked = (contenu.getAttribute('Imp_Nom_Bon')==1);
			doc.getElementById('Imp_Nom_Devis').checked = (contenu.getAttribute('Imp_Nom_Devis')==1);
			
			doc.getElementById('Imp_Desc1_Fiche').checked = (contenu.getAttribute('Imp_Desc1_Fiche')==1);
			doc.getElementById('Imp_Desc1_OF').checked = (contenu.getAttribute('Imp_Desc1_OF')==1);
			doc.getElementById('Imp_Desc1_Facture').checked = (contenu.getAttribute('Imp_Desc1_Facture')==1);
			doc.getElementById('Imp_Desc1_Bon').checked = (contenu.getAttribute('Imp_Desc1_Bon')==1);
			doc.getElementById('Imp_Desc1_Devis').checked = (contenu.getAttribute('Imp_Desc1_Devis')==1);
			
			doc.getElementById('Imp_Desc2_Fiche').checked = (contenu.getAttribute('Imp_Desc2_Fiche')==1);
			doc.getElementById('Imp_Desc2_OF').checked = (contenu.getAttribute('Imp_Desc2_OF')==1);
			doc.getElementById('Imp_Desc2_Facture').checked = (contenu.getAttribute('Imp_Desc2_Facture')==1);
			doc.getElementById('Imp_Desc2_Bon').checked = (contenu.getAttribute('Imp_Desc2_Bon')==1);
			doc.getElementById('Imp_Desc2_Devis').checked = (contenu.getAttribute('Imp_Desc2_Devis')==1);
			
			docPrix = document.getElementById('contenu_prix').contentDocument;
			docPrix.getElementById('Coeff_1').value = contenu.getAttribute('Coeff_1');
    	docPrix.getElementById('Coeff_2').value = contenu.getAttribute('Coeff_2');
    	docPrix.getElementById('Coeff_3').value = contenu.getAttribute('Coeff_3');
    	docPrix.getElementById('Coeff_4').value = contenu.getAttribute('Coeff_4');
    	docPrix.getElementById('Coeff_5').value = contenu.getAttribute('Coeff_5');		
		}
		
		
		doc.getElementById('Vignette').src = "../design/default_vignette.jpg";

		// onglet prix

		doc = document.getElementById('contenu_prix').contentDocument;

    doc.getElementById("Unite").value = "U";

    doc.getElementById('Prix_Achat_Der').value = 0.00;
    doc.getElementById('Frais_Appro_Der').value = 0.00;
    doc.getElementById('Prix_Revient_Der').value = 0.00;
    doc.getElementById('Tarif_1').value = 0;
    doc.getElementById('Tarif_2').value = 0;
    doc.getElementById('Tarif_3').value = 0;
    doc.getElementById('Tarif_4').value = 0;
    doc.getElementById('Tarif_5').value = 0;
		doc.getElementById('TTC_1').value = 0;
    doc.getElementById('TTC_2').value = 0;
    doc.getElementById('TTC_3').value = 0;
    doc.getElementById('TTC_4').value = 0;
    doc.getElementById('TTC_5').value = 0;
		doc.getElementById('Marge_1').value = 0;
    doc.getElementById('Marge_2').value = 0;
    doc.getElementById('Marge_3').value = 0;
    doc.getElementById('Marge_4').value = 0;
    doc.getElementById('Marge_5').value = 0;
		doc.getElementById('Prix_Achat').value = 0;
		doc.getElementById('Frais_Appro').value = 0;
		doc.getElementById('Prix_Revient').value = 0;
    doc.getElementById('PMP').value = 0;
    doc.getElementById('Poids_Brut').value = 0;
    doc.getElementById('Poids_Net').value = 0;
    doc.getElementById('Poids_Unite').value = 0;
    doc.getElementById('Unite_Vente').value = 1;
		doc.getElementById('Code_TVA').value = 4;
		doc.getElementById('Mesure_Poids').value = "K";
		doc.getElementById('Base_Calcul').checked = true;
		
		document.getElementById('contenu_prix').contentWindow.delete_tree_tarifs();
		document.getElementById('contenu_prix').contentWindow.annulerLigne();
		document.getElementById('contenu_prix').contentWindow.disableBoutons(true);

		// onglet stock			

		doc = document.getElementById('contenu_stock').contentDocument;

		doc.getElementById('Stock_Init').value = 0;
		doc.getElementById('Prix_Init').value = 0;
		doc.getElementById('Frais_Init').value = 0;
    doc.getElementById('Entrees').value = 0;
    doc.getElementById('Sorties').value = 0;
    doc.getElementById('Stock_Auj').value = 0;
    doc.getElementById('Com_Clients').value = 0;
    doc.getElementById('Com_Fournisseurs').value = 0;
    doc.getElementById('Stock_Calcule').value = 0;
		doc.getElementById('Stock_Dispo').value = 0;
    doc.getElementById('Stock_Minimum').value = 0;
    doc.getElementById('Stock_Alerte').value = 0;		
		
		document.getElementById('Modifie').value = "n";		
		

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/stocks/menu_stocks.js#setDefaultValues : ' + e);
  }
}


function enregistrerTout() {
	try {
		
		var Action = document.getElementById('Action').value;
		
		var corps;
		
		if (Action=="M") {
			corps = cookie() + "&Page=Facturation/Stocks/modifierArticle.tmpl&ContentType=text";
		}
		else {
			corps = cookie() + "&Page=Facturation/Stocks/creerArticle.tmpl&ContentType=text";
		}
		
		
		// Champs onglet prsentation
		
		var doc = document.getElementById('contenu_pres').contentDocument;

    var article_id = doc.getElementById('Article_Id').value;
    var designation = doc.getElementById('Designation').value;
    var famille = doc.getElementById('Famille').value;
		var sous_famille = doc.getElementById('Sous_Famille').value;
		var marque = doc.getElementById('Marque').value;
    var nature = doc.getElementById('Nature').value;
    var facturable = doc.getElementById('Facturable').value;            
    var localisation = doc.getElementById('Localisation').value;
    var code_barre = doc.getElementById('Code_Barre').value;
    var conditionnement = doc.getElementById('Conditionnement').value;
    var article_substitution = doc.getElementById('Article_Substitution').value;
    var mise_en_ligne = doc.getElementById('Mise_En_Ligne').checked?"1":"0";
		var descrip_1 = doc.getElementById('Descrip_1').value;
		var descrip_2 = doc.getElementById('Descrip_2').value;              

		corps += "&Article_Id="+urlEncode(article_id)+"&Designation="+ urlEncode(designation)+"&Famille="+ urlEncode(famille) +"&Nature="+ urlEncode(nature)+"&Localisation="+ urlEncode(localisation);
    corps += "&Facturable="+ urlEncode(facturable);
    corps += "&Code_Barre="+ urlEncode(code_barre)+"&Conditionnement="+ urlEncode(conditionnement)+"&Article_Substitution="+ urlEncode(article_substitution);
    corps += "&Mise_En_Ligne="+ urlEncode(mise_en_ligne);             
		corps += "&Marque="+ urlEncode(marque) +"&Sous_Famille="+ urlEncode(sous_famille);
		corps += "&Descrip_1="+ urlEncode(descrip_1) +"&Descrip_2="+ urlEncode(descrip_2);
    
		corps += "&Imp_Nom_Fiche="+ (doc.getElementById('Imp_Nom_Fiche').checked?"1":"0");
		corps += "&Imp_Nom_OF="+ (doc.getElementById('Imp_Nom_OF').checked?"1":"0");
		corps += "&Imp_Nom_Facture="+ (doc.getElementById('Imp_Nom_Facture').checked?"1":"0");
		corps += "&Imp_Nom_Bon="+ (doc.getElementById('Imp_Nom_Bon').checked?"1":"0");
		corps += "&Imp_Nom_Devis="+ (doc.getElementById('Imp_Nom_Devis').checked?"1":"0");
		
		corps += "&Imp_Desc1_Fiche="+ (doc.getElementById('Imp_Desc1_Fiche').checked?"1":"0");
		corps += "&Imp_Desc1_OF="+ (doc.getElementById('Imp_Desc1_OF').checked?"1":"0");
		corps += "&Imp_Desc1_Facture="+ (doc.getElementById('Imp_Desc1_Facture').checked?"1":"0");
		corps += "&Imp_Desc1_Bon="+ (doc.getElementById('Imp_Desc1_Bon').checked?"1":"0");
		corps += "&Imp_Desc1_Devis="+ (doc.getElementById('Imp_Desc1_Devis').checked?"1":"0");
		
		corps += "&Imp_Desc2_Fiche="+ (doc.getElementById('Imp_Desc2_Fiche').checked?"1":"0");
		corps += "&Imp_Desc2_OF="+ (doc.getElementById('Imp_Desc2_OF').checked?"1":"0");
		corps += "&Imp_Desc2_Facture="+ (doc.getElementById('Imp_Desc2_Facture').checked?"1":"0");
		corps += "&Imp_Desc2_Bon="+ (doc.getElementById('Imp_Desc2_Bon').checked?"1":"0");
		corps += "&Imp_Desc2_Devis="+ (doc.getElementById('Imp_Desc2_Devis').checked?"1":"0");
		
		
		// Champs onglet prix
		
		doc = document.getElementById('contenu_prix').contentDocument;
		
		var unite = doc.getElementById('Unite').value;
    var tarif_1 = doc.getElementById('Tarif_1').value;
    var tarif_2 = doc.getElementById('Tarif_2').value;
    var tarif_3 = doc.getElementById('Tarif_3').value;
    var tarif_4 = doc.getElementById('Tarif_4').value;
    var tarif_5 = doc.getElementById('Tarif_5').value;
		var coeff_1 = doc.getElementById('Coeff_1').value;
    var coeff_2 = doc.getElementById('Coeff_2').value;
    var coeff_3 = doc.getElementById('Coeff_3').value;
    var coeff_4 = doc.getElementById('Coeff_4').value;
    var coeff_5 = doc.getElementById('Coeff_5').value;
		var prix_achat = doc.getElementById('Prix_Achat').value;
		var frais_appro = doc.getElementById('Frais_Appro').value;
    var poids_brut = doc.getElementById('Poids_Brut').value;
    var poids_net = doc.getElementById('Poids_Net').value;
    var poids_unite = doc.getElementById('Poids_Unite').value;
    var unite_vente = doc.getElementById('Unite_Vente').value;
		var code_tva = doc.getElementById('Code_TVA').value;
		var mesure_poids = doc.getElementById('Mesure_Poids').value;
		var base_calcul = doc.getElementById('Base_Calcul').checked?"1":"0";
		
		corps += "&Unite="+ urlEncode(unite)+"&Poids_Brut="+ urlEncode(poids_brut)+"&Tarif_1="+ urlEncode(tarif_1);
		corps += "&Tarif_2="+ urlEncode(tarif_2)+"&Tarif_3="+ urlEncode(tarif_3)+"&Tarif_4="+ urlEncode(tarif_4)+"&Tarif_5="+ urlEncode(tarif_5);
    corps += "&Poids_Net="+ urlEncode(poids_net)+"&Poids_Unite="+ urlEncode(poids_unite)+"&Unite_Vente="+ urlEncode(unite_vente);
		corps += "&Code_TVA="+ code_tva +"&Frais_Appro="+ frais_appro +"&Prix_Achat="+ prix_achat +"&Mesure_Poids="+ mesure_poids +"&Base_Calcul="+ base_calcul;
		corps += "&Coeff_1="+ urlEncode(coeff_1) +"&Coeff_2="+ urlEncode(coeff_2)+"&Coeff_3="+ urlEncode(coeff_3)+"&Coeff_4="+ urlEncode(coeff_4)+"&Coeff_5="+ urlEncode(coeff_5);
		
		// Champs onglet stock
		
		doc = document.getElementById('contenu_stock').contentDocument;
		
    var stock_init = doc.getElementById('Stock_Init').value;
    var stock_minimum = doc.getElementById('Stock_Minimum').value;
    var stock_alerte = doc.getElementById('Stock_Alerte').value;
		var prix_init = doc.getElementById('Prix_Init').value;
		var frais_init = doc.getElementById('Frais_Init').value;

		corps += "&Stock_Init="+ urlEncode(stock_init);
    corps += "&Stock_Minimum="+ urlEncode(stock_minimum)+"&Stock_Alerte="+ urlEncode(stock_alerte);
		corps += "&Prix_Init="+ prix_init +"&Frais_Init="+ frais_init;


		var saveOK = false;
		
		
		if (Action=="C" && isEmpty(article_id)) {
			showWarning("Veuillez spcifier un code article ! (Onglet prsentation)");
		}
		else if (Action=="C" && existeArticle(article_id)) {
			showWarning("Le code article '"+ article_id +"' est dj utilis ! (Onglet prsentation)");
		}
		else if (Action=="C" && !isCleAlpha(article_id)) {
			showWarning("Code article invalide ! (Onglet prsentation)");
		}
		else if (isEmpty(marque)) { showWarning("Veuillez spcifier la marque de l'article ! (Onglet prsentation)"); }
		else if (isEmpty(designation)) { showWarning("Veuillez spcifier la dsignation de l'article ! (Onglet prsentation)"); }
		else if (isEmpty(famille)) { showWarning("Veuillez spcifier la famille de l'article ! (Onglet prsentation)"); }
		else if (isEmpty(sous_famille)) { showWarning("Veuillez spcifier la sous-famille de l'article ! (Onglet prsentation)"); }
		else if (isEmpty(unite_vente)) { showWarning("Veuillez spcifier l'unit de vente ! (Onglet prix)"); }
		
		else if (isEmpty(stock_init) || !isPositiveOrNull(stock_init)) { showWarning("Stock initial incorrect ! (Onglet stock)"); }
		else if (isEmpty(prix_init) || !isPositiveOrNull(prix_init) || !checkDecimal(prix_init,4)) { showWarning("Prix d'achat initial incorrect ! (Onglet stock)"); }
		else if (isEmpty(frais_init) || !isPositiveOrNull(frais_init) || !checkDecimal(frais_init,4)) { showWarning("Frais d'approche initiaux incorrects ! (Onglet stock)"); }
		
		else if (!isEmpty(code_barre) && (code_barre.length!=13 || !isDigitList(code_barre))) { showWarning("Code barre incorrect ! (Onglet prsentation)"); }
		
		else if (!isPositiveInteger(unite_vente)) { showWarning("Unit de vente incorrecte ! (Onglet prix)"); }
		else if (isEmpty(poids_brut) || !isPositiveOrNull(poids_brut)) { showWarning("Poids brut incorrect ! (Onglet prix)"); }
		else if (isEmpty(poids_net) || !isPositiveOrNull(poids_net)) { showWarning("Poids net incorrect ! (Onglet prix)"); }
		else if (isEmpty(poids_unite) || !isPositiveOrNull(poids_unite)) { showWarning("Poids brut  l'unit incorrect ! (Onglet prix)"); }
		
		else if (isEmpty(stock_minimum) || !isPositiveOrNull(stock_minimum)) { showWarning("Stock minimum incorrect ! (Onglet stock)"); }
		else if (isEmpty(stock_alerte) || !isPositiveOrNull(stock_alerte)) { showWarning("Stock d'alerte incorrect ! (Onglet stock)"); }
		
		else if (isEmpty(tarif_1) || !isPositiveOrNull(tarif_1) || !checkDecimal(tarif_1,4)) { showWarning("Tarif 1 incorrect ! (Onglet prix)"); }
		else if (isEmpty(tarif_2) || !isPositiveOrNull(tarif_2) || !checkDecimal(tarif_2,4)) { showWarning("Tarif 2 incorrect ! (Onglet prix)"); }
		else if (isEmpty(tarif_3) || !isPositiveOrNull(tarif_3) || !checkDecimal(tarif_3,4)) { showWarning("Tarif 3 incorrect ! (Onglet prix)"); }
		else if (isEmpty(tarif_4) || !isPositiveOrNull(tarif_4) || !checkDecimal(tarif_4,4)) { showWarning("Tarif 4 incorrect ! (Onglet prix)"); }
		else if (isEmpty(tarif_5) || !isPositiveOrNull(tarif_5) || !checkDecimal(tarif_5,4)) { showWarning("Tarif 5 incorrect ! (Onglet prix)"); }
		else if (isEmpty(coeff_1) || !isPositiveOrNull(coeff_1) || !checkDecimal(coeff_1,5)) { showWarning("Tarif 1 incorrect ! (Onglet prix)"); }
		else if (isEmpty(coeff_2) || !isPositiveOrNull(coeff_2) || !checkDecimal(coeff_2,5)) { showWarning("Tarif 2 incorrect ! (Onglet prix)"); }
		else if (isEmpty(coeff_3) || !isPositiveOrNull(coeff_3) || !checkDecimal(coeff_3,5)) { showWarning("Tarif 3 incorrect ! (Onglet prix)"); }
		else if (isEmpty(coeff_4) || !isPositiveOrNull(coeff_4) || !checkDecimal(coeff_4,5)) { showWarning("Tarif 4 incorrect ! (Onglet prix)"); }
		else if (isEmpty(coeff_5) || !isPositiveOrNull(coeff_5) || !checkDecimal(coeff_5,5)) { showWarning("Tarif 5 incorrect ! (Onglet prix)"); }
		else if (isEmpty(prix_achat) || !isPositiveOrNull(prix_achat) || !checkDecimal(prix_achat,4)) { showWarning("Prix d'achat incorrect ! (Onglet prix)"); }
		else if (isEmpty(frais_appro) || !isPositiveOrNull(frais_appro) || !checkDecimal(frais_appro,4)) { showWarning("Frais d'approche incorrects ! (Onglet prix)"); }
		
		else {		
			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		} 
			else {
				saveOK = true;
    		
				showMessage("La fiche article a t enregistre !");				
				
				if (Action=="C") {
					document.getElementById('Action').value = "M";
					document.getElementById('Article').value = article_id;

					document.getElementById('bSupprimer').collapsed = false;
					document.getElementById('contenu_pres').contentDocument.getElementById('bVoirPhoto').collapsed = false;
					document.getElementById('contenu_pres').contentDocument.getElementById('bChangerPhoto').collapsed = false;
					document.getElementById('TabFournisseurs').collapsed = false;
					document.getElementById('TabNomenclature').collapsed = false;
					chargerArticle();
					document.getElementById('contenu_pres').contentDocument.getElementById('Article_Id').disabled = true;
					document.getElementById('contenu_fournisseurs').contentDocument.getElementById('Loaded').setAttribute('label',nocache());
					document.getElementById('contenu_nomenclature').contentDocument.getElementById('Loaded').setAttribute('label',nocache());
				}
				else {
					document.getElementById("resume_stocks").contentDocument.getElementById('Designation').value = designation;
					document.getElementById("resume_stocks").contentDocument.getElementById('Marque').value = marque;
					document.getElementById("resume_stocks").contentDocument.getElementById('Famille').value = famille;
					document.getElementById('contenu_stock').contentWindow.disableInitStock(true);
					
					calculerStocks();
					afficherResumeStocks();
					calculerCUMP();
				}
				
				document.getElementById('Modifie').value = "n";
  		}
		}
		
		return saveOK;

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/menu_stocks.js#enregistrerTout : ' + e);
  }
}


function existeArticle(code_article) {
  try {
 
		var corps = cookie() + "&Page=Facturation/Stocks/existeArticle.tmpl&ContentType=xml&Article_Id="+ urlEncode(code_article);
		var p = requeteHTTP(corps);

		if (p.status != "200") {
    	alert("Rception erreur " + p.status);
			return false;
		} 
		else {
  		var contenu = p.responseXML.documentElement;                
  		return contenu.getAttribute('existe')=="true";  		
		}
    
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/menu_stocks.js#existeArticle : ' + e);
  }
}


function rechercherArticle() {
	try {
	
		var Action = document.getElementById('Action').value;
		var Modifie = document.getElementById('Modifie').value;
		var change = true;
	
		if (Modifie=="y") {		
			if (Action=="M") {
				var question = "Voulez-vous enregistrer les modifications ?";
			}
			else {
				var question = "Voulez-vous enregistrer la fiche article ?";
			}
		
			if (window.confirm(question)) {
				change = enregistrerTout();
			}
		}
	
		if (change) {	
			var url = "chrome://opensi/content/facturation/user/stocks/rech_stocks.xul?" + cookie();
			window.openDialog(url,'','chrome,modal');
			Action = document.getElementById('Action').value;

			if (Action=="M") {
				document.getElementById('bSupprimer').collapsed = false;
				document.getElementById('contenu_pres').contentDocument.getElementById('bVoirPhoto').collapsed = false;
				document.getElementById('contenu_pres').contentDocument.getElementById('bChangerPhoto').collapsed = false;
				document.getElementById('TabFournisseurs').collapsed = false;
				document.getElementById('TabNomenclature').collapsed = false;
				chargerArticle();
				document.getElementById('contenu_pres').contentDocument.getElementById('Article_Id').disabled = true;
				document.getElementById('contenu_fournisseurs').contentDocument.getElementById('Loaded').setAttribute('label',nocache());
				document.getElementById('contenu_nomenclature').contentDocument.getElementById('Loaded').setAttribute('label',nocache());
			}
			else {			
				document.getElementById('bSupprimer').collapsed = true;
				document.getElementById('contenu_pres').contentDocument.getElementById('bVoirPhoto').collapsed = true;
				document.getElementById('contenu_pres').contentDocument.getElementById('bChangerPhoto').collapsed = true;
  			document.getElementById('TabFournisseurs').collapsed = true;
				document.getElementById('TabNomenclature').collapsed = true;

				document.getElementById('Creation').label = "";
				document.getElementById('Modification').label = "";
				document.getElementById('Creation').collapsed = true;
				document.getElementById('Modification').collapsed = true;
				document.getElementById('Fiche').label = "";	

				document.getElementById('contenu_pres').contentDocument.getElementById('Article_Id').disabled = false;
				document.getElementById('contenu_stock').contentWindow.disableInitStock(false);
				
				setDefaultValues();
			}
		}
        
	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/menu_stocks.js#rechercherArticle : ' + e);
	}
}
    

function calculerCUMP() {
  try {
		  
		var article_id = document.getElementById('Article').value;
			      
    var docStocks = document.getElementById("resume_stocks").contentDocument;
    var docPrix = document.getElementById("contenu_prix").contentDocument;
		
		var stock_init = document.getElementById('contenu_stock').contentDocument.getElementById('Stock_Init').value;
		var prix_init = document.getElementById('contenu_stock').contentDocument.getElementById('Prix_Init').value;
		var frais_init = document.getElementById('contenu_stock').contentDocument.getElementById('Frais_Init').value;
		
    var corps = cookie() +"&Page=Facturation/Stocks/calculerCUMP.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id);
		corps += "&Stock_Init="+ stock_init +"&Prix_Init="+ prix_init +"&Frais_Init="+ frais_init;
    var p = requeteHTTP(corps);

    if (p.status != "200") {
      alert("Rception erreur " + p.status);
    } 
		else {
      var contenu = p.responseXML.documentElement;
      
      docStocks.getElementById('PMP').value = contenu.getAttribute('PMP');
      docPrix.getElementById('PMP').value = contenu.getAttribute('PMP');
    }
    
	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/menu_stocks.js#calculerCUMP : ' + e);
  }
}


function afficherResumeStocks() { 
  try {
  
    var docResume = document.getElementById("resume_stocks").contentDocument;
		var docStock = document.getElementById("contenu_stock").contentDocument;
		
  	docResume.getElementById('Stock_Init').value = docStock.getElementById('Stock_Init').value;
  	docResume.getElementById('Entrees').value = docStock.getElementById('Entrees').value;
  	docResume.getElementById('Sorties').value = docStock.getElementById('Sorties').value;
  	docResume.getElementById('Stock_Auj').value = docStock.getElementById('Stock_Auj').value;
  	docResume.getElementById('Stock_Calcule').value = docStock.getElementById('Stock_Calcule').value;    
		 
  } catch (e) {
   	recup_erreur('erreur dans facturation/user/clients/menu_stocks.js#afficherResumeStocks : ' + e);
  }
}


function supprimerTout() {
	try {
	
		var article_id = document.getElementById('Article').value;
	
		if (window.confirm("Confirmez-vous la suppression de l'article "+article_id+" ?")) {
	
			var corps = cookie() + "&Page=Facturation/Stocks/supprimerArticle.tmpl&ContentType=text&Article_Id="+ urlEncode(article_id);

			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		} 
			else {
    		showMessage("L'article a t supprim !");
				setDefaultValues();
				document.getElementById('Action').value = "C";
				document.getElementById('Modifie').value = "n";
				rechercherArticle();
  		}
		}
		
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/menu_stocks.js#supprimerTout : ' + e);
  }
}


function chargerArticle() {
	try {
	
		document.getElementById('Panneau').selectedIndex = 0;
		hideButtons(false);
	
		var corps = cookie() + "&Page=Facturation/Stocks/getArticle.tmpl&ContentType=xml&Article_Id="+ urlEncode(document.getElementById('Article').value);
		
		var p = requeteHTTP(corps);              
             
  	if (p.status != "200") {
      alert("Rception erreur " + p.status);
  	} 
		else {
		
			var contenu = p.responseXML.documentElement;
			
			// onglet prsentation
			
			var doc = document.getElementById('contenu_pres').contentDocument;
			
			doc.getElementById('Article_Id').value = contenu.getAttribute('Article_Id');
      doc.getElementById('Designation').value = contenu.getAttribute('Designation');
			document.getElementById("resume_stocks").contentDocument.getElementById('Article_Id').value = contenu.getAttribute('Article_Id');
			document.getElementById("resume_stocks").contentDocument.getElementById('Designation').value = contenu.getAttribute('Designation');
      doc.getElementById('Famille').value = contenu.getAttribute('Famille');
			document.getElementById("resume_stocks").contentDocument.getElementById('Famille').value = contenu.getAttribute('Famille');
			doc.getElementById('Sous_Famille').value = contenu.getAttribute('Sous_Famille');
			doc.getElementById('Marque').value = contenu.getAttribute('Marque');
			document.getElementById("resume_stocks").contentDocument.getElementById('Marque').value = contenu.getAttribute('Marque');

      doc.getElementById('Localisation').value = contenu.getAttribute('Localisation');
      doc.getElementById('Code_Barre').value = contenu.getAttribute('Code_Barre');
      doc.getElementById('Conditionnement').value = contenu.getAttribute('Conditionnement');
      doc.getElementById('Article_Substitution').value = contenu.getAttribute('Article_Substitution');
			doc.getElementById('Descrip_1').value = contenu.getAttribute('Descrip_1');
			doc.getElementById('Descrip_2').value = contenu.getAttribute('Descrip_2');
			doc.getElementById('Mise_En_Ligne').checked = contenu.getAttribute('Mise_En_Ligne')=="1";

			doc.getElementById('Imp_Nom_Fiche').checked = (contenu.getAttribute('Imp_Nom_Fiche')==1);
			doc.getElementById('Imp_Nom_OF').checked = (contenu.getAttribute('Imp_Nom_OF')==1);
			doc.getElementById('Imp_Nom_Facture').checked = (contenu.getAttribute('Imp_Nom_Facture')==1);
			doc.getElementById('Imp_Nom_Bon').checked = (contenu.getAttribute('Imp_Nom_Bon')==1);
			doc.getElementById('Imp_Nom_Devis').checked = (contenu.getAttribute('Imp_Nom_Devis')==1);
			
			doc.getElementById('Imp_Desc1_Fiche').checked = (contenu.getAttribute('Imp_Desc1_Fiche')==1);
			doc.getElementById('Imp_Desc1_OF').checked = (contenu.getAttribute('Imp_Desc1_OF')==1);
			doc.getElementById('Imp_Desc1_Facture').checked = (contenu.getAttribute('Imp_Desc1_Facture')==1);
			doc.getElementById('Imp_Desc1_Bon').checked = (contenu.getAttribute('Imp_Desc1_Bon')==1);
			doc.getElementById('Imp_Desc1_Devis').checked = (contenu.getAttribute('Imp_Desc1_Devis')==1);
			
			doc.getElementById('Imp_Desc2_Fiche').checked = (contenu.getAttribute('Imp_Desc2_Fiche')==1);
			doc.getElementById('Imp_Desc2_OF').checked = (contenu.getAttribute('Imp_Desc2_OF')==1);
			doc.getElementById('Imp_Desc2_Facture').checked = (contenu.getAttribute('Imp_Desc2_Facture')==1);
			doc.getElementById('Imp_Desc2_Bon').checked = (contenu.getAttribute('Imp_Desc2_Bon')==1);
			doc.getElementById('Imp_Desc2_Devis').checked = (contenu.getAttribute('Imp_Desc2_Devis')==1);

      if (contenu.getAttribute("Facturable") == "1") {
      doc.getElementById("Facturable").selectedItem = doc.getElementById("FacturableOui");
      }
      else {
        doc.getElementById("Facturable").selectedItem = doc.getElementById("FacturableNon");
      }
      if (contenu.getAttribute("Nature") == "1") {
      doc.getElementById("Nature").selectedItem = doc.getElementById("NaturePdt");
      }
      else {
        doc.getElementById("Nature").selectedItem = doc.getElementById("NatureMat");
      }           
			
			
			// onglet prix
			
			doc = document.getElementById('contenu_prix').contentDocument;				
			
			var prix_achat_der = parseFloat(contenu.getAttribute('Prix_Achat_Der'));			
			var frais_appro_der = parseFloat(contenu.getAttribute('Frais_Appro_Der'));
			
      doc.getElementById('Prix_Achat_Der').value = contenu.getAttribute('Prix_Achat_Der');
      doc.getElementById('Frais_Appro_Der').value = contenu.getAttribute('Frais_Appro_Der');			
			doc.getElementById('Prix_Revient_Der').value = formatNombre(prix_achat_der + frais_appro_der,"0.00");
			
			
      doc.getElementById('Tarif_1').value = contenu.getAttribute('Tarif_1');
      doc.getElementById('Tarif_2').value = contenu.getAttribute('Tarif_2');
      doc.getElementById('Tarif_3').value = contenu.getAttribute('Tarif_3');
      doc.getElementById('Tarif_4').value = contenu.getAttribute('Tarif_4');
      doc.getElementById('Tarif_5').value = contenu.getAttribute('Tarif_5');
			doc.getElementById('Coeff_1').value = contenu.getAttribute('Coeff_1');
      doc.getElementById('Coeff_2').value = contenu.getAttribute('Coeff_2');
      doc.getElementById('Coeff_3').value = contenu.getAttribute('Coeff_3');
      doc.getElementById('Coeff_4').value = contenu.getAttribute('Coeff_4');
      doc.getElementById('Coeff_5').value = contenu.getAttribute('Coeff_5');
			doc.getElementById('Prix_Achat').value = contenu.getAttribute('Prix_Achat');
      doc.getElementById('Frais_Appro').value = contenu.getAttribute('Frais_Appro');
      doc.getElementById('Poids_Brut').value = contenu.getAttribute('Poids_Brut');
      doc.getElementById('Poids_Net').value = contenu.getAttribute('Poids_Net');
      doc.getElementById('Poids_Unite').value = contenu.getAttribute('Poids_Unite');
      doc.getElementById('Unite_Vente').value = contenu.getAttribute('Unite_Vente');
			doc.getElementById('Unite').value = contenu.getAttribute('Unite');
			doc.getElementById('Code_TVA').value = contenu.getAttribute('Code_TVA');
			doc.getElementById('Mesure_Poids').value = contenu.getAttribute('Mesure_Poids');
			doc.getElementById('Base_Calcul').checked = contenu.getAttribute('Base_Calcul')=="1";
			
			
			document.getElementById('contenu_prix').contentWindow.calculerRevient();
			
			//document.getElementById('contenu_prix').contentWindow.delete_tree_tarifs();
			document.getElementById('contenu_prix').contentWindow.changeModeTarifQte();
			//document.getElementById('contenu_prix').contentWindow.init_tree_tarifs();
			document.getElementById('contenu_prix').contentWindow.disableBoutons(false);
			document.getElementById('contenu_prix').contentWindow.annulerLigne();
			
			// onglet stock			
			
			doc = document.getElementById('contenu_stock').contentDocument;
			
			doc.getElementById('Stock_Init').value = contenu.getAttribute('Stock_Init');
			doc.getElementById('Prix_Init').value = contenu.getAttribute('Prix_Init');
			doc.getElementById('Frais_Init').value = contenu.getAttribute('Frais_Init');
      doc.getElementById('Entrees').value = contenu.getAttribute('Entrees');
      doc.getElementById('Sorties').value = contenu.getAttribute('Sorties');
      doc.getElementById('Com_Clients').value = contenu.getAttribute('Com_Clients');
      doc.getElementById('Com_Fournisseurs').value = contenu.getAttribute('Com_Fournisseurs');
      doc.getElementById('Stock_Minimum').value = contenu.getAttribute('Stock_Minimum');
      doc.getElementById('Stock_Alerte').value = contenu.getAttribute('Stock_Alerte');
			stock_alerte = contenu.getAttribute('Stock_Alerte');
			
						
			// actualisation status bar
			
			document.getElementById('Creation').label = "Article cr le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
			document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
			document.getElementById('Fiche').label = "Article N "+ contenu.getAttribute('Article_Id') +" - "+ contenu.getAttribute('Designation');
			document.getElementById('Creation').collapsed = false;
			document.getElementById('Modification').collapsed = false;
			
			
			document.getElementById('contenu_stock').contentWindow.disableInitStock(true);			

			calculerStocks();
			afficherResumeStocks();
			calculerCUMP();

			document.getElementById('contenu_pres').contentWindow.loadPhoto();

			if (parseFloat(document.getElementById('Stock_Calcule'))<parseFloat(stock_alerte)) {
    		showWarning("Attention ! Le seuil minimum du stock est atteint !");
			}

			document.getElementById('Modifie').value = "n";	
  	}		
		
		
		
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/menu_stocks.js#chargerArticle : ' + e);
  }
}


function calculerStocks() {
	try {
		
		doc = document.getElementById('contenu_stock').contentDocument;
		
		var stock_init = parseFloat(doc.getElementById('Stock_Init').value);
		var entrees = parseFloat(doc.getElementById('Entrees').value);
		var sorties = parseFloat(doc.getElementById('Sorties').value);
		var stock_auj = stock_init + entrees - sorties;
		var com_clients = parseFloat(doc.getElementById('Com_Clients').value);
		var com_fournisseurs = parseFloat(doc.getElementById('Com_Fournisseurs').value);
		var stock_dispo = parseFloat(stock_auj) - com_clients;
		var stock_calcule = parseFloat(stock_auj) + com_fournisseurs - com_clients;
		
		doc.getElementById('Stock_Auj').value = stock_auj;
		doc.getElementById('Stock_Dispo').value = stock_dispo;
		doc.getElementById('Stock_Calcule').value = stock_calcule;
		
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/menu_stocks.js#calculerStocks : ' + e);
  }
}


function retour_menu_fact2() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?" + cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/menu_stocks.js#retour_menu_fact2 : ' + e);
  }
}


function imprimerArticle() {
  try {
	
  	var url = "chrome://opensi/content/facturation/user/stocks/impressionArticle.xul?" + cookie();
    window.openDialog(url,'Impression Article','chrome,modal','Article_Id');
				
  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/menu_stocks.js#imprimerBilan : ' + e);
  }
}
