/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*

Paramtres d'entre non obligatoires :
	- Nouv - true->affichage du bouton nouveau - defaut=true
	- Modif_Action - true->modification du champs Action (fentre appelante) - defaut=true
	- Field_Article - id du champs o est reporte la rfrence article choisie (fentre appelante) - defaut=Article

*/



function init() {
  try {

    var nouv = ParamValeur('Nouv');
    if (! isEmpty(nouv)) {
      if (nouv == 'false') {
        document.getElementById('bouton_nouveau').collapsed = true;
      }
    }
    
		var paramlist = "&Page=Facturation/GetRDF/familles_article.tmpl&ContentType=xml"+ nocache();
  	load_rdf_async('Famille', getUrlOpeneas(paramlist), initFamille);

		paramlist = "&Page=Facturation/GetRDF/marques_article.tmpl&ContentType=xml"+ nocache();
  	load_rdf_async('Marque', getUrlOpeneas(paramlist), initMarque);

    var x = (screen.width / 2) - 425;
    var y = (screen.height / 2) - 225;
    window.resizeTo(850,450);
    window.moveTo(x,y);
    document.getElementById('Article_Id').focus();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#init : ' + e);
  }
}

function initFamille() {
	try {
	
		document.getElementById('Famille').selectedIndex = 0;
		chargerSousFamilles();
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#initFamille : ' + e);
  }
}


function chargerSousFamilles() {
	try {

		delete_sousfamilles();

		var paramlist = "&Page=Facturation/GetRDF/sousfamilles_article.tmpl&ContentType=xml&Famille="+ document.getElementById('Famille').value + nocache();
  	load_rdf_async('Sous_Famille', getUrlOpeneas(paramlist), selSousFamille);

	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#chargerSousFamilles : ' + e);
	}
}


function selSousFamille() {
	try {
	
		document.getElementById('Sous_Famille').selectedIndex = 0;
	
	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#selSousFamille : ' + e);
	}
}


function delete_sousfamilles() {
  try {
	
    var database = document.getElementById("Sous_Famille").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }		
		document.getElementById('Sous_Famille').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#delete_sousfamilles : ' + e);
  }
}


function initMarque() {
	try {
	
		document.getElementById('Marque').selectedIndex = 0;
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#initMarque : ' + e);
  }
}


function pressOnId(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'
			
				var code_article = document.getElementById('Article_Id').value;
			
				document.getElementById('Famille').value = "";
				document.getElementById('Marque').value = "";
				document.getElementById('Designation').value = "";
				delete_sousfamilles();
				document.getElementById('Sous_Famille').selectedIndex = 0;
			
				if (existeArticle(code_article))
        	ouvrirArticle(code_article);
				else {
				
					delete_tree();
    			init_tree("&Article_Id="+ urlEncode(code_article));
				}
				
        break;      
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnId : ' + e);
  }
}


function pressOnNom(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'

				document.getElementById('Famille').value = "";
				document.getElementById('Marque').value = "";
				document.getElementById('Article_Id').value = "";
				delete_sousfamilles();
				document.getElementById('Sous_Famille').selectedIndex = 0;

        delete_tree();
        init_tree("&Designation="+ urlEncode(document.getElementById('Designation').value));
        break;      
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnNom : ' + e);
  }
}

function pressOnMarque() {
  try {
    
		document.getElementById('Famille').value = "";
		document.getElementById('Designation').value = "";
		document.getElementById('Article_Id').value = "";
		delete_sousfamilles();
		document.getElementById('Sous_Famille').selectedIndex = 0;
		
    delete_tree();
    init_tree("&Marque="+ urlEncode(document.getElementById('Marque').value));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnMarque : ' + e);
  }
}


function pressOnFamille() {
  try {
    
		document.getElementById('Designation').value = "";
		document.getElementById('Marque').value = "";
		document.getElementById('Article_Id').value = "";
		
    delete_tree();
    init_tree("&Famille="+ urlEncode(document.getElementById('Famille').value));
		
		chargerSousFamilles();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnFamille : ' + e);
  }
}


function pressOnSousFamille() {
  try {
    
    delete_tree();
    init_tree("&Famille="+ urlEncode(document.getElementById('Famille').value) +"&Sous_Famille="+ urlEncode(document.getElementById('Sous_Famille').value));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnSousFamille : ' + e);
  }
}


function pressOnTree(ev) {
  try {
   
    switch(ev.keyCode) {
      case 13: // 'Enter'
				choixArticle();        
       	break;      
  	}
	
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnTree : ' + e);
  }
}


function existeArticle(code_article) {
  try {
 
		var corps = cookie() + "&Page=Facturation/Stocks/existeArticle.tmpl&ContentType=xml&Article_Id="+ urlEncode(code_article);
		var p = requeteHTTP(corps);

		if (p.status != "200") {
    	alert("Rception erreur " + p.status);
			return false;
		} 
		else {
  		var contenu = p.responseXML.documentElement;                
  		return (contenu.getAttribute('existe')=="true" && contenu.getAttribute('supprime')=="false");  		
		}
    
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#existeArticle : ' + e);
  }
}


function nouveauArticle() {
  try {
	 	
		var modif_action = !(ParamValeur('Modif_Action')=="false");
			
		if (modif_action) {
			window.opener.document.getElementById("Action").value = "C";
		}
		
		window.close();
    
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#nouveauArticle : ' + e);
  }
}


function ouvrirArticle(code_article) {
  try {
			
		var modif_action = !(ParamValeur('Modif_Action')=="false");

		if (modif_action) {
			window.opener.document.getElementById('Action').value = "M";
		}

		var field_article = ParamValeur('Field_Article');

		if (isEmpty(field_article)) {
			window.opener.document.getElementById('Article').value = code_article;
		}
		else {
			window.opener.document.getElementById(field_article).value = code_article;
		}
    window.close();			              
  
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#ouvrirArticle : ' + e);
  }  
}


function choixArticle() {
	try {
	
		var tree = document.getElementById('articles');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
		
			var code_article = tree.view.getCellText(tree.currentIndex, 'ColArticle_Id');
		
			ouvrirArticle(code_article);		
		}
		
	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#reporterId : ' + e);
  }
}


function init_tree(param) {
  try {
	
    var fournisseur = ParamValeur('Fournisseur');
    var paramlist = "&Page=Facturation/GetRDF/liste_articles.tmpl&ContentType=xml"+ param;
    if (! isEmpty(fournisseur)) {
      paramlist += "&Fournisseur_Id=" + fournisseur;
    }
    load_rdf('articles', getUrlOpeneas(paramlist));
    document.getElementById('articles').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {
	
    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#delete_tree : ' + e);
  }
}