/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des ?v?nements sur la fen?tre <login.xul>
 * @include chrome://opensi/content/libs/verif.js
 * @include chrome://opensi/content/libs/util.js
 *
 */
 

var valcookie = '';
var utilisateur = '';

function getvalue(param) {
  switch(param) {
    case 'cookie':
      return valcookie;
      break;
    case 'utilisateur':
      return utilisateur;
      break;
    default :
      return '';
      break;
  }
}

function init() {
  
  try {

    document.getElementById('version').value = "OpenSI Client - version " + get_version();

    var module = get_pref_module();
    document.getElementById('liste').value = module;

    if (module == 'Manager') {
      affichPassword();
    } else {
      affichTout();
    }

    var x = (screen.width / 2) - 300;
    var y = (screen.height / 2) - 200;
    window.resizeTo(600,450);
    window.moveTo(x,y);
    
  } catch (e) {
    recup_erreur('erreur dans login.js#init : ' + e);
  }

}

function affiche_param() {
  try {
    document.getElementById('parambutton').collapsed = true;
    document.getElementById('paramavances').collapsed = false;
    document.getElementById('ipserveur').value = get_pref_ipserveur() ;
    document.getElementById('porttomcat').value = get_pref_porttomcat();
    document.getElementById('servlet').value = get_pref_servlet();
    document.getElementById('is_ssl').checked = get_pref_ssl();
  } catch (e) {
    recup_erreur('erreur dans login.js#affiche_param : ' + e);
  }
}

function checkLogin() {

  try {
  
    if (! document.getElementById('paramavances').collapsed) {
      set_pref_ipserveur(document.getElementById('ipserveur').value);
      set_pref_porttomcat(document.getElementById('porttomcat').value);
      set_pref_servlet(document.getElementById('servlet').value);
      set_pref_ssl(document.getElementById('is_ssl').checked);
    }
    var login = document.getElementById('login').value;
    var password = document.getElementById('password').value;

    var corps = "Page=Login.tmpl&ContentType=xml&newversion=1";
    corps += "&Login=" + login + "&Password=" + password + "&os=" + get_os();

    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,checkLogin2);

  } catch(e) {
    recup_erreur('erreur dans login.js#checkLogin : ' + e);
  }

}

function checkLogin2(httpRequest) {
  
  try {

    //    if(httpRequest.readyState != 4) return false; 
    //4==document completement charge; 1==en cours; 2==charge; 3==interactif 0==initialise

    if (httpRequest.status == "0") return false;
    
    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
    } else {

      var contenu=httpRequest.responseXML;

      if (contenu == null) {
        alert("Le serveur ncessite une connexion scurise. Veuillez cocher la case correspondante dans les paramtres avancs.");
        window.location = "chrome://opensi/content/login.xul";
        return -1;
      } else {

        var session = contenu.documentElement;
        valcookie = session.getAttribute('cookie');

        if (valcookie=="") {
          alert('Login incorrect');
          window.location = "chrome://opensi/content/login.xul";
          return -1;
        } else {

          var user = session.getElementsByTagName('user')[0];

          var numversion = user.getAttribute('numversion');
          var releasename = user.getAttribute('releasename');
          var clientrelease = user.getAttribute('clientrelease');
          var clientsousrelease = user.getAttribute('clientsousrelease');
          var urlupdate = user.getAttribute('urlupdate');

          if (numversion != get_num_version() || clientrelease > get_release()) {

            var url = "update.html?";
            url += "numversion=" + numversion;
            url += "&releasename=" + releasename;
            url += "&clientrelease=" + clientrelease;
            url += "&urlupdate=" + urlupdate;
            window.location = url;
            
          } else if (clientsousrelease > get_sous_release()) {

            var msg = "Une mise  jour (version " + numversion + "." + clientrelease + "." + clientsousrelease + ") est disponible\n";
            msg += "Voulez vous mettre  jour votre application ?";
            if (confirm(msg)) {
              var url = "update2.html?";
              url += "&urlupdate=" + urlupdate;
              window.location = url;
            } else {
              checkLogin3(user);
            }

          } else {
            checkLogin3(user);
          }
        }
      }
    }

  } catch(e) {
		recup_erreur('erreur dans login.js#checkLogin2 : ' + e);
  }

}

function checkLogin3(user) {
  
  try {

    utilisateur = user.getAttribute('id');
    if (isEmpty(utilisateur)) {
      alert('Login incorrect');
      window.location = "chrome://opensi/content/login.xul";
      return -1;
    } else {
      var root = user.getAttribute('root');
      var choix = document.getElementById('liste').value;
      set_pref_module(choix) ;

      if (root != "true") {
        
        if (choix=="Compta") {
          var url = "chrome://opensi/content/compta/user/main.xul";
          window.open(url,'main','chrome,resizable');
        } else if (choix=="Facturation") {
          var url = "chrome://opensi/content/facturation/user/main.xul";
          window.open(url,'main','chrome,resizable');
        }
        
      } else if (choix!="Manager") {
        alert('Login incorrect');
        window.location = "chrome://opensi/content/login.xul";
        return -1;
      } else {
        var url  = "chrome://opensi/content/manager/main.xul";
        window.open(url,'main','chrome,resizable');
      }
    }
  } catch(e) {
		recup_erreur('erreur dans login.js#checkLogin3 : ' + e);
  }

}

function keypress(e) {
  
  try {
  
    switch (e.keyCode) {
      case 13: // Enter
        var ipserveur = document.getElementById('ipserveur');
        var porttomcat = document.getElementById('porttomcat');
        var servlet = document.getElementById('servlet');
        var login = document.getElementById('login');
        var passwd = document.getElementById('password');
        if (! document.getElementById('paramavances').collapsed) {
          if (isEmpty(ipserveur.value)) {
            alert("Vous devez prciser l'adresse et le port du serveur OpenSI");
            ipserveur.focus();
            return false;
          } 
          if (isEmpty(porttomcat.value)) {
            alert("Vous devez prciser l'adresse et le port du serveur OpenSI");
            porttomcat.focus();
            return false;
          }
          if (isEmpty(servlet.value)) {
            alert("Vous devez prciser le nom du serlvet sur le serveur OpenSI");
            porttomcat.focus();
            return false;
          }
        }
        if (isEmpty(login.value)) {
          login.focus();
        } else if (isEmpty(passwd.value)) {
          passwd.focus();
        } else {
          checkLogin();
        }
      break;
    }

  } catch (e) {
    recup_erreur('erreur dans login.js#keypress : ' + e);
  }

}

function affichPassword(){
        document.getElementById('login').collapsed=true;
        document.getElementById('logintexte').collapsed=true;
        document.getElementById('login').value="root";
        document.getElementById('login').disabled=true;
        document.getElementById('password').focus();
}

function affichTout(){
        document.getElementById('login').disabled=false;
        document.getElementById('login').collapsed=false;
        document.getElementById('logintexte').collapsed=false;
        document.getElementById('login').value="";
        document.getElementById('login').focus();
}

function opensiweb() {
  window.open('http://www.opensi.org');
}