/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {
		document.getElementById("titre").value = 'MODIFICATION DU DOSSIER "'+ ParamValeur("Dossier_Id") +'"';
		
		var paramlist = "&Page=Compta/GetRDF/liste_centre_impot.tmpl&ContentType=xml";
  	load_rdf('Centre_Impot', getUrlOpeneas(paramlist));
		
		var paramlist = "&Page=Compta/GetRDF/liste_tresorerie.tmpl&ContentType=xml";
  	load_rdf('Tresorerie', getUrlOpeneas(paramlist));
		
		initValues();
		
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/modifier_dossier.js#init : ' + e);
  }
}

var change_exo = 0;
var debut_exercice = '';

function initValues() {
	try {
	
		var corps = cookie() + "&Page=Manager/ChampsDossier.tmpl&ContentType=xml&Dossier_Id="+ ParamValeur("Dossier_Id");
    var p = requeteHTTP(corps);
    
    if (p.status != "200") {
      alert("Rception erreur " + p.status);
    } 
		else {
      var contenu = p.responseXML;
      var dossier = contenu.documentElement;
			
			document.getElementById('Raison_Sociale').value = dossier.getAttribute('raison_sociale');
			document.getElementById('Enseigne').value = dossier.getAttribute('enseigne');
			document.getElementById('Adresse').value = dossier.getAttribute('adresse');
			document.getElementById('Comp_Adresse').value = dossier.getAttribute('comp_adresse');
			document.getElementById('Code_Postal').value = dossier.getAttribute('code_postal');
			document.getElementById('Ville').value = dossier.getAttribute('ville');
			document.getElementById('Email').value = dossier.getAttribute('email');
			document.getElementById('Telephone').value = dossier.getAttribute('telephone');
			document.getElementById('Fax').value = dossier.getAttribute('fax');
			document.getElementById('Num_SIRET').value = dossier.getAttribute('num_siret');
			document.getElementById('Code_NAF').value = dossier.getAttribute('code_naf');
			document.getElementById('Type_Societe').value = dossier.getAttribute('type_societe');
			document.getElementById('Typologie').value = dossier.getAttribute('typologie');
			if (dossier.getAttribute('date_creation')!="0") {
				document.getElementById('Date_Creation').value = dossier.getAttribute('date_creation');
			}
			if (dossier.getAttribute('duree_societe')!="0") {
				document.getElementById('Duree_Societe').value = dossier.getAttribute('duree_societe');
			}
			if (dossier.getAttribute('montant_capital')!="0") {
				document.getElementById('Montant_Capital').value = dossier.getAttribute('montant_capital');
			}
			if (dossier.getAttribute('nb_parts')!="0") {
				document.getElementById('Nb_Parts').value = dossier.getAttribute('nb_parts');
			}			
			document.getElementById('Expert').value = dossier.getAttribute('expert');
			document.getElementById('Monnaie_Tenue').value = dossier.getAttribute('monnaie_tenue');
			document.getElementById('Regime_Fiscal').value = dossier.getAttribute('regime_fiscal');
			document.getElementById('Regime_Groupe').value = dossier.getAttribute('regime_groupe');
			document.getElementById('Centre_Impot').value = dossier.getAttribute('centre_impot');
			document.getElementById('Tresorerie').value = dossier.getAttribute('tresorerie');
			document.getElementById('Centre_Gestion').value = dossier.getAttribute('centre_gestion');
			document.getElementById('Site_Web').value = dossier.getAttribute('site_web');
			document.getElementById('Num_TVA_Intra').value = dossier.getAttribute('num_tva_intra');
			document.getElementById('Ville_RCS').value = dossier.getAttribute('ville_rcs');
			
			document.getElementById('Fin_Exercice').value = dossier.getAttribute('fin_exercice');
			
			change_exo = dossier.getAttribute('change_exo');
			debut_exercice = dossier.getAttribute('debut_exercice');
			
			if (change_exo==0) {			
				document.getElementById('Fin_Exercice').disabled = true;
			}

			if (document.getElementById("Regime_Fiscal").value == "IR") {
				document.getElementById("Regime_Fiscal").selectedItem = document.getElementById("Impot_Revenu");
			}
			else {
				document.getElementById("Regime_Fiscal").selectedItem = document.getElementById("Impot_Societe");
			}

			if (document.getElementById("Regime_Groupe").value == "y")
				document.getElementById("Regime_Groupe").selectedItem = document.getElementById("GroupeOui");
			else 
				document.getElementById("Regime_Groupe").selectedItem = document.getElementById("GroupeNon");
		}
	
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/modifier_dossier.js#initValues : ' + e);
  }
}


function modifierDossier() {
	try {
		var dossier = ParamValeur("Dossier_Id");
		var date_creation = document.getElementById('Date_Creation').value;
		var email = document.getElementById("Email").value;
		var fax = document.getElementById("Fax").value;
		var telephone = document.getElementById("Telephone").value;
		var code_postal = document.getElementById("Code_Postal").value;
		var num_siret = document.getElementById("Num_SIRET").value;
		var code_naf = document.getElementById("Code_NAF").value;
		var duree_societe = document.getElementById("Duree_Societe").value;
		var montant_capital = document.getElementById("Montant_Capital").value;
		var nb_parts = document.getElementById("Nb_Parts").value;
		var fin_exercice = document.getElementById("Fin_Exercice").value;

				 if (isEmpty(document.getElementById("Raison_Sociale").value)) { alert('Raison sociale manquante !'); return false; }
		else if (isEmpty(document.getElementById("Adresse").value)) { alert('Adresse manquante !'); return false; }
		else if (isEmpty(code_postal)) { alert('Code postal manquant !'); return false; }
		else if (isEmpty(document.getElementById("Ville").value)) { alert('Ville manquante !'); return false; }
		else if (isEmpty(num_siret)) { alert('Numro de SIRET manquant !'); return false; }
		else if (isEmpty(code_naf)) { alert('Code NAF manquant !'); return false; }
		//else if (isEmpty(montant_capital)) { alert('Montant du capital manquant !'); return false; }
		//else if (isEmpty(nb_parts)) { alert('Nombre de parts manquant !'); return false; }
		else if (isEmpty(document.getElementById("Monnaie_Tenue").value)) { alert('Monnaie de tenue manquante !'); return false; }
		else if (isEmpty(fin_exercice)) { alert('Date de fin d\'exercice manquante !'); return false; }

		else if (!isEmpty(date_creation) && !isDate(date_creation)) { alert('Date de cration incorrecte (format: jj/mm/aaaa)'); return false; }
		else if (code_postal.length !=5 || !isDigitList(code_postal)) { alert('Code postal incorrect !'); return false;}
		else if (!isEmpty(email) && !isEmail(email)) { alert('Adresse e-mail incorrecte !'); return false; }	
		else if (!isEmpty(fax) && !isPhone(fax)) { alert('Numro de fax incorrect !'); return false; }
		else if (!isEmpty(telephone) && !isPhone(telephone)) { alert('Numro de tlphone incorrect !'); return false; }
		else if (num_siret.length != 14 || !isDigitList(num_siret)) { alert('Numro de SIRET incorrect !'); return false; }
		else if (code_naf.length != 4 || !isDigitList(code_naf.substring(0,3)) || !isAlpha(code_naf.charAt(3))) { alert('Code NAF incorrect !'); return false; }
		else if (!isEmpty(duree_societe) && !isPositiveInteger(duree_societe)) { alert('Dure de socit incorrecte !'); return false; }
		else if (!isEmpty(montant_capital) && !isPositive(montant_capital)) { alert('Montant du capital incorrect'); return false; }
		else if (!isEmpty(nb_parts) && !isPositiveInteger(nb_parts)) { alert('Nombre de parts incorrect'); return false; }
		else if (!isDate(fin_exercice) || !isDateInterval(debut_exercice,fin_exercice)) { alert('Dates d\'exercices incorrectes ! (format: jj/mm/aaaa)'); }
		
		else {
			if (!isEmpty(date_creation))
				date_creation = prepareDateJava(date_creation);
				
			if (window.confirm('Confirmez-vous la modification du dossier "'+ dossier +'" ?')) {
				
				var infos_societe = "&Raison_Sociale=" + document.getElementById("Raison_Sociale").value;
				infos_societe += "&Enseigne=" + document.getElementById("Enseigne").value;
				infos_societe += "&Adresse=" + document.getElementById("Adresse").value;
				infos_societe += "&Comp_Adresse=" + document.getElementById("Comp_Adresse").value;
				infos_societe += "&Code_Postal=" + code_postal;
				infos_societe += "&Ville=" + document.getElementById("Ville").value;
				infos_societe += "&Email=" + email;
				infos_societe += "&Telephone=" + telephone;
				infos_societe += "&Fax=" + fax;
				infos_societe += "&Num_SIRET=" + num_siret;
				infos_societe += "&Code_NAF=" + code_naf;
				infos_societe += "&Type_Societe=" + document.getElementById("Type_Societe").value;
				infos_societe += "&Typologie=" + document.getElementById("Typologie").value;
				infos_societe += "&Date_Creation=" + date_creation;
				infos_societe += "&Duree_Societe=" + duree_societe;
				infos_societe += "&Montant_Capital=" + montant_capital;
				infos_societe += "&Nb_Parts=" + nb_parts;
				infos_societe += "&Expert=" + document.getElementById("Expert").value;
				infos_societe += "&Monnaie_Tenue=" + document.getElementById("Monnaie_Tenue").value;
				infos_societe += "&Regime_Fiscal=" + document.getElementById("Regime_Fiscal").value;
				infos_societe += "&Regime_Groupe=" + document.getElementById("Regime_Groupe").value;
				infos_societe += "&Centre_Impot=" + document.getElementById("Centre_Impot").value;
				infos_societe += "&Tresorerie=" + document.getElementById("Tresorerie").value;
				infos_societe += "&Centre_Gestion=" + document.getElementById("Centre_Gestion").value;
				infos_societe += "&Site_Web=" + document.getElementById("Site_Web").value;
				infos_societe += "&Num_TVA_Intra=" + document.getElementById("Num_TVA_Intra").value;
				infos_societe += "&Fin_Exercice=" + prepareDateJava(document.getElementById("Fin_Exercice").value);
				infos_societe += "&Change_Exo="+ change_exo;
				infos_societe += "&Ville_RCS="+ document.getElementById('Ville_RCS').value;
				
				var corps = cookie() + "&Page=Manager/ModifierDossier.tmpl&ContentType=text&Dossier_Id=" + dossier + infos_societe;
				var p = requeteHTTP(corps);

  			if ( p.status != "200" ) {
    			alert("Rception erreur " + p.status);
  			}
				else {
					alert(trim(p.responseText));
				}
				
				var page = "chrome://opensi/content/manager/gestion_dossiers/menu_dossiers.xul?" + cookie();
  			window.location = page;
			}
		}
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/modifier_dossier.js#modifierDossier : ' + e);
  }
}

function retour_menuManager() {
	try {
  	var page = "chrome://opensi/content/manager/menu_manager.xul?" + cookie();
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/modifier_dossier.js#retour_menuManager : ' + e);
  }
}

function retour_menuDossiers() {
	try {
  	var page = "chrome://opensi/content/manager/gestion_dossiers/menu_dossiers.xul?" + cookie();
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/modifier_dossier.js#retour_menuDossiers : ' + e);
  }
}
