/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {
		var paramlist = "&Page=Compta/GetRDF/RechercheDossier.tmpl&ContentType=xml";
  	load_rdf('liste_dossiers', getUrlOpeneas(paramlist));
  	document.getElementById('Dossier_Id').focus();
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/supprimer_dossier.js#init : ' + e);
  }
}

function supprimerDossier() {
	try {
		var dossier = document.getElementById("Dossier_Id").value; 
		document.getElementById("Dossier_Id").value = '';

		if (isEmpty(dossier))
			alert('Veuillez spcifier un nom de dossier !');
		else if (!isCleAlpha(dossier)) {
			alert('Nom de dossier incorrect !');
		}
		else if (!existeDossier(dossier)) {
			alert('Dossier inexistant !');
		}
		else if (window.confirm('Confirmez-vous la suppression du dossier "'+ dossier +'" ?\nAttention tous les exercices du dossier seront supprims !')) {
			var corps = cookie() + "&Page=Manager/SupprimerDossier.tmpl&ContentType=text&Dossier_Id=" + dossier;
			var p = requeteHTTP(corps);

  		if ( p.status != "200" ) {
    		alert("Rception erreur " + p.status);
  		}
			else {
				alert(trim(p.responseText));
			}
			delete_tree();
			init_tree();
		}
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/supprimer_dossier.js#supprimerDossier : ' + e);
  }
}

function existeDossier(dossier) {
	try {
  	var v = document.getElementById('liste_dossiers').view;
		var existe = false;
		var i = 0;

  	while (i<v.rowCount && !existe) {
    	existe = dossier.toUpperCase() == v.getCellText(i,'ColDossier_Id').toUpperCase();
			i++;
  	}
  	return existe;
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/choix_dossier_journaux.js#existeDossier : ' + e);
  }
}


function init_tree() {
  try {
    var paramlist = "&Page=Compta/GetRDF/RechercheDossier.tmpl&ContentType=xml";
    load_rdf("liste_dossiers", getUrlOpeneas(paramlist));
    document.getElementById("liste_dossiers").builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/supprimer_dossier.js#init_tree : ' + e);
  }
}

function delete_tree() {
  try {
    var database = document.getElementById("liste_dossiers").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/supprimer_dossier.js#delete_tree : ' + e);
  }
}

function reporter(tree) {
	try {
	
		if (tree.view!=null && tree.currentIndex!=-1) {
  		document.getElementById("Dossier_Id").value = tree.view.getCellText(tree.currentIndex, 'ColDossier_Id');
		}
		
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/supprimer_dossier.js#reporter : ' + e);
  }
}

function retour_menuManager() {
	try {
  	var page = "chrome://opensi/content/manager/menu_manager.xul?" + cookie();
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/supprimer_dossier.js#retour_menuManager : ' + e);
  }
}

function retour_menuDossiers() {
	try {
  	var page = "chrome://opensi/content/manager/gestion_dossiers/menu_dossiers.xul?" + cookie();
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_dossiers/supprimer_dossier.js#retour_menuDossiers : ' + e);
  }
}
