/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var dossier_journaux;
var base_journaux;

function init() {
	try {
		document.getElementById("titre").value = "GESTION DES DROITS DE L'UTILISATEUR '"+ ParamValeur('Login') +"'";
		
		var paramlist = "&Page=Compta/GetRDF/droits_utilisateur.tmpl&ContentType=xml&Login="+ ParamValeur('Login');
		load_rdf_async('liste_droits', getUrlOpeneas(paramlist), selDossier);
		
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#init : ' + e);
  }
}

function selDossier() {
	try {
		var v = document.getElementById('liste_droits');
		if (v!=null && v.view!=null) {
			v.view.selection.select(0);
			v.focus();
			setTimeout("init_droits_journaux()", 100);
		}
		else {
			document.getElementById('titre_droits_journaux').value = "Droits sur les journaux du dossier ''";
			document.getElementById("Dossier_Id").focus();
		}
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#selDossier : ' + e);
  }
}

function init_droits_journaux() {
	try {
		
		var v = document.getElementById('liste_droits').view;
		if (v!=null && v.selection.currentIndex!=-1) {
  		var dossier_id = v.getCellText(v.selection.currentIndex,'dossier_id');
			
			dossier_journaux = dossier_id;
			
			var corps = cookie() + "&Page=Compta/GetLastExercice.tmpl&ContentType=xml&Dossier_Id="+ dossier_id;
			var p = requeteHTTP(corps);

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				var contenu = p.responseXML;
				var lastexo = contenu.documentElement;

				var base = lastexo.getAttribute('nom_base');
				base_journaux = base;
			
				document.getElementById('titre_droits_journaux').value = "Droits sur les journaux du dossier '"+dossier_id+"'";
				delete_tree_journaux();
				init_tree_journaux(base, dossier_id);
			}
		}
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#init_droits_journaux : ' + e);
  }
}

function changerDroits() {
	try {
		var v = document.getElementById('liste_journaux').view;
		if (v!=null && v.selection.currentIndex!=-1) {
  		var code_journal = v.getCellText(v.selection.currentIndex,'code_journal');
			var corps = cookie() + "&Page=Manager/ChangerDroitsJournaux.tmpl&ContentType=text&Code_Journal="+ code_journal +"&Login="+ ParamValeur('Login') +"&Dossier_Id="+ dossier_journaux;
			var p = requeteHTTP(corps);

  		if ( p.status != "200" ) {
    		alert("Rception erreur " + p.status);
  		}
			
			delete_tree_journaux();
			init_tree_journaux(base_journaux, dossier_journaux);
		}
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#changerDroits : ' + e);
  }
}

function affecterDroits() {
	try {
  	var dossier_id = document.getElementById('Dossier_Id').value;
		document.getElementById('Dossier_Id').value = '';

		if (isEmpty(dossier_id)) {
			alert('Veuillez spcifier un nom de dossier !');
		}
		else if (!isCleAlpha(dossier_id)) {
			alert('Nom de dossier incorrect !');
		}
		else {
		
			var corps = cookie() + "&Page=Compta/GetLastExercice.tmpl&ContentType=xml&Dossier_Id="+ dossier_id;
			var p = requeteHTTP(corps);

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				var contenu = p.responseXML;
				var lastexo = contenu.documentElement;
				var base = lastexo.getAttribute('nom_base');
		
				var corps = cookie() + "&Page=Manager/AffecterDroits.tmpl&ContentType=text&Login="+ ParamValeur('Login') +"&Dossier_Id="+ dossier_id +"&Base="+ base;
				var p = requeteHTTP(corps);

  			if ( p.status != "200" ) {
    			alert("Rception erreur " + p.status);
  			}
				else if (trim(p.responseText)!="noerror") {
					alert(trim(p.responseText));
				}
				delete_tree();
				init_tree();
			}
		}
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#affecterDroits : ' + e);
  }
}

function supprimerDroits() {
	try {
		var v = document.getElementById('liste_droits').view;
		if (v!=null && v.selection.currentIndex!=-1) {
  		var dossier_id = v.getCellText(v.selection.currentIndex,'dossier_id');

			if (isEmpty(dossier_id)) {
				alert('Aucun dossier slectionn !');
			}
			else {
				var corps = cookie() + "&Page=Manager/SupprimerDroits.tmpl&ContentType=text&Login=" + ParamValeur('Login') + "&Dossier_Id=" + dossier_id;
				var p = requeteHTTP(corps);

  			if ( p.status != "200" ) {
    			alert("Rception erreur " + p.status);
  			}
				delete_tree();
				init_tree();
				v = document.getElementById('liste_droits').view;
				if (v!=null) {
					init_droits_journaux();
				}
				else {
					delete_tree_journaux();
					document.getElementById("liste_journaux").builder.rebuild();
					document.getElementById('titre_droits_journaux').value = "Droits sur les journaux du dossier ''";
				}
			}
		}
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#supprimerDroits : ' + e);
  }
}


function keypress_dossier(e) {  
  try {  
    switch (e.keyCode) {
      case 13: affecterDroits(); break;
    }
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#keypress_dossier : ' + e);
  }
}

function keypress_droit_dossier(e) {  
  try {  
    switch (e.keyCode) {
      case 13: init_droits_journaux(); break;
    }
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#keypress_droit_dossier : ' + e);
  }
}

function keypress_droit_journaux(e) {  
  try {  
    switch (e.keyCode) {
      case 13: changerDroits(); break;
    }
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#keypress_droit_journaux : ' + e);
  }
}


function init_tree_journaux(base, dossier_id) {
  try {		
    var paramlist = "&Page=Compta/GetRDF/liste_droits_journaux.tmpl&ContentType=xml&Base="+base+"&Dossier_Id="+dossier_id+"&Login="+ ParamValeur('Login');
    load_rdf("liste_journaux", getUrlOpeneas(paramlist));		
    document.getElementById("liste_journaux").builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#init_tree_journaux : ' + e);
  }
}

function delete_tree_journaux() {
  try {
    var database = document.getElementById("liste_journaux").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#delete_tree_journaux : ' + e);
  }
}

function init_tree() {
  try {
    var paramlist = "&Page=Compta/GetRDF/droits_utilisateur.tmpl&ContentType=xml&Login="+ ParamValeur('Login');
    load_rdf_async("liste_droits", getUrlOpeneas(paramlist), selDossier);
    document.getElementById("liste_droits").builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#init_tree : ' + e);
  }
}

function delete_tree() {
  try {
    var database = document.getElementById("liste_droits").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#delete_tree : ' + e);
  }
}


function rechercherDossier() {
	try {
		var url = "chrome://opensi/content/manager/gestion_utilisateurs/rech_dossier.xul?" + cookie();
    window.openDialog(url,'rechdossier','chrome,modal','Dossier_Id');
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#rechercheDossier : ' + e);
  }
}

function retour_menuManager() {
	try {
  	var page = "chrome://opensi/content/manager/menu_manager.xul?" + cookie();
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#retour_menuManager : ' + e);
  }
}

function retour_menuUtilisateurs() {
	try {
  	var page = "chrome://opensi/content/manager/gestion_utilisateurs/menu_utilisateurs.xul?" + cookie();
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/gestion_utilisateurs/modifier_user.js#retour_menuUtilisateurs : ' + e);
  }
}
