/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/manager/choix_dossier_journaux.xul>
 * @include chrome://opensi/content/util.js
 *
 */

var base;
var dossier;

function init() {
	try {
		dossier = ParamValeur("Dossier_Id");
		document.getElementById("titre").value = 'JOURNAUX DU DOSSIER "'+ dossier +'"';
	
		var corps = cookie() + "&Page=Manager/GetBase.tmpl&ContentType=xml&Dossier_Id="+ dossier;		
    var p = requeteHTTP(corps);
    
    if (p.status != "200") {
      alert("Rception erreur " + p.status);
    } 
		else {
      var contenu = p.responseXML;
			base = contenu.documentElement.getAttribute('nom');

			var paramlist = "&Page=Compta/GetRDF/liste_journaux_manager.tmpl&ContentType=xml&Base="+ base;
  		load_rdf('liste_journaux_manager', getUrlOpeneas(paramlist));
			
		}
  	document.getElementById('Code_Journal').focus();
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#init : ' + e);
  }
}

function enableContrepartie() {
	try {
		var type_journal = document.getElementById("Type_Journal").value;
		
		if (type_journal=='TR') {
			document.getElementById("libContre_Partie").collapsed = false;
			document.getElementById("boxContre_Partie").collapsed = false;
		}
		else {
			document.getElementById("libContre_Partie").collapsed = true;
			document.getElementById("boxContre_Partie").collapsed = true;
		}
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#enableContrepartie : ' + e);
  }
}

function modifierJournal() {
	try {
		var code_journal = document.getElementById('Code_Journal').value;
		var contre_partie = '';
		var libelle = document.getElementById('Libelle').value;
		var type_journal = document.getElementById('Type_Journal').value;
		
		if (type_journal=='TR') {
			contre_partie = document.getElementById('Contre_Partie').value;
		}
		
		if (isEmpty(libelle)) {
			alert('Le champ Libelle est obligatoire !');
		}
		else if (!isEmpty(contre_partie) && !isCompteCorrect(contre_partie)) {
			alert('Numero de compte de contrepartie incorrect !');
		}
		else if (window.confirm('Confirmez-vous la modification du journal "'+ code_journal +'" ?')) {		
			var corps = cookie() + "&Page=Manager/ModifierJournal.tmpl&ContentType=text&Dossier_Id="+ dossier;
			corps += "&Code_Journal="+ code_journal +"&Contre_Partie="+ contre_partie +"&Libelle="+ libelle +"&Type_Journal="+ type_journal;
			var p = requeteHTTP(corps);

  		if ( p.status != "200" ) {
    		alert("Rception erreur " + p.status);
  		}
			else {
				alert(trim(p.responseText));
			}
			delete_tree();
			init_tree();
		}
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#modifierJournal : ' + e);
  }
}

function nouveauJournal() {
	try {
		document.getElementById('clj').collapsed = false;
		document.getElementById('msn').collapsed = true;
		document.getElementById('Code_Journal').disabled = false;
		document.getElementById('Code_Journal').value = '';
		document.getElementById('Type_Journal').value = 'TR';
		document.getElementById('Libelle').value = '';
		document.getElementById('Contre_Partie').value = '';
		document.getElementById("libContre_Partie").collapsed = false;
		document.getElementById("boxContre_Partie").collapsed = false;
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#nouveauJournal : ' + e);
  }
}

function supprimerJournal() {
	try {
		var code_journal = document.getElementById('Code_Journal').value;
		
		if (window.confirm('Confirmez-vous la suppression du journal "'+ code_journal +'" ?')) {			
			var corps = cookie() + "&Page=Manager/SupprimerJournal.tmpl&ContentType=text&Dossier_Id="+ dossier +"&Code_Journal="+ code_journal;
			var p = requeteHTTP(corps);

  		if ( p.status != "200" ) {
    		alert("Rception erreur " + p.status);
  		}
			else {
				alert(trim(p.responseText));
			}
			nouveauJournal();
			delete_tree();
			init_tree();
		}
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#supprimerJournal : ' + e);
  }
}

function creerJournal() {
	try {
		var code_journal = document.getElementById('Code_Journal').value;
		var contre_partie = '';
		var libelle = document.getElementById('Libelle').value;
		var type_journal = document.getElementById('Type_Journal').value;
	
		if (type_journal=='TR') {
			contre_partie = document.getElementById('Contre_Partie').value;
		}
	
		if (isEmpty(code_journal) || isEmpty(libelle)) {
			alert('Les champs Code journal et Libelle sont obligatoires !');
		}
		else if (!isAlpha(code_journal)) {
			alert('Code journal incorrect !');
		}
		else if (!isEmpty(contre_partie) && !isCompteCorrect(contre_partie)) {
			alert('Numero de compte de contrepartie incorrect !');
		}
		else if (window.confirm('Confirmez-vous la cration du journal "'+ code_journal +'" ?')) {
			var corps = cookie() + "&Page=Manager/CreerJournal.tmpl&ContentType=text&Dossier_Id="+ dossier;
			corps += "&Code_Journal="+ code_journal +"&Contre_Partie="+ contre_partie +"&Libelle="+ libelle +"&Type_Journal="+ type_journal;
			var p = requeteHTTP(corps);

  		if ( p.status != "200" ) {
    		alert("Rception erreur " + p.status);
  		}
			else {
				alert(trim(p.responseText));
			}
			document.getElementById('clj').collapsed = true;
			document.getElementById('msn').collapsed = false;
			document.getElementById('Code_Journal').disabled = true;
			delete_tree();
			init_tree();
		}
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#creerJournal : ' + e);
  }
}


function ouvrirJournal() {
	try {
		
		var tree = document.getElementById('liste_journaux_manager');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
		
			document.getElementById('clj').collapsed = true;
			document.getElementById('msn').collapsed = false;
			document.getElementById('Code_Journal').disabled = true;

  		var code_journal = tree.view.getCellText(tree.currentIndex, 'code');

			var corps = "Page=Manager/ChampsJournal.tmpl&ContentType=xml&Base="+ base +"&Code_Journal="+ code_journal;		
    	var p = requeteHTTP(corps);

    	if (p.status != "200") {
      	alert("Rception erreur " + p.status);
    	} 
			else {
      	var contenu = p.responseXML;
				journal = contenu.documentElement;

				document.getElementById('Code_Journal').value = journal.getAttribute('code_journal');
				document.getElementById('Type_Journal').value = journal.getAttribute('type_journal');
				document.getElementById('Libelle').value = journal.getAttribute('libelle');
				var type_journal = document.getElementById('Type_Journal').value;

				if (type_journal=='TR') {
					document.getElementById('libContre_Partie').collapsed = false;
					document.getElementById('boxContre_Partie').collapsed = false;
					document.getElementById('Contre_Partie').value = journal.getAttribute('contre_partie');
				}
				else {
					document.getElementById('libContre_Partie').collapsed = true;
					document.getElementById('boxContre_Partie').collapsed = true;
				}
			}
		}
		
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#ouvrirJournal : ' + e);
  }
}

function init_tree() {
  try {
    var paramlist = "&Page=Compta/GetRDF/liste_journaux_manager.tmpl&ContentType=xml&Base="+ base;
    load_rdf("liste_journaux_manager", getUrlOpeneas(paramlist));
    document.getElementById("liste_journaux_manager").builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#init_tree : ' + e);
  }
}

function delete_tree() {
  try {
    var database = document.getElementById("liste_journaux_manager").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#delete_tree : ' + e);
  }
}

function keypress(e) {
	try {
		switch (e.keyCode) {
      case 13: ouvrirJournal(); break;
    }
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#keypress : ' + e);
  }
}

function retour_menuManager() {
	try {
  	var page = "chrome://opensi/content/manager/menu_manager.xul?" + cookie() ;
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/gestion_journaux.js#retour_menuManager : ' + e);
  }
}
