/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/manager/choix_dossier_plan.xul>
 * @include chrome://opensi/content/util.js
 *
 */


/*****************************************************
 *  @return l'id de l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree_id(){
  return 'liste_taux';
}

/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree(){
  try {
    return document.getElementById(get_tree_id());
  } catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#get_tree : ' + e);
  }
}

function init() {
	try {
		
		init_tree();
  
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#init : ' + e);
  }
}

function reporter() {
  try {
    var v = get_tree().view;
    if (v == null) {
      nouvelleTVA();
    } else if (v.rowCount <= 0) {
      nouvelleTVA();
    }else {
      document.getElementById('Taux_TVA').value = v.getCellText(v.selection.currentIndex,'ColMode');
      document.getElementById('cptHT').value = v.getCellText(v.selection.currentIndex,'ColCptHT');
      document.getElementById('cptTVA').value = v.getCellText(v.selection.currentIndex,'ColCptTVA');
		  document.getElementById('clc').collapsed = true;
		  document.getElementById('msn').collapsed = false;
    }
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#reporter : ' + e);
  }
}

function reinit_tree() {
	try {
		delete_tree();
		init_tree();
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#reinit_tree : ' + e);
  }
}

function init_tree() {
  try {
    var paramlist = "&Page=Manager/GetRDF/taux_tva.tmpl&ContentType=xml";
    load_rdf(get_tree_id(), getUrlOpeneas(paramlist));
    get_tree().builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#init_tree : ' + e);
  }
}

function delete_tree() {
  try {
    var database = get_tree().database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#delete_tree : ' + e);
  }
}

function keypress(e) {
	try {
		switch (e.keyCode) {
      case 13: ouvrirCompte(); break;
    }
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#keypress : ' + e);
  }
}

function nouvelleTVA() {
	try {
		document.getElementById('clc').collapsed = false;
		document.getElementById('msn').collapsed = true;
		document.getElementById('Taux_TVA').value = '';
		document.getElementById('cptTVA').value = '';
		document.getElementById('cptHT').value = '';
		document.getElementById('Taux_TVA').focus();
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#nouvelleTVA : ' + e);
  }
}

function supprimerTVA() {
	try {
		var tree = get_tree();
		if (tree.contentView!=null && tree.currentIndex!=-1) {
			var selection = tree.contentView.getItemAtIndex(tree.currentIndex);
			var code_tva = selection.firstChild.firstChild.getAttribute('value');
			var taux_tva = selection.firstChild.firstChild.getAttribute('label');
			if (code_tva=="1") {
				showWarning("Le taux de TVA '0.00 %' ne peut pas tre supprim !");
			}
			else if (code_tva=="4") {
				showWarning("Le taux de TVA '"+ taux_tva +" %' ne peut pas tre supprim !");
			}
			else {
				if (window.confirm("Confirmez-vous la suppression du taux de TVA de "+ taux_tva +" % ?")) {		
					var corps = cookie() + "&Page=Manager/Parametrage/supprimerTVA.tmpl&ContentType=text&Code_TVA="+ code_tva;
          var httpRequest = new XMLHttpRequest();
          requeteHTTP(corps,httpRequest,supprimerTVA2);
        }
      }
    }
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#supprimerTVA : ' + e);
  }
}

function supprimerTVA2(httpRequest) {
	try {
    if (httpRequest.status != "200") {
      alert("Rception erreur " + httpRequest.status);
  	}	else {
			var msg = trim(httpRequest.responseText);
			if (msg!="") {					
        showWarning(msg);
      }
			reinit_tree();
    }
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#supprimerTVA2 : ' + e);
  }
}


function creerTVA() {
	try {
		var taux_tva = document.getElementById('Taux_TVA').value;
		var compte_ht = document.getElementById('cptHT').value;
		var compte_tva = document.getElementById('cptTVA').value;

		if (isEmpty(taux_tva) || !isPositiveOrNull(taux_tva)) {
			alert("Taux de TVA incorrect !");
		} else {
			var corps = cookie() + "&Page=Manager/Parametrage/creerTVA.tmpl&ContentType=text";
      corps += "&Taux_TVA="+ urlEncode(taux_tva);
      corps += "&Compte_TVA="+ urlEncode(compte_tva);
      corps += "&Compte_HT="+ urlEncode(compte_ht);
      var httpRequest = new XMLHttpRequest();
      requeteHTTP(corps,httpRequest,creerTVA2);
    }
  } catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#creerTVA : ' + e);
  }
}

function creerTVA2(httpRequest) {
  try {
    if (httpRequest.status != "200") {
      alert("Rception erreur " + httpRequest.status);
  	}	else {			
			reinit_tree();
  	}		
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#creerTVA2 : ' + e);
  }
}

function modifierTVA() {
	try {
		var tree = get_tree();
		if (tree.contentView!=null && tree.currentIndex!=-1) {
			var selection = tree.contentView.getItemAtIndex(tree.currentIndex);
			var code_tva = selection.firstChild.firstChild.getAttribute('value');
		  var taux_tva = document.getElementById('Taux_TVA').value;
			var compte_ht = document.getElementById('cptHT').value;
	  	var compte_tva = document.getElementById('cptTVA').value;

      if (isEmpty(taux_tva) || !isPositiveOrNull(taux_tva)) {
			  alert("Taux de TVA incorrect !");
		  } else {
			  var corps = cookie() + "&Page=Manager/Parametrage/modifierTVA.tmpl&ContentType=text";
        corps += "&Taux_TVA="+ urlEncode(taux_tva);
        corps += "&Compte_TVA="+ urlEncode(compte_tva);
        corps += "&Compte_HT="+ urlEncode(compte_ht);
        corps += "&Code_TVA="+ urlEncode(code_tva);
        var httpRequest = new XMLHttpRequest();
        requeteHTTP(corps,httpRequest,modifierTVA2);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#modifierTVA : ' + e);
  }
}

function modifierTVA2(httpRequest) {
  try {
    if (httpRequest.status != "200") {
      alert("Rception erreur " + httpRequest.status);
  	}	else {			
			reinit_tree();
  	}		
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/taux_tva.js#modifierTVA2 : ' + e);
  }
}
